#pragma once

enum L2ExtLogType
{
	FULL_LOG=0,
	FILE_LOG=1,
	CONSOLE_LOG=2
};

class CL2ExtLog
{
public:
	static CL2ExtLog* Instance()
	{
		static CL2ExtLog l2ExtLog;
		return &l2ExtLog;
	}
	void Init();
	void Add(L2ExtLogType logType, const char *format, ...);
private:
	CRITICAL_SECTION m_criticalSection;
	HANDLE m_logConsole, m_logFile;
	CL2ExtLog();
	~CL2ExtLog();
};

#define LOG CL2ExtLog::Instance() 