//#pragma once
/* 
 * Lineage II Extension Project - Affectionately known as the L2EP 'Elhaym' Project/DLL
 * Property of Michael Sadlon a.k.a. mcrabben7 [mcrabben7@gmail.com]
 * Team Effort along with RipperX, Annatar, Nevyn, and with some help from others.
 * 
 * The goals of this project are to expand the aging Lineage II Chronicle 1 server
 * to support the functionality in C3 and C4, and is made to work with the C4 client.
 * 
 * This project is open-source.  It is released from time to time by our discretion.
 * Anyone who has this code, or this DLL, and chooses to use it or learn from it frees
 * us from ALL liabilities.  USE AT YOUR OWN RISK.
 * 
 * I have chosen to release this (you can read the license in License.txt) with the caveat
 * that you may NOT sell our work, any derivative of our work, or make a profit in any way
 * related to our work or a derivative of our work WITHOUT OUR EXPRESS PERMISSION.
 * 
 * Please see License.txt for the full details.  Make sure you READ it!
 */


#include "CorrundCommon.h"
#include "CSharedData.h"
//#include <excpt.h>
#include <eh.h>

#include "L2ExtLog.h"

//#ifndef _CRT_SECURE_NO_WARNINGS
//	#define _CRT_SECURE_NO_WARNINGS 1
//#endif


#ifndef _L2SERVER_
	#define _L2SERVER_
#endif

//General includes
#ifndef _WINDOWS_
	#include <windows.h>
	
#endif



DWORD GetParameter(DWORD * pData, DWORD byteOffset);
BYTE GetParameter8(DWORD * pData, DWORD byteOffset);

//-----------------------------------------------------
//special items - send to client fake item id to see it
//specials items are 7600 and 7601
static int SPEC_ITEM_ADD=16167; //tarot for lucky game 23767
static int SPEC_ITEM1=0; //weapons
static int SPEC_ITEM2=0; //weapons

//static int SPEC_ITEM_ADD=37774; //laser weapon
//static int SPEC_ITEM1=45374; //laser weapon
//static int SPEC_ITEM2=45381; //plasma weapon

static int armour_glow=6;


//---------------------------------------------
// CLASSIC PARAMETERS
static int LINEAGE2_CLASSIC = 19;


static int SETUPGAUGE_0 = 1; 
static int SETUPGAUGE_1 = 0; 
static int CLIENT_Z_SHIFT=16; //no good effect :(
//http://www.scadacore.com/field-applications/programming-calculators/online-hex-converter

static int MAX_STRING_CHAT=96; 
static int MAX_STRING_CHAT2=196; 
static int MAX_STRING_NAME=17; 

static BYTE L2_SKILLS_VERSION=2; //skills chronicle
static BYTE L2_SKILLS_DEFENDER=1; //defender skill 
static BYTE DUMP_PACKETS=0;
static	BYTE SERVER_TEST=0; //1 = test mode. every version testing different things

static  WORD PROTOCOL_VERSION=1;
static  DWORD SERVERPORT=2002;

//***************************
// test server stuff
//***************************
//static int SERVER_RATES_MULTIPLY_ADENA = 10; //, set it to 1 for original
//static int SERVER_RATES_MULTIPLY_EXP=10; //, set it to 1 for original
//static int SERVER_RATES_MULTIPLY_SP=10; //, set it to 1 for original
//static int SERVER_RATES_MULTIPLY_DROP1 = 10; //not implemented yet, set it to 1 for original
//static int GM_LEVEL_4_ALL=2; //set it to 0 for no feature, 2 means that all player become GMs level 2


//***************************
// real server stuff
//***************************
static int SERVER_RATES_MULTIPLY_ADENA = 1; //, set it to 1 for original
static int SERVER_RATES_MULTIPLY_EXP=1; //, set it to 1 for original
static int SERVER_RATES_MULTIPLY_SP=1; //, set it to 1 for original
static int SERVER_RATES_MULTIPLY_DROP1 = 1; //not implemented yet, set it to 1 for original
static int GM_LEVEL_4_ALL=0; //set it to 0 for no feature
static int MARRIAGE_ITEM=8701; //marriage/vedding ring



static  int OFFLINE_PARAMETER=100001;
static  int BLESSENCHANT_PARAMETER=300003;
static  int DEADLOG_PARAMETER=400004;
static  DWORD ADENA_ITEMID=57; //adena
static  DWORD COIN_ITEMID=4037; //coin of luck
static  DWORD OFFLINE_ITEMCOUNT=0;

static  DWORD SIEGE_NO_WYVERN=0;

static	BYTE DEADTALK=1; //1 = can talk
static	BYTE SHOUTLEVEL=1;
static	BYTE GLOBALTALK=0; //0 = no 1= gracia one (battlefield?) 2= global trade
static	BYTE MARAUDEERS=0; //1 = allow see dead items 2= allow maraud
static	BYTE DISABLE_CP=0;  //disable combat points
static	BYTE FAKEDEATH_SUCCESS=95;  //95% of success
//used here by default static	BYTE EnableASS=0; //enable auto soulshots
static	BYTE ALLGOODTARGETS=0;

static	BYTE DISABLE_RIDE=0; 
static	BYTE DISABLE_RIDE_ARMED=0;
//static	BYTE DISABLE_AUTOSS=0; 
static	BYTE DISABLE_PARTYBUFF=1;
static	BYTE DISABLE_FASTLOGIN=0;
static	BYTE DISABLE_GM_SUMMON=0;
static	BYTE C1_PARTY_EXP=1;


//used here by default static	BYTE USERCOMMANDS=0;
static	BYTE USEPATCH2DLL=1; //use sockets.dll, patch2.dll 


static	BYTE FIXPETITIONCRASH=1; 
static	BYTE pLuckCrashFixBy_Fyyre=1;

static	WORD MAX_SELL_ITEMS=900;
static	WORD MAX_BUY_ITEMS=900;
static	WORD MAX_OP_ITEMS_DELTA=2000;
static  DWORD AFTER_TELEPORT_TICKMAX=7000; //7sec
static  DWORD AFTER_DEATH_TICKMAX=3*60*60000; //3hours
//The resolution of the GetTickCount function is limited to the resolution of the system timer, 
//which is typically in the range of 10 milliseconds to 16 milliseconds. 
//The resolution of the GetTickCount function is also affected by adjustments made 
//by the GetSystemTimeAdjustment function.


static BYTE PLEDGE_MAX_MEMBERS_L0 = 10; //PLEDGE_MAX_MEMBERS_L0 10
static BYTE PLEDGE_MAX_MEMBERS_L1 = 15; //PLEDGE_MAX_MEMBERS_L1 15
static BYTE PLEDGE_MAX_MEMBERS_L2 = 20; //PLEDGE_MAX_MEMBERS_L2 20
static BYTE PLEDGE_MAX_MEMBERS_L3 = 25; //PLEDGE_MAX_MEMBERS_L3 25 (c3=30)
static BYTE PLEDGE_MAX_MEMBERS_L4 = 30; //PLEDGE_MAX_MEMBERS_L4 30 (c3=40)
static BYTE PLEDGE_MAX_MEMBERS_L5 = 40; //PLEDGE_MAX_MEMBERS_L5 40 (c3=50)
static BYTE ALLIANCE_MAX_CLANS = 3; //ALLIANCE_MAX_CLANS 5 (c3=12) 

static BYTE PLEDGE_WAR_MIN_MEMBERS = 1; //c1=5  c4=15
static BYTE PLEDGE_WAR_MIN_LEVEL = 0; //3
static BYTE PLEDGE_REDUCED_TIMEOUTS = 0; //3
static BYTE INCREASEPLEDGE=1;
static int PLEDGE_SIEGE_LEVEL=4;


static int PLEDGE_TITLE_LEVEL=3;

//privilegies
static	int	PLEDGE_JOIN = 2;
static	int	PLEDGE_PRIVS_WIEW = 4;
static	int PLEDGE_WH_WITHDRAW = 8;
static	int PLEDGE_DOORS = 16;
static	int	PLEDGE_TITLE = 32;


static BYTE PLAYER_PENALTY_LEVEL = 5; //PLAYER_PENALTY_LEVEL (c1=5, c6=10)
static BYTE MAX_PLAYER_LEVEL=75; //original c1 max level



//safe enchants
static BYTE ENCHANT_SAFE_WEAPON = 3; //ENCHANT_SAFE_WEAPON 3
static BYTE ENCHANT_SAFE_STAFF = 3; //ENCHANT_SAFE_STAFF 3
static BYTE ENCHANT_SAFE_ARMOR = 3; //ENCHANT_SAFE_ARMOR 4
static int ENCHANT_SAFE_ARMOR_ = 3; //ENCHANT_SAFE_ARMOR 4
//static BYTE GM_SAFE_ENCHANTS = 0; 




static DWORD PLEDGE_WAR_TIMEOUT = 1; //*24*60*60; //PLEDGE_WAR_TIMEOUT
static DWORD PLEDGE_OUST_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_OUST_PENALTY_TIMEOUT
static DWORD PLEDGE_WITHDRAW_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_WITHDRAW_PENALTY_TIMEOUT
static DWORD PLEDGE_OUSTED_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_OUSTED_PENALTY_TIMEOUT
static DWORD PLEDGE_RECHALLENGE_PENALTY_TIMEOUT = 5; //5; //*24*60*60; //PLEDGE_RECHALLENGE_PENALTY_TIMEOUT
static DWORD PLEDGE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT = 5; //5; //*24*60*60; //PLEDGE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT
static DWORD PLEDGE_DISMISS_TIMEOUT = 7; //*24*60*60; //PLEDGE_DISMISS_TIMEOUT
static DWORD PLEDGE_DISMISS_PENALTY_TIMEOUT = 10; //*24*60*60; //PLEDGE_DISMISS_PENALTY_TIMEOUT
static DWORD ALLIANCE_DISMISS_TIMEOUT = 7; //*24*60*60; //UNKNOWN_TIMEOUT???
static DWORD ALLIANCE_OUST_PENALTY_TIMEOUT = 1; //*24*60*60; //ALLIANCE_OUST_PENALTY_TIMEOUT
static DWORD ALLIANCE_WITHDRAW_PENALTY_TIMEOUT = 1; //*24*60*60; //ALLIANCE_WITHDRAW_PENALTY_TIMEOUT
static DWORD ALLIANCE_OUSTED_PENALTY_TIMEOUT = 1; //*24*60*60; //ALLIANCE_OUSTED_PENALTY_TIMEOUT
static DWORD ALLIANCE_DISMISS_PENALTY_TIMEOUT = 10; //*24*60*60; //ALLIANCE_DISMISS_PENALTY_TIMEOUT
static DWORD ALLIANCE_RECHALLENGE_PENALTY_TIMEOUT = 5; //*24*60*60; //ALLIANCE_RECHALLENGE_PENALTY_TIMEOUT
static DWORD ALLIANCE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT = 5; //*24*60*60; //ALLIANCE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT
static DWORD CASTLE_ANNOUNCE_TIME = 10*24*60*60; //1* CASTLE_ANNOUNCE_TIME
static DWORD CASTLE_STANDBY_TIME = 1*24*60*60; //CASTLE_STANDBY_TIME

static int PC_IPDisconect=0;
static int GM_IPDisconect=0; //check it every time ??


//static DWORD DEAD_LOCK1x = 0xEA60;
static DWORD DEAD_LOCK2x = 0x1D4C0;
static DWORD DEAD_LOCK3x = 0x2BF20;

//max items, npc
static int MAX_ITEMS = 25000;  //original 10000
static int MAX_NPCS = 1019000; //original 1015000
static int MIN_NPCS = 1010000; //original 1010000
static int MAX_PACKET_LEN = 0x4000; //original 0x2000 = 8kbytes
static BYTE MAX_CHILD_DOORS = 4; //original 4
static int MAX_KARMA = 0x30000000;
static BYTE INTERVAL_MSG_MAX = 5; //original 5

//--------------------------------------------------------------------------------------------
//// DOMINION WARS Variables
//--------------------------------------------------------------------------------------------
static int DOMWARS1 = 257; //dominion wars of gludio-oren (1-4)
//structure of variable: 257
// 00000001 - 00000001
// for dion   for gludio
//= dion vs gludio
//#define 
static int DOMWARS2 = 0; //dominion wars of aden-rune (5-8)
static int racialwARS1 = 0; //dominion wars of human, elf, darkelf, orc (0-3)
static int racialwARS2 = 0; //dominion wars of dwarfs, kamaels, arthreas
static BYTE DOMWARS=1; //inicialization flag  0 - domwars disabled, 1 - need inicialize, 2 - ready
static BYTE racialwARS=1;
static BYTE domw[9][9];
static BYTE racialw[9][9];
static WORD dombadge[9];
static WORD mercbadge[9];
static int cloth_fragment_dom=10867;
//-------------------------------------------------------------


struct FVector
{
	double x;
	double y;
	double z;
};

//typedef FVector *pFVector;



static BYTE JMP_HOOK = 0xE9;
static const wchar_t * EMPTY_WCHAR = L"";
static const wchar_t * LOGIN_MSG = L"Lineage2 classic C1 server";
static int mrZero = 0;
static int DumpSize = 0x100;
static int CLIENT_PING = 0xA8;

static int lvl_76_max =1100150000;
static int lvl_76_c4=931275828;
static int lvl_77_c4=1151275834;
static int lvl_78_c4=1511275834;
static int lvl_79_c4=2099275834;
static int lvl_80_c4=4200000000;

//static int lvl_76_c1=931275828;
//static int lvl_77_c1=1108571463;
//static int lvl_78_c1=1309482881;
//static int lvl_79_c1=1535687304;
//static int lvl_80_c1=1788937098;


//---------
//helmets
//---------
static int HELMET_RIDE = 0; 
static int HELMET_N_WEDDING1 = 8223; //----original
static int HELMET_N_WEDDING = 6408; 

static int HELMET_DRAGON1 = 8252; //7449; // valakas
static int HELMET_DRAGON2 = 8251; // antaras


//cursed
static int cZariche = 8190;
static int cAkamanah = 8689;
static BYTE cChances = 1; //1 out of 100
static DWORD cLifetime = 43200; //lifetime of cursed 4 real hours and full 24h day in l2
static const int cNumber = 6666;
static	int	rgiState[2+55]; //random generation 

//packet flood
static int floodOP[256];
static int floodACTION[256];
static int floodTIMEOUT = 10; //100;

//pets
static int PET_WOLF_A=1012077;  

static int PET_GREAT_WOLF=1012025; //1016025; 
static int PET_GREAT_WOLF_COLAR=9882; 
static int PET_RIDE_WOLF=1016030; 
static int PET_RIDE_WOLFA=1016037; 
static int PET_RIDE_WOLFB=1016041; 
static int PET_RIDE_WOLFC=1016042; 

static int PET_RIDE_LION_COLLAR=13547; //ct2.2 10312; 
static int PET_RIDE_LION=1013146; 
static int PET_RIDE_HORSE_STRAPS=13022; 
static int PET_RIDE_HORSE=1013130; 
static int PET_RIDE_STEAM_HANDLE=13546; //ct2.2 10311; 
static int PET_RIDE_STEAM=1013147; 

static int PET_KNIGHT_HONOR=14061; //ct2.2 10313; 
static int PET_KNIGHT=1016052; //ct2.2 1012052; 


static int PET_RIDE_STRIDERR=1012038; 
static int PET_RIDE_STRIDER=1012528; 
static int PET_RIDE_WYVERN=1012621; 

static int PET_RIDE_STRIDER_WIND=1012526; 
static int PET_RIDE_STRIDER_STAR=1012527; 


static int AGAHTION=16027;
//static int DOMINION_MASTER=1008031; //npc ID which is master of territories // broadcasting tower
static int CRAZY_FARMER=1000953; //npc ID which is for Crazy gardener Event


//augmetation
static int aRhand = 0x397e0b0d; //blue with lighting, stars, glowing
static int aLhand = 0x397e12e9; //blue with stars, glowing
static int aDisplay = 0x3f6c3f6d; //0x3f6d3f6c; //NO GLOW "Acrive:Inflicts flaming attack"; "Acrive:Inflicts water-type attack"


const wchar_t unknName[12] = L"-=unknown=-"; 
//colors
static int NAME_COLOR = 0x00FFFFFF; 
static int TITLE_COLOR = 0x00ECF9A2; 

static int SPEC1_COLOR=4164606;
static int SPEC2_COLOR=8453888;
static int SPEC3_COLOR=10283177;
static int SPEC4_COLOR=33023;


//Oli statics
static const BYTE PERIOD_REG = 0xff;


//max items, npc
static const int STOCK_ITEMS = 9000;
static const int MAX_STOCK_ITEMS = 11;  //original 10000
static DWORD ItemStockArray[STOCK_ITEMS];
static DWORD ResourceStockArray[MAX_STOCK_ITEMS]  ={
	1, //short sword
	1869, //@iron_ore
	1873, //@silver_nugget
	1868, //@thread
	1872, //@animal_bone
	1867, //@animal_skin
	1865, //@varnish
	1864, //@stem
	1866, //@suede
	1870, //@coal
	1871  //@charcoal
};

//static int MAX_NPCS = 1037000; //original 1015000
//static int MAX_PACKET_LEN = 0x4000; //original 0x2000 = 8kbytes

//epic bosses
static int queen_ant = 1012001;
static int core = 1012052;
static int orfen = 1012169;
static int antaras = 1012211;
static int baium = 1012372;
static int zaken = 1012374;
static int valakas = 1012899;




//packet format strings
const char findQ='Q';
const char replF='f';
//int findQ = 0x51;
//int replacef = 0x66;

static int WOOL_UNDERWEAR_SET = 56;

//maraudeering
static int MARAUDERS=0;
static int COMBAT_TIME_SEC = 15000; //15 sec
static int COMBAT_TIME_SAVE = 60000; //1 min
static int COMBAT_TIME_MAX =  600000; // 10 min
//=======================
//Server->Client opcodes
//======================

//BYTE fOPCODE(BYTE opkode);
BYTE aOPCODE(BYTE opkode);
WORD aOPCODEx(WORD opkode);

static WORD OP_SHOWSCREENMESSAGE_A = 0x38;
static WORD OP_TELEPORT_TO_LOCATION_A = 0x142; //lindvior: 0x154; //extended packet
static WORD OP_IsCharNameCreatable_A = 0x10f; //gd: 0x110; //extended packet
static WORD OP_ExHeroListPacket_A=0x79; //gd: 0x7A; //extended packet

static WORD OP_ClientRequestGOTOLobby_A = 0x39; //0x36;0x37;0x38;0x39; lindvior: 0x33
static WORD OP_ClientRequestCreatable_A = 0xb0; //lindvior: 0xAD
static WORD OP_ClientRequestEnchantCancel_A=0x51;
static WORD OP_ClientRequestEnchantPutSupportItem_A=0x50;
static WORD OP_ClientRequestEnchantPutItem_A=0x4F;
static WORD OP_ClientRequestReceivedPostList_A=0x67;
static WORD OP_ClientRequestReceivedPost_A=0x69;
static WORD OP_ClientRequestJoinPledgeByName_A=0xBE; //LindviorOnly?


static WORD OP_ClientRequestSpeedHackCheck_A=0xC4; //0xDB;
static WORD OP_ExCheck_SpeedHack_A=0x135; //126 //135 //143


static WORD OP_ExNoticePostArrived_A=0xA9;
static WORD OP_ExShowReceivedPostList_A=0xAA;
static WORD OP_ExReplyReceivedPost_A=0xAB;
static WORD OP_ExChangePostState_A=0xB3;


static WORD OP_ExUnreadMailCount_A=0x146;
static WORD OP_ExPledgeCount_A=0x147;
static WORD OP_ExAdenaInvenCount_A=0x148;




static WORD OP_ClientConfirmMenteeAdd_A=0xBC;
static WORD OP_ClientRequestMentorCancel_A=0xBD;
static WORD OP_ClientRequestMentorList_A=0xBE;
static WORD OP_ClientRequestMenteeAdd_A=0xBF;
static WORD OP_ClientRequestMenteeSearch_A=0x00; //WaitingList //lindvior

static WORD OP_ExMentorList_A=0x120;
static WORD OP_ExMentorAdd_A=0x121;
static WORD OP_ExListMenteeWaiting_A=0x122;


#ifdef __C1_PACKETS__

//c1
static BYTE PARTY_SMALLW_U=0x67;


static BYTE OP_SAY = 0x5D; //c1
static BYTE OP_EXTENDED = 0xFE;
static BYTE OP_SELECTION_INFO = 0x1f;
static BYTE OP_SELECTION_INFO2 = 0xDD; //c1=earthQUAKE. if pUserNULL at earthtquake......
static BYTE OP_SELECTION_INFO3 = 0x1f;
static BYTE OP_HTML_TUTORIAL = 0xB9;
static BYTE OP_SYS_MSG = 0x7A;
//
static BYTE OP_NETPING = 0xEC;
static BYTE OP_DICE = 0xDA;
static BYTE OP_PLEDGE_MPOWER = 0xEC; //no pledge power in C1
static BYTE OP_MACRO_LIST = 0xEC; //no macro list in C1
static BYTE OP_SHOW_MAP = 0xB6;
static BYTE OP_STATUS_UPDATE = 0x1a;
static BYTE OP_PARTY_BUFF = 0xEC; //no partybuff in C1
static BYTE OP_TELEPORT2LOC = 0x38;
static BYTE OP_NEWCHAR_OK = 0x23;
static BYTE OP_NEWCHAR_FAIL = 0x24;
static BYTE OP_VERSION = 0x00;
static BYTE OP_PLEDGE_ADDW = 0x6a;
static BYTE OP_SSQ_SKY = 0xEC; //no ssq in c1 
static BYTE OP_WEAR = 0xEC; //no wear in c1
static BYTE OP_LOGOUT = 0x96; 
static BYTE OP_TIME = 0xEC; //no time packet in c1
static BYTE OP_OBSERVE_START = 0xEC; //no observer in c1
static BYTE OP_OBSERVE_END = 0xEC; //no observer in c1
static BYTE OP_CHAIR_SIT = 0xEC; //no chair sit in c1
static BYTE OP_SETUP_GAUGE = 0x85;
static BYTE OP_RECIPE_BOOK = 0xEC; //no recipe book in c1
static BYTE OP_PLAY_SOUND = 0xB1;
static BYTE OP_FRIEND_SAY = 0xEC; //not in c1
static BYTE OP_CONFIRMD = 0xEC; //not in c1
static BYTE OP_NPCHTML = 0x1b;
static BYTE OP_CHAR_CREATE_SUCCESS = 0x25;
static BYTE OP_START_PLEDGEWAR = 0x7d;
static BYTE OP_STOP_PLEDGEWAR = 0x7f;
static BYTE OP_SURENDER_PLEDGEWAR = 0x81;
static BYTE OP_START_ALLYWAR = 0xD5;
static BYTE OP_STOP_ALLYWAR = 0xD7;
static BYTE OP_SURENDER_ALLYWAR = 0xD9;
static BYTE OP_PLEDGE_SHOWALL = 0x68;
static BYTE OP_OBJECT_STATUS = 0xb2;
static BYTE OP_LIST_PARTYW = 0xaf;
static BYTE OP_DELETEOBJ = 0x1e;

static BYTE OP_DOOR_INFO = 0x60; 
static BYTE OP_DOOR_STATUS = 0x61; 

static BYTE OP_BUYLIST = 0x1d;
static BYTE OP_SELLLIST = 0x1c;

		static BYTE OP_SHOW_RADAR=0xBD;
		static BYTE OP_DEL_RADAR=0xBE;
		static BYTE OP_CNTR_RADAR=0xEC; //no in c1

static BYTE OP_ACTION_FAIL = 0x35;
static BYTE OP_BBS_SHOW_BOARD = 0x86;
static BYTE OP_EARTHQUAKE = 0xdd;
static BYTE OP_NPC_SAY = 0x2;




#else


#ifndef __KAMAEL_PACKETS_SEND__


//c2-c6
static BYTE OP_USER_INFO=0x4;
static BYTE OP_NPC_INFO=0x16;

static BYTE OP_TRADE_START=0x1e;
static BYTE ETC_STATUS_UPDATE=0xF3;
static BYTE OP_PET_STATUS_UPDATE=0xB5;
static BYTE OP_PET_INFO=0xB1;
static BYTE OP_X_MAS = 0xF2;


static BYTE PARTY_SMALLW_U=0x52;

//static BYTE OP_TARGET_UNSELECTED = 0x2a;
static BYTE OP_SAY = 0x4a;
static BYTE OP_L2FRIEND_SAY=0xFD;
static BYTE OP_FRIEND_STATUS=0x7B;
static BYTE OP_EXTENDED = 0xFE;
static BYTE OP_SELECTION_INFO = 0x13;
static BYTE OP_SELECTION_INFO2 = 0xDD;
static BYTE OP_SELECTION_INFO3 = 0x13;
static BYTE OP_HTML_TUTORIAL = 0xA0;
static BYTE OP_SYS_MSG = 0x64;
//
static BYTE OP_NETPING = 0xD3;
static BYTE OP_DICE = 0xD4;
static BYTE OP_PLEDGE_MPOWER = 0x30;
static BYTE OP_MACRO_LIST = 0xE7;
static BYTE OP_SHOW_MAP = 0x9D;
static BYTE OP_STATUS_UPDATE = 0x0E;
static BYTE OP_PARTY_BUFF = 0xEE;
static BYTE OP_TELEPORT2LOC = 0x28;
static BYTE OP_NEWCHAR_OK = 0x17;
static BYTE OP_NEWCHAR_FAIL = 0x18;
static BYTE OP_VERSION = 0x00;
static BYTE OP_PLEDGE_ADDW = 0x55;
static BYTE OP_SSQ_SKY = 0xF8; 
static BYTE OP_WEAR = 0xEF; 
static BYTE OP_LOGOUT = 0x7E; 
static BYTE OP_TIME = 0xEC;
static BYTE OP_OBSERVE_START = 0xDF;
static BYTE OP_OBSERVE_END = 0xE0;
static BYTE OP_CHAIR_SIT = 0xe1;
static BYTE OP_SETUP_GAUGE = 0x6d;
static BYTE OP_RECIPE_BOOK = 0xd6;

static BYTE OP_PLAY_SOUND = 0x98;

//static BYTE OP_PARTY_MLIST = 0x96;
//not used yet
static BYTE OP_FRIEND_SAY = 0xFD;
static BYTE OP_CONFIRMD = 0xED;

//SEND opCODES part2
static BYTE OP_NPCHTML = 0x0f;
static BYTE OP_CHAR_CREATE_SUCCESS = 0x19;

static BYTE OP_START_PLEDGEWAR = 0x65;
static BYTE OP_STOP_PLEDGEWAR = 0x67;
static BYTE OP_SURENDER_PLEDGEWAR = 0x69;
static BYTE OP_START_ALLYWAR = 0xBC;
static BYTE OP_STOP_ALLYWAR = 0xBE;
static BYTE OP_SURENDER_ALLYWAR = 0xC0;
static BYTE OP_PLEDGE_SHOWALL = 0x53;
static BYTE OP_OBJECT_STATUS = 0x99;
static BYTE OP_LIST_PARTYW = 0x96;

static BYTE OP_DELETEOBJ = 0x12;
static BYTE OP_DOOR_INFO = 0x4c; //those opcodes the same bor c2 and ct2
static BYTE OP_DOOR_STATUS = 0x4d; //those opcodes the same bor c2 and ct2

static BYTE OP_BUYLIST = 0x11;
static BYTE OP_SELLLIST = 0x10;


		static BYTE OP_SHOW_RADAR=0xA4;
		static BYTE OP_DEL_RADAR=0xA5;
		static BYTE OP_CNTR_RADAR=0xEB;

static BYTE OP_EARTHQUAKE = 0xc4;
static BYTE OP_MY_TARGET_SELECTED = 0xa6;
static BYTE OP_TARGET_SELECTED = 0x29;
static BYTE OP_TARGET_UNSELECTED = 0x2A;

static BYTE OP_GM_HIDE = 0x8d;

static BYTE OP_ACTION_FAIL = 0x25;
static BYTE OP_BBS_SHOW_BOARD = 0x6e;

static BYTE OP_INVENTORY_UPDATE = 0x27; 
static BYTE OP_WAREHOUSE_DONE = 0x43; 

static BYTE OP_SOCIAL_ACTION=0x2d;
static BYTE OP_AUTOATTACK_STOP=0x2c;



	#endif //c2-c6 defined
#endif //c1 defined





#ifdef __KAMAEL_PACKETS_SEND__

//CT1 OPCODES

static BYTE OP_AUTOATTACK_STOP=0x26;
static BYTE OP_SOCIAL_ACTION=0x27;
static BYTE OP_USER_INFO=0x32;
static BYTE OP_NPC_INFO=0x0C;

static BYTE OP_TRADE_START=0x14;
static BYTE ETC_STATUS_UPDATE=0xF9; //0xF3
static BYTE OP_PET_STATUS_UPDATE=0xB6;
static BYTE OP_PET_INFO=0xB2;
static BYTE OP_X_MAS = 0xF8;


static BYTE OPK_VERSION = 0x2e;
static BYTE OPK_STATUS_UPDATE = 0x18;
static const BYTE EXOPK_PARTYPET_ADD = 0x5f; //0x18
static const BYTE EXOPK_PARTYPET_DELETE = 0x6a;
static int OP_NPC_SAY = 0x30; //for freya packet


static BYTE OPZ_SELECTION_INFO = 0xe5; //original=0x09;
static BYTE OPZ_SELECTION_INFO2 = 0xE3;
static BYTE OPZ_SELECTION_INFO3 = 0x09;


//CT1-...
static BYTE OP_DOOR_INFO = 0x4c; //those opcodes the same bor c2 and ct2
static BYTE OP_DOOR_STATUS = 0x4d; //those opcodes the same bor c2 and ct2

static BYTE PARTY_SMALLW_U=0x52;


//static BYTE OP_TARGET_UNSELECTED = 0x24;
static BYTE OP_SAY = 0x4a;
static BYTE OP_L2FRIEND_SAY=0x78;
static BYTE OP_FRIEND_STATUS=0x59;
static BYTE OP_EXTENDED = 0xFE;

static BYTE OP_DELETEOBJ = 0x08;
static BYTE OP_SELECTION_INFO = 0xe5; //original=0x09;
static BYTE OP_SELECTION_INFO2 = 0xE3;
static BYTE OP_SELECTION_INFO3 = 0x09;
static BYTE OP_HTML_TUTORIAL = 0xA6;
static BYTE OP_SYS_MSG = 0x62;
//
static BYTE OP_NETPING = 0xD9;
static BYTE OP_DICE = 0xDA;
static BYTE OP_PLEDGE_MPOWER = 0x2a;
static BYTE OP_MACRO_LIST = 0xE8;
static BYTE OP_SHOW_MAP = 0xa3;
static BYTE OP_STATUS_UPDATE = 0x18;
static BYTE OP_PARTY_BUFF = 0xf4;
static BYTE OP_TELEPORT2LOC = 0x22;
static BYTE OP_NEWCHAR_OK = 0x0d;
static BYTE OP_NEWCHAR_FAIL = 0x0e;
static BYTE OP_VERSION = 0x2e;
static BYTE OP_SSQ_SKY = 0x73;
static BYTE OP_WEAR = 0xF5; 
static BYTE OP_LOGOUT = 0x84;
static BYTE OP_TIME = 0xF2;
static BYTE OP_OBSERVE_START = 0xEB;
static BYTE OP_OBSERVE_END = 0xEC;
static BYTE OP_CHAIR_SIT = 0xed;
static BYTE OP_SETUP_GAUGE = 0x6b;
static BYTE OP_RECIPE_BOOK = 0xdc;


static BYTE OP_PLAY_SOUND = 0x9e;

//static BYTE OP_PARTY_MLIST = 0x9c;
//not used yet
//static BYTE OP_CONFIRMD = 0xf3;
static BYTE OP_FRIEND_SAY = 0x78;

//SEND opCODES part2
static BYTE OP_NPCHTML = 0x19;
static BYTE OP_CHAR_CREATE_SUCCESS = 0x0f;

static BYTE OP_START_PLEDGEWAR = 0x63;
static BYTE OP_STOP_PLEDGEWAR = 0x65;
static BYTE OP_SURENDER_PLEDGEWAR = 0x67;
static BYTE OP_START_ALLYWAR = 0xC2;
static BYTE OP_STOP_ALLYWAR = 0xC4;
static BYTE OP_SURENDER_ALLYWAR = 0xC6;
static BYTE OP_OBJECT_STATUS = 0x9f;
static BYTE OP_LIST_PARTYW = 0x9c;


static BYTE OP_BUYLIST = 0x07;
static BYTE OP_SELLLIST = 0x06;

		static BYTE OP_SHOW_RADAR=0xaa;
		static BYTE OP_DEL_RADAR=0xB8;
		static BYTE OP_CNTR_RADAR=0xf1; 

static BYTE OP_EARTHQUAKE = 0xd3;
static BYTE OP_MY_TARGET_SELECTED = 0xb9;
static BYTE OP_TARGET_SELECTED = 0x23;
static BYTE OP_TARGET_UNSELECTED = 0x24;

static BYTE OP_GM_HIDE = 0x93;



/*
//static BYTE OPK_NETPING = 0xD9;
static BYTE OPK_START_PLEDGEWAR = 0x63;
static BYTE OPK_STOP_PLEDGEWAR = 0x65;
static BYTE OPK_SURENDER_PLEDGEWAR = 0x67;
static BYTE OPK_START_ALLYWAR = 0xC2;
static BYTE OPK_STOP_ALLYWAR = 0xC4;
static BYTE OPK_SURENDER_ALLYWAR = 0xC6;
static BYTE OPK_PLEDGE_SHOWALL = 0x5a;
static BYTE OPK_SYS_MSG = 0x62;

static BYTE OPK_SELECTION_INFO = 0x09;
static BYTE OPK_SELECTION_INFO2 = 0xE3;
static BYTE OPK_NEWCHAR_OK = 0x0d;
static BYTE OPK_NEWCHAR_FAIL = 0x0e;
*/
//....
static BYTE OP_ACTION_FAIL = 0x1f;
static BYTE OP_BBS_SHOW_BOARD = 0x7b;

static BYTE OP_INVENTORY_UPDATE = 0x21; 
static BYTE OP_WAREHOUSE_DONE = 0x43; 


static BYTE OP_PLEDGE_SHOWALL = 0x5a;
static BYTE OP_PledgeShowMembeListUpdate=0x5b;
static BYTE OP_PLEDGE_ADDW = 0x5c;
static BYTE OP_PledgeShowMembeListDelete=0x5d;

static BYTE OP_L2FriendList=0x75;

#endif













//--------------------------------------------------------------------------------------------
//// Global Function Addresses in L2Server
//--------------------------------------------------------------------------------------------

static const DWORD * KOREAN_RANDOM = (DWORD *)0x0043C5F0;

static const DWORD * USER_RESTART = (DWORD *)0x004ED7E0;
static const DWORD * USER_GETPARTY = (DWORD *)0x004417E0; //4417E0,	"CParty *User::GetParty();
static const DWORD * PARTY_USERWITHDRAW = (DWORD *)0x004B4D60; //"void CParty::Withdraw(User *pUser);
//static const DWORD * CLOG_ADD = (DWORD *)0x0053eee0;
static const DWORD * CLOG_ADDU = (DWORD *)0x0053eee0;
static const DWORD * CLOG_ADDA = (DWORD *)0x0053EE60;
static const DWORD * PACKET_ASSEMBLE = (DWORD *)0x0053afa0;
static const DWORD * MATH_FLOAT2DEC = (DWORD *)0x0058c3ac;
//static const DWORD * USER_GET_PARTY = (DWORD *)0x004417e0	//User::GetParty()
//static const DWORD * USER_GET_PLEDGE = (DWORD *)0x00405520	//User::GetPledge()
static const DWORD * CCREATURE_CHECK_AVE = (DWORD *)0x004486C0;		//void CCreature::CheckAbnormalVisualEffect()
static const DWORD * CCREATURE_GETBY_OBJID = (DWORD *)0x00439660;	//pCreature* CCreature::GetObject(unsigned int sid)
//4ad870	CObject::GetObject(unsigned int sid)
static const DWORD * CCREATURE_ADD_ITEMS = (DWORD *)0x004440E0;		
static const DWORD * CCREATURE_ADD_ITEM_TO_INV =(DWORD *)0x00443DF0;
static const DWORD * CCREATURE_USE_ITEM = (DWORD *)0x00443630;		//void CCreature::UseItem(DWORD * pItem)
static const DWORD * CSOCKET_SEND = (DWORD *)0x004DFC70;			//void CSocket::Send(pSocket, format, ...)
static const DWORD * CSOCKET_BROADCAST = (DWORD *)0x00445990;			//BroadcastToNeighborDist
static const DWORD * L2SERVER_BROADCAST2ALL = (DWORD *)0x004f0960;			//BroadcastToalluser
static const DWORD * CSOCKET_SEND2 = (DWORD *)0x004DF3E0;			//void CSocket::Send(const char* format, ...)
//static const DWORD * CSOCKET_SENDV = (DWORD *)0x004DFB70;			//void CSocket::SendV(pSocket, format, ...)
static const DWORD * CINVENTORY_FIND_ITEM = (DWORD *)0x00485B20;	//CObject* CInventory::FindFirstItemByClassID(int nClassID)
//static const DWORD * CINVENTORY_FIND_ITEM = (DWORD *)0x00485830;	//CObject* CInventory::FindItemByIndex(int nID)
static const DWORD * TEMPLATE_GET_USER = (DWORD *)0x00517B90;
static const DWORD * TEMPLATE_GET_USER2 = (DWORD *)0x0058C8B6;
static const DWORD * TEMPLATE_GET_USER3 = (DWORD *)0x00406970;
static const DWORD * TEMPLATE_GET_USER4 = (DWORD *)0x0041E4D0;
static const DWORD * USER_GET_PARTYY = (DWORD *)0x004417E0;			//User::GetParty(User * pUser)
static const DWORD * USER_SEND_USERINFO = (DWORD *)0x004FE0E0;		//User::SendUserInfo()  //push 0 for normal, 1 for GM UserInfo
static const DWORD * USER_SEND_CHARINFO = (DWORD *)0x004FEDD0;		//User::SendCharInfo()	//push 0 for normal, 1 for NPC?
static const DWORD * USER_USE_ITEM = (DWORD *)0x004EDF70;			//void User::UseItem(CItem*)
static const DWORD * USER_SEND_ITEM_LIST = (DWORD *)0x004F1830;
static const DWORD * MOV_EAX_ECX = (DWORD *)0x00401B00;
//static const DWORD * VIRTUAL_FREE = (DWORD *)0x005B505C;			//kernel 32
//static const DWORD * PARTY_LEADER_LEAVE_WORLD = (DWORD *)0x004B4F70;			
static const DWORD * PARTY_DISMISS = (DWORD *)0x004B4F70;			

static const DWORD * CUSERSOCKET_READ = (DWORD *)0x00500FF0;		//CUserSocket::Read(pBuffer, pSocket, pUser)??
//static const DWORD * CUSERSOCKET_READ2 = (DWORD *)0x005509E2;		//Alternate function?

// close socket closesocket
static const DWORD * _CLOSE_SOCKET = (DWORD *)0x00539610;
static const DWORD * _DISCONECT_SOCKET = (DWORD *)0x00514480;
static const DWORD * STD_CLOSESOCKET = (DWORD *)0x005B52CC; 
static const DWORD * _CLOSE_PRESERVED_SOCKET = (DWORD *)0x00514850;
static const DWORD * CSocket_Kick=(DWORD *)0x005067B0;


//mov ecx,Socket;
//mov dword ptr [ecx+$13CC], 2
//call _CLOSE_SOCKET

static const DWORD * _SEND_DB = (DWORD *)0x00455D60;	


//  PUSH List
//  PUSH format
//  MOV ECX, Socket
//  CALL SEND_DB

//static const DWORD * CDB_P = (DWORD *)(0x1720CB90 + 0x1C);





//new 2009


static const DWORD * USER_CHECKTRADE = (DWORD *)0x004e7ff0; //4e7ff0	User::CheckTrade()
static const DWORD * USER_CANCELTRADE = (DWORD *)0x004e7ff0; //4e7e70	User::CancelTrade()
static const DWORD * USER_ISITEMUSABLE = (DWORD *)0x004e9fc0; //4e9fc0	User::IsItemUsable()
static const DWORD * USER_SENDPRIVATEBUY = (DWORD *)0x004f39f0; //4f39f0	User::SendPrivateStoreBuyList(CUserSocket * pTargetSocket)
static const DWORD * USER_SENDPRIVATESELL = (DWORD *)0x004f3000; //4f3000	User::SendPrivateStoreManageList(CUserSocket * pTargetSocket)
static const DWORD * CDOOR_OPEN = (DWORD *)0x004760d0; //4760d0	bool CDoor::Open(bool bByParent)
//557440	CWorld::DoorOpenClose(class CDoor *pDoor, bool bOpenClose) //[ebp+8] pDoor
//4760d0	bool CDoor::Open(bool bByParent) //[ebp+4] pDoor, [ebp+0] requester? [requester][78h] GetUser
//[pdoor][c8h] GetDoorSharedData???
//[doorshared][14ch] staticobjectid

//new 2010
static const DWORD * SEND_ITEMSPAWN = (DWORD *)0x00488590;
//static const DWORD * USER_SET_GUILTY = (DWORD *)0x004eb430;
static const DWORD * GRADE_PARSER = (DWORD *)0x0058C90D;

//new 2011
static const DWORD * FN_TRACKER = (DWORD *)0x004792B0;
static const DWORD * NPC_GETMASTER= (DWORD *)0x00494FC0;
static const DWORD * SUMMON_GETMASTER= (DWORD *)0x0054ADB0;

static const DWORD * _PARSER1= (DWORD *)0x0058C90D; //word compare
static const DWORD * _PARSER2= (DWORD *)0x00448B20;

//static const DWORD * GET_HTML_FILE= (DWORD *)0x00538900;


static const DWORD * USER_RELATION_CHANGED= (DWORD *)0x00500990;
static const DWORD * USER_GATHER_RELATION_CHANGED= (DWORD *)0x00500C40;
static const DWORD * GET_GEODATA= (DWORD *)0x00416C40;
static const DWORD * GEODATA_MOVE_TEST= (DWORD *)0x0047DDE0;


static const DWORD * CIOObject_SetTimeStamp= (DWORD *)0x00539560;
	//typedef bool (*_TIME_STAMP)(LONG *Target);
	//static _TIME_STAMP CIOObject_SetTimeStamp = (_TIME_STAMP)0x539560; 


static const DWORD * __PushCreature=(DWORD *)0x004CCF30;



static const DWORD * IS_INPEACE_ZONE=(DWORD *)0x0043EC00;
static const DWORD * IS_INPVP_ZONE=(DWORD *)0x0043EAE;
static const DWORD * IS_INBATTLE_ZONE=(DWORD *)0x0043EB70;

static const DWORD * GET_OBJECT_CREATURE_INV=(DWORD *)0x0042EE00;
static const DWORD * OPERATOR_GETCREATURE=(DWORD *)0x0042E910;


//2012

static const DWORD * USER_STOPSAY=(DWORD *)0x004E9500;
static const DWORD * SYS_MSG_S=(DWORD *)0x00405060;


static const DWORD * FIND_IN_TOGGLE_DB = (DWORD *)0x00546C90; //(DWORD *pFirstBuff, DWORD *p1, DWORD *p2);
//static const DWORD * INITIALIZE_TOGGLE_DB = (DWORD *)0x00439A90;

static const DWORD * USER_HAVESKILL=(DWORD *)0x00445320;
static const DWORD * USER_HAVESKILLA=(DWORD *)0x004453E0;
//static const DWORD * ISUSER_HAVE_SKILL= (DWORD *)0x00445320;
static const DWORD * FIND_IN_OBJECTS=(DWORD *)0x0040D830;


//2016
static const DWORD * EquippedWeaponGrade = (DWORD *)0x00442480;
static const DWORD * SendSystemmessage_404FE0 = (DWORD *)0x00404FE0;

//2017
static const DWORD * USER_GetCharacterName = (DWORD *)0x004E86B0;
static const DWORD * INV_FINDITEMBY_DBID = (DWORD *)0x004851D0;



//--------------------------------------------------------------------------------------------
//// Packet Formats
//--------------------------------------------------------------------------------------------

static const char * FORMAT_ExPrivateStoreBuyingResult = "chdddS"; //grand crusade OP_ExPrivateStoreBuyingResult_EXT


static const char * FORMAT_NEWCHARSUCCESS_2 = "dddddddddddddddddddddddddd";




//TODO: rename all the packet formats, and order by format, shortest to longest, for easy reuse
static const char * FORMAT_ACTION_FAILED = "c";
static const char * FORMAT_ASK_PARTY = "cSd";
static const char * FORMAT_FE00 = "chhhhd";
static const char * FORMAT_AUTOSS = "chdd";
static const char * FORMAT_AUTOSS2 = "cdddd";
static const char * FORMAT_RECOMMEND = "cdddS";
static const char * FORMAT_RECOMMEND2 = "cdddSdd";
static const char * FORMAT_SHOWMAP = "cdd";


static const char * INITIAL_KEY_FORMAT_C4 = "ccddd"; //c4 actual format is ccddd, C1 =ccdd
static const char * INITIAL_KEY_FORMAT_C7 = "ccddddcd"; //+0,0,0 or 1,0,0 ddcd
static const char * INITIAL_KEY_FORMAT_CLASSIC1 = "ccddddcdcffffffff";
static const char * FORMAT_SAY = "cddSS";
static const char * E_GRADE="e";


/*
static char * CFORMAT_LOCATION1 = "chcddd"; //classic
static char * CFORMAT_SYS_MSG1 = "chd";
static char * CFORMAT_SYS_MSG2 = "chccd";
static char * CFORMAT_SYS_MSG3 = "chccdcd";
static char * CFORMAT_SYS_MSG4 = "chccdcdcd";
static char * CFORMAT_SYS_MSG_SKILL = "chccdd";
static char * CFORMAT_SYS_MSG_EPIC_DROP_ADENA = "chccdcd";
static char * CFORMAT_SYS_MSG_EPIC_DROP = "chccdcdcd";
static char * CFORMAT_SYS_MSG_TXT = "chccS";
static char * CFORMAT_SYS_MSG_TXT2 = "chccScd"; //CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT2, OP_SYS_MSG,614, 2 , 0, L"numer(123):",1,123);
static char * CFORMAT_SYS_MSG_TXT3 = "chccScS";
static char * CFORMAT_SYS_MSG_TXT4 = "chccScdcd";
static char * CFORMAT_SYS_MSG_TXT5 = "chccdcS";
static char * CFORMAT_SYS_MSG_TXT_SKILL = "chccScdd";
static char * CFORMAT_TIME = "chccdcd";
static char * CFORMAT_TIME1 = "chccdcd";
*/

static char * FORMAT_LOCATION = "cdddddddd";
static char * FORMAT_LOCATION1 = "cdddddd";
static char * FORMAT_LOCATION2 = "chccddd";
static char * FORMAT_SYS_MSG1 = "cdd";
static char * FORMAT_SYS_MSG2 = "cdddd";
static char * FORMAT_SYS_MSG3 = "cdddddd";
static char * FORMAT_SYS_MSG4 = "cdddddddd";
static char * FORMAT_SYS_MSG_SKILL = "cddddd";
static char * FORMAT_SYS_MSG_EPIC_DROP_ADENA = "cdddddd";
static char * FORMAT_SYS_MSG_EPIC_DROP = "cdddddddd";
static char * FORMAT_SYS_MSG_TXT = "cdddS";
static char * FORMAT_SYS_MSG_TXT2 = "cdddSdd"; //CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT2, OP_SYS_MSG,614, 2 , 0, L"numer(123):",1,123);
static char * FORMAT_SYS_MSG_TXT3 = "cdddSdS";
static char * FORMAT_SYS_MSG_TXT4 = "cdddSdddd";
static char * FORMAT_SYS_MSG_TXT5 = "cdddddS";
static char * FORMAT_SYS_MSG_TXT_SKILL = "cdddSddd";
static char * FORMAT_TIME = "cdddddd";

static char * CFORMAT_SYS_MSG_TXT2 = "chccScd"; //classic version for broadcasts
static char * CFORMAT_SYS_MSG_TXT4 = "chccScdcd";
static char * CFORMAT_SYS_MSG_EPIC_DROP_ADENA = "chccdcd";
static char * CFORMAT_SYS_MSG_EPIC_DROP = "chccdcdcd";

							   //C1 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbc"
//static const char * FORMAT_USERINFO = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcddddddddhhdhddddcddd";
//static const char * FORMAT_USERINFO = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcddddddddhhdhddddccdcccdddd";
							//Linex = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcddddddddhhdhddddccdcccdddd"
//static const char * FORMAT_CHARINFO = "cdddddSddddddddddddddddddddddddddddffffdddSdddddccccccchbcdchddddcccccdddd";
//004FF515 PUSH L2Ser.006037CC "cdddddSdddddddddddddddddddddddddddffffdddSdddddccccccchbc"						//C1 Format
//004FFAB2 PUSH L2ser.006B8869 "cdddddSddddddddddddddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccdddd"		//C4 Format
				//L2J format = "cdddddSddddddddddddddddddddddddddddffffdddSdddddccccccchhcdchdddccdcccdddd"		//C4 Format


static const char * FORMAT_PARTY_MATCHD = "cdddddS"; //c3 550
static const char * FORMAT_PARTY = "dSdddddddddd";
static const char * FORMAT_PARTY2 = "cddddb";
static const char * FORMAT_PARTY_C2 = "cdb"; //c2 window all
static const char * FORMAT_PARTY3 = "cdSdddddddd"; //party window add C2
static const char * FORMAT_PARTY4 = "cdddSdddddddddd"; //party window add C4


//==================
//2007 smeli formats
//==================

		static const char * FORMAT_RADAR_CONTROL="cddddd";


//pledge formats
static const char * EX_FORMAT_PLEDGE_STATUSCHANGED_c = "cdddddd";

static const char * EX_FORMAT_PLEDGE_WINDOWOPEN_c = "Sddddddc"; //PledgeOpenWindow classic
static const char * EX_FORMAT_PLEDGE_WINDOWOPEN_5 = "Sdddddd"; //PledgeOpenWindow
static const char * EX_FORMAT_PLEDGE_WINDOWOPEN_4 = "Sddddd"; //PledgeOpenWindow
static const char * EX_FORMAT_PLEDGE_WINDOWOPENALL_c = "cddddSSdddddddddddSddddb"; //PledgeOpenWindowAll classic
static const char * EX_FORMAT_PLEDGE_WINDOWOPENALL_a = "cdddSSdddddddddddSddddb"; //PledgeOpenWindowAll awake
static const char * EX_FORMAT_PLEDGE_WINDOWOPENALL_9 = "cdddSSddddddddddSddddb"; //PledgeOpenWindowAll
static const char * EX_FORMAT_PLEDGE_WINDOWOPENALL_5 = "cdddSSdddddddddSdddb"; //PledgeOpenWindowAll
static const char * EX_FORMAT_PLEDGE_WINDOWOPENALL_4 = "cdSSdddddddddSdddb"; //PledgeOpenWindowAll
static const char * EX_FORMAT_PLEDGE_WINDOWOPENALL_2 = "cdSSdddddddddSddb"; //PledgeOpenWindowAll
//static const char * EX_FORMAT_PLEDGE_WINDOWADD_c = "cSddddddc"; //PledgeAddWindow classic
static const char * EX_FORMAT_PLEDGE_WINDOWADD_5 = "cSdddddd"; //PledgeAddWindow
//static const char * EX_FORMAT_PLEDGE_WINDOWADD_4 = "cSddddd"; //PledgeAddWindow
static const char * EX_FORMAT_PLEDGE_MEMBERLIST_5 = "cdddSS"; 
static const char * EX_FORMAT_PLEDGE_MEMBERLIST_5_Classic = "cddddSS";
static const char * EX_FORMAT_PLEDGE_MEMBERLIST_4 = "cdSS"; 
static const char * EX_FORMAT_PLEDGE_SHOWINFOUPD_a = "cddddddddddddSdddd"; //PledgeShowInfoUpdate awake
static const char * EX_FORMAT_PLEDGE_SHOWINFOUPD_7 = "cdddddddddddSdd"; //PledgeShowInfoUpdate
static const char * EX_FORMAT_PLEDGE_SHOWINFOUPD_5 = "cddddddddddSdd"; //PledgeShowInfoUpdate
static const char * EX_FORMAT_PLEDGE_SHOWINFOUPD_4 = "cdddddddddsSd"; //PledgeShowInfoUpdate
static const char * EX_FORMAT_PLEDGE_SHOWINFOUPD_Lind = "cdddddddddddddSdddd"; //PledgeShowInfoUpdate Tauti
                                                     // "cddddddddddddSdddd"

//static const char * EX_FORMAT_PLEDGE_INFO_GM5="cSddSSdddddddddddSdddb"; //GM
static const char * EX_FORMAT_PLEDGE_INFO_GM2="cSdSSdddddddddSddb"; //GM
static const char * EX_FORMAT_PLEDGE_INFO_GM5="cSddSSdddddddddSdddb"; //GM
     static const char * EX_FORMAT_PLEDGE_INFO_GM9="cSddSSddddddddddSddddb"; //GM
static const char * EX_FORMAT_PLEDGE_INFO_GM_awake="cSddSSdddddddddddSddddb"; //GM
	


//skill & shortcut c5 formats
//================================================================================================
static const char * EX_FORMAT_SKILLIST_4 = "ddd"; 
static const char * EX_FORMAT_SKILLIST_5 = "dddc";
static const char * EX_FORMAT_SKILLIST_10 = "dddcc";
static const char * EX_FORMAT_SKILLIST_Awake = "ddddcc";
static const char * EX_FORMAT_SHORTCUT_INF_4 = "ddddd"; //FOR SKILL ONLY
static const char * EX_FORMAT_SHORTCUT_INF_5 = "ddddcd"; //d*(1dddd) (2ddddcd) (3dddd) FOR SKILL ONLY
static const char * EX_FORMAT_SHORTCUT_INF_Awake = "dddddcd"; 
static const char * EX_FORMAT_SHORTCUT_REG_4 = "cddddd"; // FOR SKILL ONLY
static const char * EX_FORMAT_SHORTCUT_REG_5 = "cddddcd"; // FOR SKILL ONLY
static const char * EX_FORMAT_SHORTCUT_REG_Awake = "cdddddcd"; // FOR SKILL ONLY
static const char * EX_FORMAT_SHORTCUT_REG_7 = "cdddd"; // FOR ITEM ONLY

//polymorph Info
static const char * FORMAT_POLYMORPH_INFO = "cddddddddddddddddddffffdddcccccSSddddddddccffddddccd";
//static const char * FORMAT_POLYMORPH_INFOH5 = "cddddddddddddddddddffffdddcccccdSdSddddddddccffddddccd";
static const char * FORMAT_POLYMORPH_INFOH5=    "cddddddddddddddddddffffdddcccccdSdSddddddddccffddddccddddddcdddddddddd";



//character info
//===============================================================================================
static const char * FORMAT_CHARINFO_4 = "cdddddSddddddddddddddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccdddd"; //c4
static const char * FORMAT_CHARINFO_5 = "cdddddSddddddddddddddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccdddddddddd"; //c5


//Broadcast character info
//==============================================================================================
  static const char * FORMAT_BCCHARINFO_2 = "cdddddSdddddddddddddddddddddddddddffffdddSdddddccccccchbcdchdddc";
//static const char * FORMAT_BCCHARINFO_2 = "cdddddSdddddddddddddddddddddddddddffffdddSdddddccccccchbc";
static const char * FORMAT_BCCHARINFO_4 = "cdddddSddddddddddddddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccdddd"; //C4 
static const char * FORMAT_BCCHARINFO_5 = "cdddddSddddddddddddddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccdddddddddd"; //C5

//	   static const char * FORMAT_BCCHARINFO_6 = "cdddddSdddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddd"; //C6
//	   static const char * FORMAT_BCCHARINFO_7 = "cdddddSddddddddddddddd dddddddd hhhhhhhhhhhhhhhhhhhhhhhh hhhhhhhhhhhhhhhh ddddddddddddddffffdddSdddddccccccchbcdchdddccdcccdddddddd ddd"; //C7(ddd)

//static const char * FORMAT_BCCHARINFO_7 = "cdddddSdddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddddddd"; //C7 + C8(d)

	   static const char * FORMAT_BCCHARINFO_6 = "cdddddSdddddddddddddddhhhhdhhhhhhhhhhhhdhhhhddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddd"; //C6
//	   static const char * FORMAT_BCCHARINFO_7A = "cdddddSdddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddddddd"; //C7 + C8(d)
//changed hh to d in 7b and augmentations starts to show
	   static const char * FORMAT_BCCHARINFO_7B = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddddddd"; //C7 + C8(d)
                                           //ct2.3 cdddddSddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddffffdddSdddddccccccchdchd
//	   static const char * FORMAT_BCCHARINFO_7A = "cdddddSddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddddddd"; //C7 + C8(d)
                                          //                                     d                                        hhdd
    	   static const char * FORMAT_BCCHARINFO_CT2F = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddddddddddd"; //+4d dummy
//   	   static const char * FORMAT_BCCHARINFO_CT2F = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddddddd"; 

//freya
//cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddddddddddddddddffffdddSdddddccccccchbcdchdddccdcccddddddddddddddddd
//cdddddSdddddddddddddddddddddddddddddddddddddddddddhhddddddd_dddddddddffffdddSdddd_ccccccch
//                                                           karma2 removed        relation_changed_for_ally war removed
    	static const char * FORMAT_BCCHARINFO_CT2Freya = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhdddddddddddddddffffdddSddddccccccchbcdchdddccdcccddddddddddddddddd";
        static const char * FORMAT_BCCHARINFO_CT3Awake = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddfddddddddddddddffffdddSddddccccccchbcdchdddccdcccddddddddddddddddd";
		                                                                                                    //   ^^ awake  
      static const char * FORMAT_BCCHARINFO_CT3Harmony = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddfdddfffdddddddddddffffdddSddddccccccchbcdchdddccdcccddddddddddddddddd";
//                                                                                                                   ^^^ harmony                                                  
       static const char * FORMAT_BCCHARINFO_GD2Tauti = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddfdddfffdddddddddddffffdddSddddccccccchbcchdddccdcccdddddddddddddfffffcdffffffffc"; //american
    

       static const char * FORMAT_BCCHARINFO_GD2TautiKOR = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddfddddddddddddddffffdddSddddccccccchbcchdddccdcccdddddddddddddfffffcdffffffffc";
                                                                                                                                                   //   ^tauti removed d




	   static const char * FORMAT_BCCHARINFO_LINDVIOR = "cdddddSddddddddddddddddddddddddddddddddddddddddddddhhddffdffdddddddddddddffffdddSddddccccccchbcchdddccdcccdddddddddddddfffffcdffffffffc"; 
  static const char * FORMAT_BCCHARINFO_LINDVIOR558   = "cdddddShcddddddddddddddddddddddddddddddddddddddddddhhccffdffcddddhhhhhhhhffffdddSddddccccccchbcchdddccdcccdddddchdcdddhffffhdhhhhhhhhhhhhhhhhcc"; 
      static const char * FORMAT_BCCHARINFO_EPEI575   = "cdddddShcdddddddddddddddddddddddddddddddddddddddddddcccffdffcddddhhhhhhhhffffdddSddddccccccchbcchdddccdcccdddddchdcdddhffffhdhhhhhhhhhhhhhhhhcc"; 

	   static const char * FORMAT_BCCHARINFO_Classic  =                           "cdddddShcdddddddddddddhhhhhhcffdffcdddhhhhhhhhffffdddSddddccccccchbcchdddccdcccdddddchdcdddcdddddcdhhhhhhhhhhhhhhhhccc"; 
 	   static const char * FORMAT_BCCHARINFO_Infinity  =                          "cdddddShcdddddddddddddddddddcffdffcdddhhhhhhhhffffdddSddddccccccchbcchdddccdcccdddddchdcdddcdddddcdhhhhhhhhhhhhhhhhccc"; 
 	   static const char * FORMAT_BCCHARINFO_CRUSADER  =                         "ccdddddShcdddddddddddddddddddcffdffcdddhhhhhhhhffffdddSddddccccccchbcchdddccdcccdddddchdcdddcdddddcdhhhhhhhhhhhhhhhhccc"; 



//userinfo
//================================================================================================

static const char * FORMAT_USERINFO_C12014 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdd";

//static const char * FORMAT_USERINFO_2 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcddddddddhhdhddddcdddddd";
//static const char * FORMAT_USERINFO_1 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbc"
                                          //dddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhb hhdh
  static const char * FORMAT_USERINFO_2 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcddddddddhhdhd"; 

  static const char * FORMAT_USERINFO_4 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcddddddddhhdhddddccdcccdddd"; //c4 java, macrabenn7
  static const char * FORMAT_USERINFO_5 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcdddddd"; //c5 
  static const char * FORMAT_USERINFO_5Q = "cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcdddddd"; //c5 


 //static const char * FORMAT_USERINF_60 = "cdddddSddddQddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcdddd"; //c6 original 
  // static const char * FORMAT_USERINFO_6 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcdddd"; //c6  
  //static const char * FORMAT_USERINFO_6Q = "cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcdddd"; //c6  
  static const char * FORMAT_USERINFO_6Q = "cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcdddd"; //c6  
    static const char * FORMAT_USERINFO_6 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcdddd"; //c6  

    static const char * FORMAT_USERINFO_7 = "cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcddddddddddddddddd"; //c7 + c8(ddd)
                                     //CT2.3 cdddddSddddQddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddh
                                     //CT2.2 cdddddSddddQddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddh
																										              // dd                                                  hhdd

    static const char * FORMAT_USERINFO_CT2F = "cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcddddddddddddddddddddd"; //ct2.3 +4d dummy
//                                               dddddSddddQddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddh
//character selection info
  //SdSddddddddddffdQddddddddddddddddddddddddddddddddddddddddffdddchhd //gracia ct2.3
  //SdSddddddddddffdQdddddddddddddddddddddddddddddddddddddddffdddchhd //ct1-ct2

  //SdSddddddddddffddddddddddddddddddddddddddddhhdddddddddddddddhhdddffdddc  // - changed in  interlude client
//  static const char * FORMAT_CHAR_SEL_INF_6 ="cdb";
//  static const char * FORMAT_CHAR_SEL_INF_7 ="cddcb";

//final:dddddSddddQddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddh
//freya:dddddSddddQddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddh
	
//freya
//cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcddddddddddddddddddddd
//cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddh

      static const char * FORMAT_USERINFO_CT2H5 = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcddddddddddddddddddddd"; 
    //static const char * FORMAT_USERINFO_CT3A  = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhdddddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcddddddddddddddddddddd"; //kor
      static const char * FORMAT_USERINFO_CT3B  = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcddddddddddddddddddddd";  //GOD American
      //                                                                                                                                                                              ^^^  GOD AMERICAN        
  static const char * FORMAT_USERINFO_CT3GOD1h  = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhdddddfffdddddddddddddddddddddddffffddddSdddddcccddhbcdcdhhdhddddccdcccddddcddddddddddddddddddddd";  //GOD harmony american
      //                                                                                                                                                                                 ^^^  GOD Harmony        
  static const char * FORMAT_USERINFO_CT3GOD2t  = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhdddddfffdddddddddddddddddddddddffffddddSdddddcccddhbccdhhdhddddccdcccddddcdddddddddddddfdchhffffffff";  //Tauti american
       static const char * FORMAT_USERINFO_GD2KOR  = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddddddddffffddddSdddddcccddhbccdhhdhddddccdcccddddcdddddddddddddfdchhffffffff";  //Tauti Korean
                                                                                                                                                                                                                                     //  ^d removed in tauti                            
    
                                                                                                                                                                                        

    //static const char * FORMAT_USERINFO_CT2H5 = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhh dddddddddddddddddddddd    ffffddddSdddddcccddh bcdcdhhdhddddc cdcc cddd dcddddddddddddddddddddd"; 
//Awakening                           0x32 UserInf cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhdhhhhhhhhhhhhdhhhhhhhhhhhhhhhhhhhhhh dddddddddddddddddddddd dddffffddddSdddddcccddh   dc hhdh ddddc dcc cddd dd hhhhhhhh dd
//writeF((float) (_activeChar.getExp() - Experience.LEVEL[_activeChar.getLevel()]) / (Experience.LEVEL[_activeChar.getLevel() + 1] - Experience.LEVEL[_activeChar.getLevel()]));
	  /*
	  writeD(_mdef);

//Awakening addons		
writeD(0);			// mEvasion
writeD(0);			// mAccuracy
writeD(_mCritRate);  	// mCritRate
		
writeD(pvp_flag);
*/

//static const char * FORMAT_CSELINFO_1="SdSddddddddddffddddddddddddddddddddddddddddddddddddddddddddddffd"; //c1
//static const char * FORMAT_CSELINFO_3="SdSddddddddddffddddddddddddddddddddddddddddddddddddddddddddddddffdddc"; //c3
//static const char * FORMAT_CSELINFO_6="SdSddddddddddffddddddddddddddddddddddddddddddddddddddddddddddddddffdddchh"; //c6
static const char * FORMAT_CHAR_SELECTED_6="cSdSddddddddddffdddddddddddddddddddddddddddddddddddddddddddddddddd"; //c2+Q

//static const char * FORMAT_CSELINFO_5="SdSddddddddddffdQddddddddddddddddddddddddddddddddddddddddddddddffdddcdd"; //c5
//static const char * FORMAT_CSELINFO_6="SdSddddddddddffddddddddddddddddddddddddddddddddddddddddddddddddddffdddcd"; //c6smeli
//static const char * FORMAT_CSELINF_60="SdSddddddddddffdQddddddddddddddddddddddddddddddddddddddddddddddddffdddcd"; //c6
//static const char * FORMAT_CSELINF_CL="SdSddddddddddffQQddddddddddddddddddddddddddddddddddddddddddddddddffdddcd"; //c6


static const char * FORMAT_CHAR_SELECTED_Classic="cSdSddddddddddffddddddddddddddddddddddddddddddddddddddddddddddddddd"; //c2+QQ



//GM view userinfo
//==================================================================================================
static const char * FORMAT_ALT_G_2 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhddd"; 
static const char * FORMAT_ALT_G_5s = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhdddd"; //c5 by smeli
static const char * FORMAT_ALT_G_5q = "cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhdddd"; //c6 by smeli Q
static const char * FORMAT_ALT_G_5Q = "cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhdddd"; //c6 by smeli Q
static const char * FORMAT_ALT_G_6q = "cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddcccddhhddddccdcc"; //c6 by smeli Q
//static const char * FORMAT_ALT_G_7= "cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddcccddhhddddccdcc"; //c6Q + 32 (C7) 
//static const char * FORMAT_ALT_G_7q = "cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddcccddhhddddccdccdddddddddd"; //c6Q + 32 (C7) + 10 (C7) 
static const char * FORMAT_ALT_G_7s = "cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddcccddhhddddccdccdddddddddd"; //c6Q + 32 (C7) + 10 (C7) 
static const char * FORMAT_ALT_G_6s = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddffffddddSdddcccddhhdddd"; //c6 by smeli /wo/Q

//cdddddSddddQddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd //original CT2.3
//cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd 
//cdddddSddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd
//                                                                             dd                                                  hhdd                                                          dd

//static const char * FORMAT_ALT_G_3 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhddd"; //c3-c4
//static const char * FORMAT_ALT_G_5 = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhddddcdddddd"; //c5 by java
//static const char * FORMAT_ALT_G_5Rival = "cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhddddccdcccdddddd"; //c5 by rival
//rev420 cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSddd
//rev478 cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhh
//rev551 cdddddSdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddffffddddSdddcccddhhddd


     static const char * FORMAT_ALT_G_GF = "cdddddSddddfddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccdddddddddddd"; 
     static const char * FORMAT_ALT_G_H5 = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhhddddddddddddddddddddddffffddddSdddcccddhhddddccdccdddddddddddd"; 
static const char * FORMAT_ALT_G_EP = "cdddddSddddffdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddfccdhdddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd"; 
static const char * FORMAT_ALT_G_CL = "cdddddSddddffddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddccdhdddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd"; 

	 static const char * FORMAT_ALT_G_CL1= "cdddddSddddffdddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddddfffffffffffffffffffffffffffffffffccdhdddddddddddddddddddddddffffddddSdddcccddhhddddccdccddhhhhhhhhdd"; 
	 //infinity ^


//2008 smeli formats
static const char * FORMAT_PET_INVENTORY_UPDATE_7 ="hhdddhhhdhhdddddddd";
static const char * FORMAT_INVENTORY_UPDATE_8 ="hhddddhhhdhhdddddddddd";
//kama static const char * FORMAT_INVENTORY_UPDATE_7 ="hhdddhhhdhhdddddddddd";
static const char * FORMAT_INVENTORY_UPDATE_6 ="hhdddhhhdhhdd";
static const char * FORMAT_INVENTORY_UPDATE_4 ="hhdddhhhdhh";
static const char * FORMAT_PET_INVENTORY_LIST_7 ="hdddhhhdhhdddddddd";
//static const char * FORMAT_PET_INVENTORY_LIST_4 ="hdddhhhdhh";



static const char * FORMAT_INVENTORY_LIST_8 ="hddddhhhdhhdddddddddd";
//kama  static const char * FORMAT_INVENTORY_LIST_7 ="hdddhhhdhhdddddddddd";
  static const char * FORMAT_INVENTORY_LIST_6 ="hdddhhhdhhdd";
  static const char * FORMAT_INVENTORY_LIST_4 ="hdddhhhdhh";


//kamael
//static const char * FORMAT_TRADE_7a = "hhdddhhdhhhdddddddd";
static const char * FORMAT_TRADE_7b = "hdddhhdhhhdddddddd";
static const char * FORMAT_TRADE_7u = "hddhhhdhhhhhhhhdddddddd";

static const char * FORMAT_BUYSELL_7a = "hdddhhdhhhddddddddd";
static const char * FORMAT_BUYSELL_7b = "hdddhhddddddddd";

static const char * FORMAT_PRIVATE_STORE_7a = "ddddhhhdddddddddd";
static const char * FORMAT_PRIVATE_STORE_7b = "ddddhhhddddddddddd";
static const char * FORMAT_PRIVATE_STORE_7c = "dhddhdhdddddddd";
static const char * FORMAT_PRIVATE_STORE_7d = "dhddhdhdddddddddd";
static const char * FORMAT_PRIVATE_STORE_7e = "ddddhhhddddddddddd";
static const char * FORMAT_PRIVATE_STORE_7f = "ddhddhdhdddddddddd";

//interlude shortcuts
//static const char * FORMAT_SHORTCUT_INF_ACTION_6 ="dddd";
//static const char * FORMAT_SHORTCUT_INF_SKILL_6 ="ddddcd";
static const char * FORMAT_SHORTCUT_INF_ITEM_6 ="dddddddhh";
static const char * FORMAT_SHORTCUT_INF_ITEM_TAUTI ="dddddddhhd";
//static const char * FORMAT_SHORTCUT_INF_ITEM_INFIN ="dddddddd";
static const char * FORMAT_SHORTCUT_INF_ITEM_INFIN1 ="dddddddddd";

//protocol version CT ????????????
//static const char * FORMAT_PROTOCOL_4="cddd";
//static const char * FORMAT_PROTOCOL_5Q="cQdd";
//static const char * FORMAT_PROTOCOL_7Q="cQddcd";


//petinfo
  

//   static const char * FORMAT_PETINFO_4= "cdddddddddddddddddddffffdddcccccSSdddddddddddddddddddddddddddddddccccccddd";

				                    //l2j cdddddddddddddddddddffffdddcccccSSdddddddddddddddddddddddddddhchcdd
   static const char * FORMAT_PETINFO_4= "cdddddddddddddddddddffffdddcccccSSdddddddddddddddddddddddddddhchcddd";  //+d ct 1.5
  static const char * FORMAT_PETINFO_5Q= "cdddddddddddddddddddffffdddcccccSSddddddddddddddddddddddddddddddhchcddd";  //+d ct 1.5
  
   static const char * FORMAT_PETINFO_H5= "cdddddddddddddddddddffffdddcccccdSdSddddddddddddddddddddddddddddddhchcddd";  //+d ct 1.5
static const char * FORMAT_PETINFO_Awake= "cdddddddddddddddddddffffdddcccccdSdSdddddddddddddddddddddddddddddddddhchcddddddddc";  
//                                                                                                       ^^^ GOD Awakening

  static const char * FORMAT_PETINFO_Tauti= "cdddddddddddddddddddffffdddcccccdSdSdddddddddddddddddddddddddddddddddccdddddddddddc";  
static const char * FORMAT_PETINFO_Lind558= "ccddcddddcddhhhhhhhhffffdddcccccdSdSccddddddddcdddddddddddddddddddddcccccddccdhhhhc";  
static const char * FORMAT_PETINFO_Epei575= "ccddcddddcddhhhhhhhhffffdddcccccdSdSccdddddddddcdddddddddddddddddddddcccccddccdhhhhc";  
static const char * FORMAT_PETINFO_Classic= "ccddddddddhhhhhhhhffffdddcdSdScdddddddddcdddddddddddddddddddddccccddcchhhhhc";  




  static const char * FORMAT_RIDE_7="cdddd"; //+ddd?;
  static const char * FORMAT_RIDE_7_XYZ="cddddddd"; 




//0x22
//   ddddddddddddddddddffffdddcccccSSddd dddddc //c2
//   ddddddddddddddddddffffdddcccccSSddd dddddccffd  //c3
//   ddddddddddddddddddffffdddcccccSSddd dddddccffd ddd //c6
static const char * FORMAT_NPC_INFO_6=     "cddddddddddddddddddffffdddcccccSSddddddddccffddddd";
static const char * FORMAT_NPC_INFO_CT2F=  "cddddddddddddddddddffffdddcccccSSddddddddccffddddccd";
static const char * FORMAT_NPC_INFO_Awake= "cddddddddddddddddddffffdddcccccdSdSddddddddccffddddccddddddd";
                                                                                 
static const char * FORMAT_NPC_INFO_Tauti= "cddddddddddddddddddffffdddcccccdSdSddddddddccffddddccddddddcdddddddddd";
//                                          dddddddddddddddddddffffdddcccccSSddddddddccffddddccd
                                                                                    
//static const char * FORMAT_NPC_INFO_Classic= "cdccccccccccdhhdddddddffdddcccddddcddddd";


//pet infupdate
static const char * FORMAT_PETINFO_UPD_4="cdddddSdddddddddd";
//static const char * FORMAT_PETINFO_UPD_5="cdddddSdddddddQQQ";
static const char * FORMAT_PETINFO_UPD_5=  "cdddddSdddddddfff";


//multisell
static const char * FORMAT_MULTISELL_3b="dhdhddb"; //dhdhdhhb
static const char * FORMAT_MULTISELL_4b="dchhhdhdhb";
static const char * FORMAT_MULTISELL_6b="dddchhhdhdhddb"; 
static const char * FORMAT_MULTISELL_4a="hhdh";
static const char * FORMAT_MULTISELL_6a="hhdhdd"; // +dd

static const char * FORMAT_MULTISELL_7a="dhdhdddddddddd"; // +dd
static const char * FORMAT_MULTISELL_7b="dchddddddddddhhddhdhddddddddddb"; 


static const char * FORMAT_WAREHOUSE_6="hdddhhdhhhddd";
static const char * FORMAT_WAREHOUSE_7="hdddhhdhhhdddddddddddd";
  static const char * FORMAT_PACKAGE_7="hdddhhdhhhddddddddd";



//2009 smeli formats
static const char * FORMAT_INVENTORY_UPDATE_9 ="hhddddhhhdhhddddddddddd"; // Gracia +d
static const char * FORMAT_INVENTORY_LIST_9 ="hddddhhhdhhddddddddddd";

static const char * FORMAT_WAREHOUSE_9="hdddhhdhhhddddddddddddd"; // Gracia +d

static const char * FORMAT_DOOR_STATUS_7="cddddddddddd"; 
static const char * FORMAT_DOOR_INFO_7="cdd"; 
static const char * FORMAT_MYTARGET_SELECTED_7="cdhd";
static const char * FORMAT_MYTARGET_SELECTED_CRUSADE="cddhd";
static const char * FORMAT_TARGET_SELECTED_7="cdddddd";


//-------------------------------------------------------------------
//Gracia Final 2008
//-------------------------------------------------------------------
//

//PET inventory OK
//static const char * FORMAT_PET_INVENTORY_LIST_7  ="hdddhhhdhhdddddddd";
static const char * FORMAT_PET_INVENTORY_LIST_CT2F ="hddddhhhdhhdddddddd";
//                                                    dddQhhhdhhhhhhhhhh
//static const char * FORMAT_PET_INVENTORY_UPDATE_7  ="hhdddhhhdhhdddddddd";
static const char * FORMAT_PET_INVENTORY_UPDATE_CT2F ="hhddddhhhdhhdddddddd";
//                                                       dddQhhhdhhhhhhhhhh


//buy/sell OK
//static const char * FORMAT_BUYSELL_CT2Fa = "hdddhhdhhhddddddddd";
//static const char * FORMAT_BUYSELL_CT2Fb = "hdddhhddddddddd";
static const char * FORMAT_BUYSELL_CT2Fc =   "cdddhb";
//commented for test purposes
static const char * FORMAT_BUYSELL_CT2Fa =   "hddddhhdhhhdddddddddd";
static const char * FORMAT_BUYSELL_CT2Fb =   "hddddhhdddddddddd";




//inventory OK
static const char * FORMAT_INVENTORY_UPDATE_CT2F ="hhdddddhhhdhhhhdddddddddd";
//static const char * FORMAT_INVENTORY_LIST_CT2F ="hdddddhhhdhhhhdhhhhhhhhd";
//static const char * FORMAT_INVENTORY_LIST_CT2F ="hdddddhhhdhhhhdddddddddd";
static const char * FORMAT_INVENTORY_LIST_CT2F =  "hdddddhhhdhhhhdddddddddd";




//trade OK, used FAKE packet on sendtradable list
//static const char * FORMAT_TRADE_CT2FA = "hhddddhhdhhhdddddddd";
static const char * FORMAT_TRADE_CT2FB = "hddddhhdhhhdddddddd";
static const char * FORMAT_TRADE_CT2FA1 = "hhddddhhdhhh";
static const char * FORMAT_TRADE_CT2FB1 = "hddddhhdhhh";
static const char * FORMAT_TRADE_Classic_A1 = "hhddddccddhhh";
static const char * FORMAT_TRADE_Classic_B1 = "hddddccddhhh";
//                                        hddQhhdhhhhhhhhhhh

//trade update... not used
//static const char * FORMAT_TRADE_CT2Fu = "hddhhhdhhhhhhhhdddddddd";
//                                          hddhhhdhhhhhhhhdddddddd
//                                             ^count?

static const char * FORMAT_TRADE_Saviors_A1 = "hcddcddcchddccddc";
static const char * FORMAT_TRADE_Saviors_B1 =  "cddcddcchddccddc";


//warehouse FAKE packet
//warehouse  hddQhhdhhhdddhhhhhhhhdd 
 static const char * FORMAT_WAREHOUSE_CT2F= "hddddhhdhhhddddddddddddd"; // Gracia +d

//                                          hddQhhdhhhdddhhhhhhhhdd
//static const char * FORMAT_WAREHOUSE_CT2Fake= "hdddhhdhhhdddddddddddddd"; // 

static const char * FORMAT_WAREHOUSE_CT2Fa="chddhb";
static const char * FORMAT_WAREHOUSE_CT2Fb="cddddhb"; //ex (unused???? in server???)

static const char * FORMAT_WAREHOUSE_Awake_withdraw ="chddhdb"; //GF:"chddhb"  
static const char * FORMAT_WAREHOUSE_Awake_deposit = "chdddhb"; //GF:"chddhb"

   static const char * FORMAT_WAREHOUSE_Glory_withdraw ="chddhhdb";  
 //static const char * FORMAT_WAREHOUSE_Classic_withdraw ="chddhhb";
 




//static const char * FORMAT_WAREHOUSE_CT2FGM="hddddhhd";
static const char * FORMAT_WAREHOUSE_CT2FGMa="cSddhb";
static const char * FORMAT_WAREHOUSE_Lindvior_GMa="cSdddhhb";



//multisell OK
//multisell ?d? dchddhhhhhhhhhhddhQhddhhhhhhhh dhQhddhhhhhhhh //ct2.3
static const char * FORMAT_MULTISELL_CT2Fa="dhddhdddddddddd"; // (+d)
//                                          dhQhddhhhhhhhh
static const char * FORMAT_MULTISELL_CT2Fb="dchddddddddddhhddhddhddddddddddb"; //+d
//                                          dchddhhhhhhhhhhddhQhddhhhhhhhh



   static const char * FORMAT_SPAWNITEM_Crusade=  "cdddddddddccc";

   static const char * FORMAT_DROPITEM_CT2F="cdddddddddd";
static const char * FORMAT_DROPITEM_Classic="cddddddcddc";
static const char * FORMAT_DROPITEM_Crusade="cddddddcddcccc";


//private store OK
//cdQd
static const char * FORMAT_PRIVATE_STORE_CT2Fa = "dddddhhhddddddddddd";
//                                                dddQhhhdQdddddddd			//OK pstore manage sell 1
static const char * FORMAT_PRIVATE_STORE_CT2Fb = "dddddhhhddddddddddddd";
//                                                dddQhhhdQQdddddddd		//OK pstore manage sell2
static const char * FORMAT_PRIVATE_STORE_CT2Fc = "dhddddhdhdddddddd";
//                                                dhQQhdhhhhhhhhh			//OK pstore manage buy1
static const char * FORMAT_PRIVATE_STORE_CT2Fd = "dhddddhdhdddddddddddd";
//                                                dhQQhdhQQhhhhhhhh 		//OK pstore manage buy2
static const char * FORMAT_PRIVATE_STORE_CT2Fe = "dddddhhhddddddddddddd";
//                                                dddQhhhdQQdddddddd  		//OK pstore add sell
static const char * FORMAT_PRIVATE_STORE_CT2Ff = "ddhddddhdhdddddddddddd";
//                                                ddhQQhdhQQhhhhhhhh  		//OK pstore add buy




static const char * FORMAT_PRIVATES_SELLM_CT2F = "cdddddbdb";
static const char * FORMAT_PRIVATES_BUYM_CT2F =  "cddddbdb";
static const char * FORMAT_PRIVATES_SELL_CT2F =  "cdddddb";
static const char * FORMAT_PRIVATES_BUY_CT2F =   "cddddb";



//air vehicle
static const char * FORMAT_VEHICLEG =  "cdddddd";
static const char * FORMAT_VEHICLEG1 =  "cddddddd";
static const char * FORMAT_VEHICLEA =  "chddddd"; //air vehicle
static const char * FORMAT_VEHICLEA1 =  "chdddddd";

static const char * FORMAT_VEHICLEA2a =  "chddddddddddddddddd";
static const char * FORMAT_VEHICLEG2a =  "cdddddddddddddddddd";


static const char * FORMAT_QUESTLIST_CT2F="ddddd"; //original "dddd"
static const char * FORMAT_QUESTLIST_CH_CRUSADE="cdbhb"; //original "chbhb"
//static const char * FORMAT_QUESTLIST_LINDVIOR="c";
//static const char * FORMAT_QUESTLIST_LINDVIOR2="cShbffffffffffffffffhb"; //cShbhb
//                                      
//--------------------------------------------------------------------


static const char * FORMAT_TutorialShowQuestionMark_Saviors = "ccd";

//-------------------------------------------------------------------
//Gracia Final 2009
//-------------------------------------------------------------------
//

//PET inventory OK
//static const char * FORMAT_PET_INVENTORY_LIST_7  ="hdddhhhdhhdddddddd";
static const char * FORMAT_PET_INVENTORY_LIST_CT2FF ="hddddhhhdhhhhhhhhhh"; //ok?
//                                                     dddQhhhdhhhhhhhhhh   //CT2FF 
static const char * FORMAT_PET_INVENTORY_LIST_Freya  ="dddddhhhdhhfdffhhh"; //ok?
//static const char * FORMAT_PET_INVENTORY_LIST_Awake  ="dddddhhhdhhfdhffhhh"; //ok?
static const char * FORMAT_PET_INVENTORY_LIST_Awake  ="dddddhhhdhhfdhffhhhd"; //ok? GOD American
static const char * FORMAT_PET_INVENTORY_LIST_GD4Ep  ="ddcddccccddhfdcffhhhd"; //ok? GOD American


//static const char * FORMAT_PET_INVENTORY_UPDATE_7  ="hhdddhhhdhhdddddddd";
static const char * FORMAT_PET_INVENTORY_UPDATE_CT2FF ="hhddddhhhdhhhhhhhhhh"; //ok??
                                                       //dddQhhhdhhhhhhhhhh  //CT2FF 

static const char * FORMAT_PET_INVENTORY_UPDATE_Freya  ="hdddddhhhdhhfdffhhh"; //ok??
//static const char * FORMAT_PET_INVENTORY_UPDATE_Awake  ="hdddddhhhdhhfdhffhhh"; //ok??
static const char * FORMAT_PET_INVENTORY_UPDATE_Awake  ="hdddddhhhdhhfdhffhhhd"; //ok?? GOD AMERICAN
static const char * FORMAT_PET_INVENTORY_UPDATE_GD4Ep  ="hddcddcccddhfdcffhhhd"; //ok?? GOD AMERICAN


//-1h item type1
//-4h kamael
//+3d freya
//+3h freya


//buy/sell OK
static const char * FORMAT_BUYSELL_CT2FFb =   "hddddhhddhhhhhhhh"; // ok?
static const char * FORMAT_BUYSELL_CT2FFa =   "hddddhhdhhhddhhhhhhhh"; // ok?
//Qd                                            hddQhhdhhhQhhhhhhhh //CT2FF

//freya: hddQhhdhhhQhhhhhhhh                                               
static const char * FORMAT_BUYSELL_CT3Awake_b =   "hddddhhddhff"; // ok?
static const char * FORMAT_BUYSELL_CT3Awake_a =   "hddddhhdhhhddhff"; // ok?


   static const char * FORMAT_BUYSELL_Classic =   "cddcddcchddccddcdd"; // ok?
  // static const char * FORMAT_BUYSELL_Classic_sell =   "chddhb";
   static const char * FORMAT_BUYSELL_Classic_sell =   "chddhb";
   static const char * FORMAT_BUYSELL_Classic_buy =   "chdddddhb";


   static const char * FORMAT_BUYSELL_Lind558 =   "dddddhhhdhhdddhhfffdd"; // ok?
   static const char * FORMAT_BUYSELL_GD4Ep =     "ddcddccccddhdddchfffdd"; // ok?
//hddddhhdhhhddhff


//inventory OK
   static const char * FORMAT_INVENTORY_UPDATE_CT2FF ="hhdddddhhhdhhhhdhhhhhhhhd"; //ok
//static const char * FORMAT_INVENTORY_LIST_CT2FF ="hdddQhhhdhhhhdhhhhhhhhd";
                                               //SdhhdddQhhhdhhhhdhhhhhhhhd c2FF GMview itemlist
static const char * FORMAT_INVENTORY_UPDATE_CT2Freya  ="hdddddhhhdhhfdffhhh"; //ok?
//static const char * FORMAT_INVENTORY_UPDATE_CT3Awake  ="hdddddhhhdhhfdhffhhh"; //ok? KOR
static const char * FORMAT_INVENTORY_UPDATE_CT3Awake  ="hdddddhhhdhhfdhffhhhd"; //ok AMERICAN
   static const char * FORMAT_INVENTORY_UPDATE_GD4Ep  ="hddcddccccddhfdcffhhhd"; //ok AMERICAN



//static const char * FORMAT_INVENTORY_LIST_CT2FF ="hdddddhhhdhhhhdddddddddd";
  static const char * FORMAT_INVENTORY_LIST_CT2FF =     "hdddddhhhdhhhhdhhhhhhhhd"; //ok
//static const char * FORMAT_INVENTORY_LIST_CT2EPnew =  "hdddddhhhdhhhhdhhhhhhhhdhhh"; //ok?												
  static const char * FORMAT_INVENTORY_LIST_CT2Freya =   "dddddhhhdhhfdffhhh"; //ok?												
  //static const char * FORMAT_INVENTORY_LIST_CT3Awake =   "dddddhhhdhhfdhffhhh"; //ok?	KOR
  static const char * FORMAT_INVENTORY_LIST_CT3Awake =   "dddddhhhdhhfdhffhhhd"; //ok	AMERICAN
  static const char * FORMAT_INVENTORY_LIST_GD4Ep    =   "ddcddccccddhfdcffhhhd"; 									


   static const char * FORMAT_INVENTORY_LIST_Classic =   "cddcddcchddccddc"; //ok?										
 static const char * FORMAT_INVENTORY_UPDATE_Classic  = "hcddcddcchddccddc"; //

static const char * FORMAT_PET_INVENTORY_UPDATE_Classic  ="hcddcddcchddccddc"; //ok??
   static const char * FORMAT_PET_INVENTORY_LIST_Classic  ="cddcddcchddccddc"; //ok? 
	




//---static const char * FORMAT_INVENTORY_LIST_CT3Awake_c =   "chhbhc"; //ok?	AMERICAN 4F23B9										
//---static const char * FORMAT_INVENTORY_LIST_CT3Awake_b =   "chhbhc"; //ok?	AMERICAN 4F23E9										
//---static const char * FORMAT_INVENTORY_LIST_CT3Awake_a =   "cShhbhc"; //ok?	AMERICAN 4F2448										


static const char * FORMAT_SETUPGAUGE_Freya = "cdddd";
//static const char * FORMAT_SETUPGAUGE_C2 = "cddd"; //c1: cdd



//trade OK, used FAKE packet on sendtradable list
//static const char * FORMAT_TRADE_CT2FFA = "hhddddhhdhhhhhhhhhhh"; //ok?
static const char * FORMAT_TRADE_CT2FFB = "hddddhhdhhhhhhhhhhh"; //ok??
//                                          hddQhhdhhhhhhhhhhh

//static const char * FORMAT_TRADE_FreyaA = "hhddddhhdhhhffhhh"; //add
static const char * FORMAT_TRADE_FreyaB = "hddddhhdhhhffhhh"; //add
static const char * FORMAT_TRADE_FreyaC = "dddddhhhdhhfdffhhh"; //send trade list

//static const char * FORMAT_TRADE_AwakeningA = "hhddddhhdhhhhffhhhd"; //add
//static const char * FORMAT_TRADE_AwakeningB = "hddddhhdhhhhffhhhd"; //add
static const char * FORMAT_TRADE_AwakeningC = "dddddhhhdhhfdhffhhhd"; //send trade list

//static const char * FORMAT_TRADE_GD4EpA = "hhddddhhdhhhhffhhhd"; //add
//static const char * FORMAT_TRADE_GD4EpB = "hddddhhdhhhhffhhhd"; //add
static const char * FORMAT_TRADE_GD4EpC = "ddcddccccddhfdcffhhhd"; //send trade list



//warehouse FAKE packet
//warehouse  hddQhhdhhhdddhhhhhhhhdd 
   static const char * FORMAT_WAREHOUSE_CT2FF= "hddddhhdhhhdddhhhhhhhhdd"; // ok??
//                                            hddQhhdhhhdddhhhhhhhhdd
//static const char * FORMAT_WAREHOUSE_CT2FFake= "hdddhhdhhhddddhhhhhhhhdd"; //ok? 

    static const char * FORMAT_WAREHOUSE_CT25=      "dddddhhdhhhfdffhhhd"; // ok??
	static const char * FORMAT_WAREHOUSE_CT3Awake=  "dddddhhdhhhfdhffhhhdd"; // ok??
	static const char * FORMAT_WAREHOUSE_GD2Glory_withdr=  "dddddhhdhhhfdhffhhhdddd"; // ok??
	static const char * FORMAT_WAREHOUSE_Lindvior_withdr=  "dddddhhhdhhfdhffhhhdddd"; // ok??
	   static const char * FORMAT_WAREHOUSE_GD4Ep_withdr=  "ddcddccccddhfdcffhhhdddd"; // ok??

	static const char * FORMAT_WAREHOUSE_Classic_withdr=   "cddcddcchddccfcddd"; // ok??

      //static const char *  FORMAT_PACKAGE_Classic="cddcddcchddccfcd";

//static const char * FORMAT_WAREHOUSE_Lindvior_withdr=  "dddddhhhdhhfdhfffhddd"; // ok??

//static const char * FORMAT_WAREHOUSE_Lindvior_withdr=  "hddddddhhhdhhfdhfffhdh"; // ok??
static const char * FORMAT_WAREHOUSE_Lindvior_dep= "dddddhhdhhhfdhffhhhdd"; // ok??
   static const char * FORMAT_WAREHOUSE_GD4Ep_dep= "ddcddccccddhfdcffhhhdd"; // ok??
static const char * FORMAT_WAREHOUSE_Lindvior_GM=  "dddddhhhdhhfdhffhhhdd"; // ok??
   static const char * FORMAT_WAREHOUSE_GD4Ep_GM=  "ddcddccccddhfdcffhhhdd"; // ok??

//   static const char * FORMAT_WAREHOUSE_Classic_dep=  "cdddddhhhddhhfhd"; // ok??
    static const char * FORMAT_WAREHOUSE_Classic_dep=   "cddcddcchddccfcd"; // ok??



//-1h item type1
//-1h 0
//-2d object id add
//-4h
//+4(3h1d)

//dddQhhhdQhhhhhhhhdddQhhhdQQhhhhhhhh //CT2FF
	    static const char * FORMAT_PACKAGE_CT2F= "hddddhhdhhhddddddddd";
		static const char * FORMAT_PACKAGE_CT2FF="hddddhhdhhhdhhhhhhhh";
 //                                             ddQhhdhhhdhhhhhhhh
		static const char * FORMAT_PACKAGE_CT2Fc =   "cddddb";

     static const char * FORMAT_PACKAGE_CT2Freya="dddddhhdhhhfdffhhhd";
	 static const char * FORMAT_PACKAGE_CT3Awake="dddddhhdhhhfdhffhhhdd";
	    static const char * FORMAT_PACKAGE_GD4Ep="ddcddccccddhfdcffhhhdd";
//-1h type
//+1d slot id
//-4h elements
//+3h enchant

//friendlist awake
 static const char * FORMAT_L2FRIENDLIST_GD ="dSddddh"; //"dSdddd";
static const char * FORMAT_L2FRIENDLIST_Add ="cddSddddh"; //cd
static const char * FORMAT_L2FRIENDLIST_Remove ="cdS"; //cd


//multisell OK
//multisell ?d? dchddhhhhhhhhhhddhQhddhhhhhhhh dhQhddhhhhhhhh //ct2.3
    static const char * FORMAT_MULTISELL_CT2FFa="dhddhddhhhhhhhh"; // ok??
    //static const char * FORMAT_MULTISELL_CT2Freya_a="dhddhdddddd"; // ok??
	static const char * FORMAT_MULTISELL_CT2Freya_a="dhddhddff"; // ok??
//	static const char * FORMAT_MULTISELL_CT2Awake_a="dhddhddhff"; // ok??
	 static const char * FORMAT_MULTISELL_Classic_a="dhddhddff"; // ok??											


    static const char * FORMAT_MULTISELL_CT2FFb="dchddhhhhhhhhhhddhddhddhhhhhhhhb"; //ok??
//    static const char * FORMAT_MULTISELL_CT2Freya_b="dchddddddhhddhddhddddddb"; //ok??
    static const char * FORMAT_MULTISELL_CT2Freya_b="dchddffhhddhddhddffb"; //ok??
	static const char * FORMAT_MULTISELL_CT2Awake_b="dchddffhhddhddhdddffb"; //ok??
	 static const char * FORMAT_MULTISELL_Classic_b="dchddffhhdddhddhdddffb"; //ok??


static const char * FORMAT_MULTISELL_CT2Awake_c="cdddddcb"; //ok??
static const char * FORMAT_MULTISELL_Classic_c="cdcddddcb"; //ok??


static const char * FORMAT_MULTISELL_Splendor2_a="dhddhddffh"; // ok??
static const char * FORMAT_MULTISELL_Splendor2_b="dchddffhhhdddhddhdddffhb"; //ok??
//static const char * FORMAT_MULTISELL_Splendor2_c="cdcddddcb"; //ok??
static const char * FORMAT_MULTISELL_Saviors_c=    "ccdcddddcdb"; //ok??
static const char * FORMAT_MULTISELL_Saviors_d=    "chd"; //new packet


static const char * FORMAT_PartySmallWindowAdd_AWAKE="cdddSdddddddddddddd"; //cdddSdddddddddd c4 
//static const char * FORMAT_UpdateWindow_AWAKE = "cdSdddddddddd"; //cdSdddddddd c4
static const char * FORMAT_OpenAllWindow_AWAKE = "dSddddddddddddddd"; //dSdddddddddd c4



static const char * FORMAT_PartySmallWindowAdd_Classic="cdddSdddddddchch"; 
static const char * FORMAT_UpdateWindow_Classic = "cdccddddddchd"; 
static const char * FORMAT_OpenAllWindow_Classic = "dSdddddddchchd"; 
static const char * FORMAT_OpenAllWindow_Classic_Main="cdccb";


	//                                          dchddhhhhhhhhhhddhQhddhhhhhhhh

//          	writeD(ent.getEntryId());
  //          	writeC(ent.stackable());
    //           writeH(0x00); // C6
//                writeD(0x00); // C6
  //              writeD(0x00); // T1
    //            writeH(65534); // T1
      //          writeH(0x00); // T1
        //        writeH(0x00); // T1
          //      writeH(0x00); // T1
            //    writeH(0x00); // T1
              //  writeH(0x00); // T1
//                writeH(0x00); // T1
  //              writeH(0x00); // T1
    //        	writeH(ent.getProducts().size());
      //      	writeH(ent.getIngredients().size());



//final    dchddhhhhhhhhhh
//epilogue dchddhhhhhhhhhh
//freja    dchddhhhhhhhhhh

//final    ddhQhddhhhhhhhh
//epilogue ddhQhddhhhhhhhh
//freja    ddhQhddhhhhhhhh

//final    dhQhddhhhhhhhh
//epilogue dhQhddhhhhhhhh
//freja    dhQhddhhhhhhhh



//                                           dhQhddhhhhhhhh





//private store OK
//cdQd
static const char * FORMAT_PRIVATE_STORE_CT2FFa = "dddddhhhdddhhhhhhhh"; //??
//                                                dddQhhhdQdddddddd			//OK pstore manage sell 1
static const char * FORMAT_PRIVATE_STORE_CT2FFb = "dddddhhhdddddhhhhhhhh"; //??
//                                                dddQhhhdQQdddddddd		//OK pstore manage sell2
static const char * FORMAT_PRIVATE_STORE_CT2FFc = "dhddddhdhhhhhhhhh"; //??
//                                                dhQQhdhhhhhhhhh			//OK pstore manage buy1
static const char * FORMAT_PRIVATE_STORE_CT2FFd = "dhddddhdhddddhhhhhhhh"; //??
//                                                dhQQhdhQQhhhhhhhh 		//OK pstore manage buy2
static const char * FORMAT_PRIVATE_STORE_CT2FFe = "dddddhhhdddddhhhhhhhh"; //??
//                                                dddQhhhdQQdddddddd  		//OK pstore add sell
static const char * FORMAT_PRIVATE_STORE_CT2FFf = "ddhddddhdhddddhhhhhhhh"; //??
//                                                ddhQQhdhQQhhhhhhhh  		//OK pstore add buy

static const char * FORMAT_PRIVATE_STORE_CT2Freya_a = "dddddhhhdhhfdffhhhdd"; //??

//-4h elements
//+3d mana
//+3h enchant eff
//+1d location slot
//+1h custom type 2
//==============
//total + 4values = 10h to esp


static const char * FORMAT_PRIVATE_STORE_CT2Freya_b = "dddddhhhdhhfdffhhhdddd"; 
//-4h elements
//+3d mana
//+3h enchant eff
//+1d location slot
//+1h custom type 1
//+1h custom type 2
//==============
//total + 5values = 14h to esp


static const char * FORMAT_PRIVATE_STORE_CT2Freya_c = "dddddhhhdhhfdffhhhdd";
//-4h elements
//+3h enchants
//+1d object id
//+1h equiped
//-1h damaged

//+3d mana
//+1h custom type 1
//+1d location slot
//+1h custom type2
//==============
//total + 6values = 18h to esp

static const char * FORMAT_PRIVATE_STORE_CT2Freya_d = "dddddhhhdhhfdffhhhdddddd";
//-4h elements
//+3h enchants
//+1d object id
//-1h damaged
//+1h custom type1
//+2d + count
//-2d - ref price

//+3d mana
//+1h custom type2
//+1d location slot
//+1h enchant level
//==============
//total + 6values = 18h to esp

static const char * FORMAT_PRIVATE_STORE_CT2Freya_e = "dddddhhhdhhfdffhhhdddd"; //??
//-4h elements
//+3h enchants
//+1h custom type1

//+3d mana
//+1h custom type2
//+1d locslot
//==============
//total + 5values = 14h to esp



static const char * FORMAT_PRIVATE_STORE_CT2Freya_f = "dddddhhhdhhfdffhhhddddddd"; //??
//-4h elements
//+3h enchants
//+1h custom type1

//+3d mana
//+1h custom type2
//+1d locslot
//+1d objectid addon
//==============
//total + 6values = 18h to esp

static const char * FORMAT_PRIVATES_SELL_Awake =  "cddddddb";
static const char * FORMAT_PRIVATES_BUY_Awake =   "cdddddb";


//remove ffhhhd from tail
//remove augment d before our last c and add slot d
 //add c at the beginning
  //  static const char * FORMAT_TRADE_ClassicC = "dddddhhhddhhfdh"; //send trade list
   static const char * FORMAT_TRADE_ClassicC =    "cddcddcchddccfc"; //send trade list
  //static const char * FORMAT_TRADE_AwakeningC = "dddddhhhdhhfdhffhhhd"; //send trade list

//  static const char * FORMAT_TRADE_Classic1 =    "cdchb"; 
     static const char * FORMAT_TRADE_Classic0 =    "cddb"; 

//classic item: cddcddcchddccddc  -> cddcddcchddccfc
//remove ffhhhd from tail
//remove augment d before our last c and add slot d
//add c at the beginning
//total removal 8, addition 1
static const char * FORMAT_PRIVATE_STORE_Classic_a = "cddcddcchddccfcdd"; //??
static const char * FORMAT_PRIVATE_STORE_Classic_b = "cddcddcchddccfcdddd"; 
static const char * FORMAT_PRIVATE_STORE_Classic_c = "cddcddcchddccfcdd";
static const char * FORMAT_PRIVATE_STORE_Classic_d = "cddcddcchddccfcdddddd"; //Send:0xb7 0xbd, PrivateStoreBuyManageList section3
static const char * FORMAT_PRIVATE_STORE_Classic_e = "cddcddcchddccfcdddd"; //??
//total removal 7, addition 1
static const char * FORMAT_PRIVATE_STORE_Classic_f = "cddcddcchddccfcddddddd"; //?? keep esp 7Ch



static const char * FORMAT_PRIVATE_STORE_CT3Awake_a = "dddddhhhdhhfdhffhhhddd"; //??
static const char * FORMAT_PRIVATE_STORE_CT3Awake_b = "dddddhhhdhhfdhffhhhddddd"; 
static const char * FORMAT_PRIVATE_STORE_CT3Awake_c = "dddddhhhdhhfdhffhhhddd";
static const char * FORMAT_PRIVATE_STORE_CT3Awake_d = "dddddhhhdhhfdhffhhhddddddd";
static const char * FORMAT_PRIVATE_STORE_CT3Awake_e = "dddddhhhdhhfdhffhhhddddd"; //??
//static const char * FORMAT_PRIVATE_STORE_CT3Awake_f = "dddddhhhdhhfdhffhhhdddddddd"; //?? esp must be over 7Ch
  static const char * FORMAT_PRIVATE_STORE_CT3Awake_f = "dddddhhhdhhfdhffhddddddddd"; //?? keep esp 7Ch

static const char * FORMAT_PRIVATE_STORE_GD4Ep_a = "ddcddccccddhfdcffhhhddd"; //??
static const char * FORMAT_PRIVATE_STORE_GD4Ep_b = "ddcddccccddhfdcffhhhddddd"; 
static const char * FORMAT_PRIVATE_STORE_GD4Ep_c = "ddcddccccddhfdcffhhhddd";
static const char * FORMAT_PRIVATE_STORE_GD4Ep_d = "ddcddccccddhfdcffdhddddddd"; //hhh->dh keep esp 7Ch
static const char * FORMAT_PRIVATE_STORE_GD4Ep_e = "ddcddccccddhfdcffhhhddddd"; //??
static const char * FORMAT_PRIVATE_STORE_GD4Ep_f = "ddcddcchddhfdcffdhdddddddd"; //hhh->dh keep esp 7Ch
													   //cccc->cch keep esp 7Ch


  static const char * FORMAT_PETSTATUSSHOW_GD1Awake="cdd";
   static const char * FORMAT_TUTORIALSHOWHTML_GD1Awake="cdS";

//--------------------------------------------------------------------
static const char * FORMAT_BBS4 = "ccSSSSSSS";
static const char * EX_FORMAT_SKILLAQUIRE_CT2F = "ddddd";
static const char * FORMAT_TELEPORTTOLOC_CT2F = "cdddddd";
static const char * FORMAT_SKILLAQUIRE_LIST_C4 = "cddb";
//static const char * FORMAT_SKILLAQUIRE_LIST_EPEI = "cddb";
static const char * FORMAT_SKILLAQUIRE_LIST_CLASSIC = "chhhb";
//static const char * FORMAT_SKILLAQUIRE_LIST_C4_S = "ddddd";
static const char * FORMAT_SKILLAQUIRE_LIST_EPEI_S = "dddddd";
static const char * FORMAT_SKILLAQUIRE_LIST_CLASSIC_S = "dhhcddc";
static const char * FORMAT_SKILLAQUIRE_INFO_CLASSIC = "cddddddb";




static const char * FORMAT_NPC_SAY_FREYA = "cddddS";
static const char * FORMAT_NPC_SAY_AWAKE = "cddddS";
static const char * FORMAT_PC_SAY_AWAKE = "cddSdS"; //was cddSS
static const char * FORMAT_WHISPER_CLASSIC = "cddSdScc"; //say2 private hear


static const char * FORMAT_RELATION_CHANGED_FREYA = "cdddddd";
static const char * FORMAT_RELATIONCHANGED_Classic= "ccddcdc";


static char * FORMAT_NPCHTML_CLASSIC = "cdSdd";

//---------------------------
// status update
//---------------------------
//static const char * FORMAT_STATUS_UPDATE = "cdddd";
//static const char * FORMAT_STATUS_UPDATE2 = "cdddddd";
static const char * FORMAT_STATUSU_Awake1="cdddddd"; 
static const char * FORMAT_STATUSU_Awake2="cdddddddd"; 
static const char * FORMAT_STATUSU_Lind558_1="cddcccd"; 
static const char * FORMAT_STATUSU_Lind558_2="cddcccdcd"; 


static const char * FORMAT_SKILLUSE_Classic = "cdddddddddddh"; 
static const char * FORMAT_SKILLUSE1_Classic ="cdddddddddddhb"; 
static const char * FORMAT_ABNORMAL_STUPDATE_Classic =    "dhdh"; 
static const char * FORMAT_ABNORMAL_STUPDATE_Infinity =    "dddh"; 


static const char * FORMAT_SKILLUSE_Awake = "cdddcddddddddh"; 
static const char * FORMAT_SKILLUSE1_Awake ="cdddcddddddddhb"; 
static const char * FORMAT_SKILLLAUNCHED_Awake="cdddddd";
//static const char * FORMAT_SKILLLAUNCHED3_Awake="cddddddb";
static const char * FORMAT_SKILLLAUNCHED4_Awake="cdddddb";
static const char * FORMAT_SKILLLAUNCHED4_Awake_fake="cddddd";


static const char * FORMAT_ATTACK_Awakening="cddcddddddh";
static const char * FORMAT_ATTACK_Awakening_b="cddcddddddhb";
static const char * FORMAT_ATTACK_Awakening_dddd="dddd";

static const char * FORMAT_ATTACK_Classic="cdddddddddh";
static const char * FORMAT_ATTACK_Classic_b="cdddddddddhb";



static const char * FORMAT_CREST_Lindvior="cdddb";
static const char * FORMAT_PLEDGEINFO_Lindvior="cddSS";


static const char * FORMAT_FRIENDADDREQUEST_Classic="ccS";


/*
//ini hooks
static BYTE PLEDGE_MAX_MEMBERS_L0 = 10; //PLEDGE_MAX_MEMBERS_L0 10
static BYTE PLEDGE_MAX_MEMBERS_L1 = 15; //PLEDGE_MAX_MEMBERS_L1 15
static BYTE PLEDGE_MAX_MEMBERS_L2 = 20; //PLEDGE_MAX_MEMBERS_L2 20
static BYTE PLEDGE_MAX_MEMBERS_L3 = 30; //PLEDGE_MAX_MEMBERS_L3 25 30
static BYTE PLEDGE_MAX_MEMBERS_L4 = 40; //PLEDGE_MAX_MEMBERS_L4 30 40
static BYTE PLEDGE_MAX_MEMBERS_L5 = 50; //PLEDGE_MAX_MEMBERS_L5 40 50
static BYTE ALLIANCE_MAX_CLANS = 3; //ALLIANCE_MAX_CLANS 5 12 
//player
static BYTE PLAYER_PENALTY_LEVEL80 = 80; //max level of C1 creatures
static BYTE PLAYER_PENALTY_LEVEL = 10; //PLAYER_PENALTY_LEVEL (default 5)
//enchant
static BYTE ENCHANT_SAFE_WEAPON = 7; //ENCHANT_SAFE_WEAPON 3
static BYTE ENCHANT_SAFE_STAFF = 7; //ENCHANT_SAFE_STAFF 3
static BYTE ENCHANT_SAFE_ARMOR = 8; //ENCHANT_SAFE_ARMOR 4
//timeouts
static DWORD PLEDGE_WAR_TIMEOUT = 1; //*24*60*60; //PLEDGE_WAR_TIMEOUT
static DWORD PLEDGE_OUST_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_OUST_PENALTY_TIMEOUT
static DWORD PLEDGE_WITHDRAW_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_WITHDRAW_PENALTY_TIMEOUT
static DWORD PLEDGE_OUSTED_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_OUSTED_PENALTY_TIMEOUT
static DWORD PLEDGE_RECHALLENGE_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_RECHALLENGE_PENALTY_TIMEOUT
static DWORD PLEDGE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT = 5; //*24*60*60; //PLEDGE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT
static DWORD PLEDGE_DISMISS_TIMEOUT = 7; //*24*60*60; //PLEDGE_DISMISS_TIMEOUT
static DWORD PLEDGE_DISMISS_PENALTY_TIMEOUT = 10; //*24*60*60; //PLEDGE_DISMISS_PENALTY_TIMEOUT
static DWORD ALLIANCE_DISMISS_TIMEOUT = 7; //*24*60*60; //UNKNOWN_TIMEOUT???
static DWORD ALLIANCE_OUST_PENALTY_TIMEOUT = 1; //*24*60*60; //ALLIANCE_OUST_PENALTY_TIMEOUT
static DWORD ALLIANCE_WITHDRAW_PENALTY_TIMEOUT = 1; //*24*60*60; //ALLIANCE_WITHDRAW_PENALTY_TIMEOUT
static DWORD ALLIANCE_OUSTED_PENALTY_TIMEOUT = 1; //*24*60*60; //ALLIANCE_OUSTED_PENALTY_TIMEOUT
static DWORD ALLIANCE_DISMISS_PENALTY_TIMEOUT = 10; //*24*60*60; //ALLIANCE_DISMISS_PENALTY_TIMEOUT
static DWORD ALLIANCE_RECHALLENGE_PENALTY_TIMEOUT = 5; //*24*60*60; //ALLIANCE_RECHALLENGE_PENALTY_TIMEOUT
static DWORD ALLIANCE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT = 5; //*24*60*60; //ALLIANCE_RECHALLENGE_DESPITE_REJECTION_PENALTY_TIMEOUT
static DWORD CASTLE_ANNOUNCE_TIME = 1*24*60*60; //CASTLE_ANNOUNCE_TIME
static DWORD CASTLE_STANDBY_TIME = 1*24*60*60; //CASTLE_STANDBY_TIME

static BYTE PLEDGE_WAR_MIN_LEVEL = 0; //3
static BYTE PLEDGE_WAR_MIN_MEMBERS = 1; //c1=5  c4=15

//static DWORD DEAD_LOCK1x = 0xEA60;
static DWORD DEAD_LOCK2x = 0x1D4C0;
static DWORD DEAD_LOCK3x = 0x2BF20;
*/

static DWORD OFFSET_USEROBJECT_USERINFO = 0x0F54;
static DWORD OFFSET_USERINFO_BUILDER = 1316;

//c4 suport simulnaeously with C5
//static int C4check = 0; //for back object id (134h) = 0= C5 greater C4 
//simple back object itemID=52 [hemp_cloak]
// jng = not more than, any cloak will make more
//		mov		edx, [ebx+0F54h]
//		mov		edx, [edx+134h] 
//static int C4check =0; //now this functionality disabled
//cause we will use back slot for TVT functionality

//For Send a StatusUpdate packet
static int STATUS_LEVEL = 0x01; 
static int STATUS_EXP = 0x02; 
static int STATUS_STR = 0x03; 
static int STATUS_DEX = 0x04; 
static int STATUS_CON = 0x05; 
static int STATUS_INT = 0x06; 
static int STATUS_WIT = 0x07; 
static int STATUS_MEN = 0x08; 
static int STATUS_CUR_HP = 0x09; 
static int STATUS_MAX_HP = 0x0a; 
static int STATUS_CUR_MP = 0x0b; 
static int STATUS_MAX_MP = 0x0c; 
static int STATUS_SP = 0x0d; 
static int STATUS_CUR_LOAD = 0x0e; 
static int STATUS_MAX_LOAD = 0x0f; 
static int STATUS_P_ATK = 0x11; 
static int STATUS_ATK_SPD = 0x12; 
static int STATUS_P_DEF = 0x13; 
static int STATUS_EVASION = 0x14; 
static int STATUS_ACCURACY = 0x15; 
static int STATUS_CRITICAL = 0x16; 
static int STATUS_M_ATK = 0x17; 
static int STATUS_CAST_SPD = 0x18; 
static int STATUS_M_DEF = 0x19; 
static int STATUS_PVP_FLAG = 0x1a; 
static int STATUS_KARMA = 0x1b; 
static int STATUS_CUR_CP = 0x21; 
static int STATUS_MAX_CP = 0x22; 



//--------------------------------------------------------------------------------------------
//// L2Server Internal 'Classes' and Functions
//--------------------------------------------------------------------------------------------
#define G_BROADCAST_OBJECT (__int32)0x0168AD244
#define G_WORLDPLANECOLLISION_OBJECT (__int32)0x016C6C5C0
//#define G_AREA_DB (__int32)0x0202F6BD8
#define G_GEODATA_OBJECT (__int32)0x018ACD030
#define G_DOORDB_OBJECT (__int32)0x09A1BC4

namespace CGeodata
{

	typedef bool (*_IsTargetVisible)(__int32, const FVector &vStart, const FVector &vEnd);
	static _IsTargetVisible IsTargetVisible = (_IsTargetVisible)0x47DDE0; 

    	typedef DWORD * (__thiscall *c_GetGeodata) (__int32);
	static c_GetGeodata GetGeodata = (c_GetGeodata)0x00416C40;

//.text:0048E026                 mov     ecx, offset unk_9A1BC4
//.text:0048E02B                 call    CDoorDB__Load_476FB0

	//CDoor$_CDoorDB__GetDoor_475000
   	typedef DWORD * (__thiscall *_GetDoor) (__int32, DWORD* object);
	static _GetDoor GetDoor = (_GetDoor)0x00416C40;

	

}


namespace L2Server
{

/*
	typedef DWORD * (*_GET_AREA)(__int32, wchar_t *); //GetAreaByName(G_AREA_DB, L"")
	static _GET_AREA GetAreaByName = (_GET_AREA)0x47DED0; 


	typedef void (*_CAreaDB_ValidateArea)(__int32, __int32 * pTerritory, __int32 areaDB, __int32 on_off ); //ValidateArea(G_AREA_DB, &pArea+28h, pArea, 1/0)
	static _CAreaDB_ValidateArea ValidateArea = (_CAreaDB_ValidateArea)0x47BA10; 

	typedef DWORD * (*_CEventController__SetOnOff)(__int32, __int32 on_off); //AreaSetOnOff([pArea+184h], 1/0)
	static _CEventController__SetOnOff AreaSetOnOff = (_CEventController__SetOnOff)0x477A70; 
*/


//	typedef bool (*_BUILDER_SET_AREAONOFF)(DWORD * pSocket, DWORD *pUser, std::basic_string<wchar_t> area_name);  //std::basic_string<wchar_t>    std::vector<std::basic_string<wchar_t>>
//	static _BUILDER_SET_AREAONOFF Builder_SetAreaOnOff = (_BUILDER_SET_AREAONOFF)0x423230; 

//	typedef void (*_LOADDATA)();
//--	static _LOADDATA LoadData = (_LOADDATA)0x6426A0; //c4
//	static _LOADDATA LoadData = (_LOADDATA)0x48de20; //c1


	typedef bool (*_WORLDPLANECOLLISION)(__int32, const FVector &vStart, const FVector &vEnd, double dRadius, FVector &Out);
	static _WORLDPLANECOLLISION g_WorldPlaneCollision_CheckCollision = (_WORLDPLANECOLLISION)0x521920; 





	typedef int (*_KOR_RANDOM)(int maxNumber);
	static _KOR_RANDOM KoreanRandom = (_KOR_RANDOM)0x43C5F0; 


	typedef void (* _BROADCAST_TO_ALL_USER)(const char *szFormat, ...);
	static _BROADCAST_TO_ALL_USER BroadcastToAllUser = (_BROADCAST_TO_ALL_USER)0x4f0960; //c1

	typedef void (* _BROADCAST_TO_ALL_USER_ANNOUNCE)(const WCHAR* pszAnnounce);
	static _BROADCAST_TO_ALL_USER_ANNOUNCE BroadcastToAllUser_Announce = (_BROADCAST_TO_ALL_USER_ANNOUNCE)0x4f0af0; //c1

/*
4456C0,	"void BroadcastToNeighbor(FVector vPos, const char* format, ...);
445990,	"void BroadcastToNeighborDist(FVector vPos, double dist, const char* format, ...);
445D90,	"void BroadcastToTargettingNeighbor(FVector vPos, int id, double dist, const char *format, ...);
4461B0,	"void BroadcastToNeighborExceptSelf(int id, FVector vPos, const char* format, ...);
446520,	"void BroadcastToNeighborExceptSelf(int id, FVector vPos, double dist, const char* format, ...);
*/
	typedef void (*_BROADCAST_TO_NEIGHBOR)(FVector vPos, const char *szFormat, ...);
	static _BROADCAST_TO_NEIGHBOR BroadcastToNeighbor = (_BROADCAST_TO_NEIGHBOR)0x4456c0; //c1

//c1 168AD244
	//int, int, int, double, double, int, int, double, int, char
	typedef void (*_BROADCAST_TO_NEIGHBOR_D)(__int32, __int32 objectID, __int32 unkn, FVector vPos, double dist, const char *szFormat, ...);
	static _BROADCAST_TO_NEIGHBOR_D BroadcastToNeighborDist = (_BROADCAST_TO_NEIGHBOR_D)0x445990; //c1

/*
c4
	typedef void (*TBroadcastToNeighborDist) (__int64 , UINT32 objectID, UINT32 unk, FVector& vPos, int radius, const char* format, ...);
	static TBroadcastToNeighborDist BroadcastToNeighborDist = (TBroadcastToNeighborDist)0x00403DE0;

	typedef void (*TBroadcastToNeighborDist2) (__int64 , UINT32 objectID, UINT32 unk, FVector& vPos, int distance, const char* format, ...);
	static TBroadcastToNeighborDist2 BroadcastToNeighborDist2 = (TBroadcastToNeighborDist2)0x004747B0;

			FVector locVec;
			locVec.loc_x=pItem->sharedData->loc_x;
			locVec.loc_y=pItem->sharedData->loc_y;
			locVec.loc_z=pItem->sharedData->loc_z;
//#define G_BROADCAST_OBJECT (__int64)0x0E427AA8
			L2Server::BroadcastToNeighborDist2(G_BROADCAST_OBJECT,objId,0x05000,locVec,1500,"cdd",0x12,objId,0);

*/



	typedef void (*_START_TIMER)(DWORD *);
	static _START_TIMER StartTimer = (_START_TIMER)0x58C684; //c1


	typedef void (*_SET_AREA)(DWORD * pSocket, WCHAR *area_command);
	static _SET_AREA SetArea = (_SET_AREA)0x423230; //c1






/*
4456c0	BroadcastToNeighbor(FVector vPos, const char* format, ...)
445990	BroadcastToNeighborDist(FVector vPos, double dist, const char* format, ...)
445d90	BroadcastToTargettingNeighbor(FVector vPos, int id, double dist, const char *format, ...)
4461b0	BroadcastToNeighborExceptSelf(int id, FVector vPos, const char* format, ...)
446520	BroadcastToNeighborExceptSelf(int id, FVector vPos, double dist, const char* format, ...)
4469f0	CCreature::BroadcastFlyToLocation(int x, int y, int z)
446b40	CCreatureController::ActionBroadcastCubicUse(int nTargetID, int nSkillID, int nSkillLevel)
446cc0	CCreature::BroadcastWaitType()
446f10	CCreature::BroadcastCombatModeStart()
446ff0	CCreature::BroadcastCombatModeFinish()
*/

	//4054A0 CPledge_$GetObject_4054A0 proc near
	typedef DWORD * (*_GET_PLEDGE)(int pledgeID);
	static _GET_PLEDGE GetPledgeByOID = (_GET_PLEDGE)0x4054A0; 

	static DWORD *GetObjectItem(INT32 nClassId)
	{
		typedef DWORD *(__fastcall *t) (VOID *pObjectDB, INT32 nClassId);
		t f = (t)0x4B0470;
		return f((VOID *)0x141C9D78, nClassId);
	} 



}


namespace CDBOld
{

	typedef void (__thiscall *CDB_SEND) (DWORD *, const char *, va_list);
	static CDB_SEND SendDB = (CDB_SEND)0x005340A0;
	
		static void Send(const char* format, ...) {
			va_list vl;
			va_start(vl, format);
			SendDB((DWORD *)0x01720CB90,format, vl);
		}
}

namespace CDBSocketOld
{

	typedef void (__thiscall *CDBSocket_SEND) (DWORD *, const char *, va_list);
	static CDBSocket_SEND SendV = (CDBSocket_SEND)0x00455D60;
	
		static void Send(const char* format, ...) {
			va_list vl;
			va_start(vl, format);
			SendV((DWORD *)(0x01720CB90+0x1c),format, vl);
		}

}



/*

//dummy packet corrund
//	typedef bool (__thiscall * DUMMY_PACKET) (DWORD * pSocket, const unsigned char * pBuffer);
//	static DUMMY_PACKET _DummyPacket = (DUMMY_PACKET)0x00435080; //strange address..., maybe 4533b0

//4533b0	DummyPacket(CDBSocket *socket, const unsigned char *packet)
//dummy packet
	typedef bool (__thiscall * DUMMY_PACKET) (DWORD * pSocket, const unsigned char * pBuffer);
	static DUMMY_PACKET _DummyPacket = (DUMMY_PACKET)0x004533b0;  
*/


//L2Server CSocket class
namespace CSocketOLD
{
	
	typedef void (__thiscall *CSOCKET_SENDV) (DWORD *, const char *, va_list);
	static CSOCKET_SENDV SendV = (CSOCKET_SENDV)0x004DFB70;
	//static void (__thiscall *SendV) (DWORD*, const char*, va_list) = (void (__thiscall *) (DWORD*, const char*, va_list)) CSOCKET_SENDV;
	static void Send(DWORD * pSocket,const char* format, ...) {
		if (pSocket != NULL) {
			va_list vl;
			va_start(vl, format);
			SendV(pSocket,format, vl);
		}
	}

	typedef void (__thiscall *_CLOSE) (DWORD *);
	static _CLOSE CloseS = (_CLOSE)0x539610;

	
	static void Close(DWORD * pSocket) {
		if (pSocket != NULL) {
			__asm { 

				mov ecx,pSocket
				mov dword ptr[ecx+013CCh], 2
				call	_CLOSE_SOCKET

			}
		}
	}
	

	typedef void (__thiscall *_KICK) (DWORD *);
	static _KICK kick = (_KICK)0x5067B0;

	typedef void (__thiscall *_KICK2) (DWORD *);
	static _KICK2 disconnect = (_KICK2)0x514480;



	typedef void (* _FRIEND_ADD)(DWORD *pSocket, wchar_t *friendname);
	static _FRIEND_ADD FriendAddRequest = (_FRIEND_ADD)0x5121E0;



//	typedef void (* _TUTORIAL_CLICK)(DWORD *, const unsigned char *packet);
//	static _TUTORIAL_CLICK TutorialQuestionMarkClick = (_TUTORIAL_CLICK)0x504D90;

	typedef void (* _TUTORIAL_CLICK)(DWORD *, int *packet);
	static _TUTORIAL_CLICK TutorialQuestionMarkClick = (_TUTORIAL_CLICK)0x504D90;


/*
	typedef void (__thiscall *SEND_HOME) (DWORD *pSocket, DWORD *pUser, wchar_t *);
	static SEND_HOME SendHome = (SEND_HOME)0x004221A0;

	typedef void (__thiscall *TELEPORTTO) (DWORD *pSocket, DWORD *pUser, wchar_t *);
	static TELEPORTTO TeleportTo = (TELEPORTTO)0x00422580;



/*
static void SetClientGameTime(DWORD *pSocket)
{
	typedef INT32 (__fastcall *_CL2TIME_GETTIME)(VOID *pClass);
	static _CL2TIME_GETTIME xGetTime = (_CL2TIME_GETTIME) 0x00491060;
	Send(pSocket, "cdd", aOPCODE(OP_TIME), xGetTime((VOID *)0x006C085C), 6);
}
*/

static INT32 GetGameTime()
{
	typedef INT32 (__fastcall *_CL2TIME_GETGTIME)(VOID *pClass);
	static _CL2TIME_GETGTIME xGetTime = (_CL2TIME_GETGTIME) 0x00491060;
	return xGetTime((VOID *)0x006C085C);
}





}





//L2Server CInventory class

namespace CInventory {

//corund discovered function, option=0 in corrund version
	typedef void (__thiscall *INVENTORY_LOCK) (DWORD * pInventory, WCHAR lockername, DWORD option); 
	static INVENTORY_LOCK InventoryLock = (INVENTORY_LOCK)0x004132F0;

//corund discovered function
	typedef void (__thiscall *INVENTORY_UNLOCK) (DWORD * pInventory); 
	static INVENTORY_UNLOCK InventoryUnLock = (INVENTORY_UNLOCK)0x0041C4A0;

//	typedef DWORD * (__thiscall *INVENTORY_GETFIRSTBYCLASSID) (DWORD * pInventory, DWORD classID);
//	static INVENTORY_GETFIRSTBYCLASSID InventoryFirstItemByClassId = (INVENTORY_GETFIRSTBYCLASSID)0x00485B20;

//mcrabbens used in AutoSS
	typedef DWORD * (__thiscall *CINVENTORY_FIND_FIRST_ITEM_BY_CLASS_ID) (DWORD * pInventory, DWORD itemID);
	static CINVENTORY_FIND_FIRST_ITEM_BY_CLASS_ID FindFirstItemByClassID = (CINVENTORY_FIND_FIRST_ITEM_BY_CLASS_ID)0x00485B20;

	typedef DWORD * (__thiscall *INVENTORY_GETNEXTBYCLASSID) (DWORD * pInventory, DWORD prevIndex);
	static INVENTORY_GETNEXTBYCLASSID FindNextItemByClassID = (INVENTORY_GETNEXTBYCLASSID)0x00485E00;

	typedef void (__thiscall *INVENTORY_CHANGED) (DWORD * pInventory, PItem pItem, DWORD ChangeType );  //2 itemupdate 3 itemdelete
	static INVENTORY_CHANGED SetInventoryChanged = (INVENTORY_CHANGED)0x004883A0;

	typedef DWORD (__thiscall *INVENTORY_POP) (DWORD * pInventory, DWORD index, DWORD option );  //option = 0?
	static INVENTORY_POP Pop = (INVENTORY_POP)0x00484C90;

	typedef DWORD (__thiscall *INVENTORY_PUSH) (DWORD * pInventory, DWORD index, DWORD option );  //option = 0?
	static INVENTORY_PUSH Push = (INVENTORY_PUSH)0x00443F0C;

	typedef DWORD (__thiscall *INVENTORY_ADENA) (DWORD * pInventory);  
	static INVENTORY_ADENA GetAdenaAmount = (INVENTORY_ADENA)0x00484f60;

	typedef DWORD (__thiscall *INVENTORY_TOTALCOUNT) (DWORD * pInventory);  
	static INVENTORY_TOTALCOUNT GetTotalCount = (INVENTORY_TOTALCOUNT)0x00486120;





//by server id?
	typedef DWORD * (__thiscall *INVENTORY_GETBYSOID) (DWORD * pInventory, DWORD oid);
	static INVENTORY_GETBYSOID FindByServerID = (INVENTORY_GETBYSOID)0x00485550;

//by index
	typedef DWORD * (__thiscall *INVENTORY_GETBYIDX) (DWORD * pInventory, DWORD idx);
	static INVENTORY_GETBYIDX FindByIndex = (INVENTORY_GETBYIDX)0x00485830;

//by DB id
	typedef DWORD * (__thiscall *INVENTORY_GETBYDBIDX) (DWORD * pInventory, DWORD idx);
	static INVENTORY_GETBYDBIDX FindByDBID = (INVENTORY_GETBYDBIDX)0x004851D0;


}




//L2Server CItem class
namespace CItemOLD
{
	typedef DWORD * (__cdecl *CITEM_GET_OBJECT) (DWORD objectID);
	static CITEM_GET_OBJECT GetItem = (CITEM_GET_OBJECT)0x0048A4C0;

	typedef void (__thiscall *ITEM_DELETE) (DWORD * pItem); 
	static ITEM_DELETE Delete = (ITEM_DELETE)0x0048B480;


	//T$_operator_GetItemObject_from_obj_db_41BBD0
typedef DWORD * (__cdecl *_GetItemObject_from_obj_db) (DWORD itemID);
	static _GetItemObject_from_obj_db GetItemObject = (_GetItemObject_from_obj_db)0x0041BBD0;



//CItem__GetItemTemplate_4D0520
typedef DWORD * (__cdecl *_GetItemTemplate) (DWORD itemID);
	static _GetItemTemplate GetItemTemplate = (_GetItemTemplate)0x004D0520;


//CSPointer(CItem).CItem::FindObjectSP_48A540(
	typedef DWORD * (__thiscall *_FindObjectSP) (DWORD * pIemSP, DWORD idx);
	static _FindObjectSP FindObjectSP = (_FindObjectSP)0x0048A540;

/*
int itemIndex = pSD->nEquipment[n];
		if(itemIndex > 0)
		{
			CItemSP itemSp;
			CItem::FindItemSp(itemSp, itemIndex);

			if(CItem *pItem = itemSp.get())
			{
				if(!CanEquip(pItem))
				{
					UnEquipItem(n);
				}
*/


}



namespace CNPC
{

	typedef void (__thiscall *CNPC_SEND_NPCINFO) (DWORD * pNPC, DWORD * pUser, bool NewlyCreated);
	static CNPC_SEND_NPCINFO _SendNPCInfo = (CNPC_SEND_NPCINFO)0x004961c0;


//54B0F0,	"bool CSummon::IsMakeAttackerGuilty(CCreature *pAttacker, bool bGood);
	typedef void (__thiscall *CNPC_MAKEGUILTY) (DWORD * pNPC, DWORD * pAttacker, bool bGood);
	static CNPC_MAKEGUILTY MakeGuilty = (CNPC_MAKEGUILTY)0x0054B0F0;


	//typedef void (__thiscall *CNPC_SAY) (DWORD * pNPC);
	//static CNPC_SAY Say = (CNPC_SAY)0x00495e00;

	//typedef void (__thiscall *CNPC_DIE) (DWORD * pNPC);
	//static CNPC_DIE Die = (CNPC_DIE)0x00496950;


}

namespace CStaticObject
{
//4E0900,	"CStaticObject* CStaticObject::GetObject(unsigned int sid);
	typedef DWORD * (__cdecl *CStaticObject_GET_OBJECT) (DWORD objectID);
	static CStaticObject_GET_OBJECT GetStaticObject = (CStaticObject_GET_OBJECT)0x004E0900;
}



//L2Server CCreature class
namespace CCreature
{

static BYTE GetToggleSkillONOFF(DWORD *pUser, int skill_id, int parameter) //0x14
{
DWORD element = 0;
DWORD _this = (DWORD)pUser;
typedef DWORD* (__thiscall *f)(DWORD, DWORD*, int*);
f(0x546C90)(_this + 0xA94, &element, &skill_id);
return (element && element != *(DWORD*)(_this + 0xA98)) ?  *(BYTE*)(element + parameter) : 0; //GetParameter8((DWORD*)element, parameter)
}

static int GetToggleSkillParameter(DWORD *pUser, int skill_id, int parameter)
{
DWORD element = 0;
DWORD _this = (DWORD)pUser;
typedef DWORD* (__thiscall *f)(DWORD, DWORD*, int*);
f(0x546C90)(_this + 0xA94, &element, &skill_id);
return (element && element != *(DWORD*)(_this + 0xA98)) ? *(int*)(element + parameter) : 0;
}

static int *GetToggleSkill(DWORD *pUser, int skill_id, int parameter)
{
DWORD element = 0;
DWORD _this = (DWORD)pUser;
typedef DWORD* (__thiscall *f)(DWORD, DWORD*, int*);
f(0x546C90)(_this + 0xA94, &element, &skill_id);
return (element && element != *(DWORD*)(_this + 0xA98)) ? (int*)(element + parameter) : 0;
}


static int GetSkillParameter(DWORD *pUser, int skill_id, int parameter)
{
	//parameter 10 - skill level
DWORD element = 0;
DWORD _this = (DWORD)pUser;
typedef DWORD* (__thiscall *f)(DWORD, DWORD*, int*);
f(0x40D830)(_this + 0x998, &element, &skill_id);
return (element && element != *(DWORD*)(_this + 0x99C)) ? *(int*)(element + parameter) : 0;
}

static int GetItemSkillParameter(DWORD *pUser, int skill_id, int parameter)
{
	//parameter 10 - skill level
DWORD element = 0;
DWORD _this = (DWORD)pUser;
typedef DWORD* (__thiscall *f)(DWORD, DWORD*, int*);
f(0x40D830)(_this + 0x9C0, &element, &skill_id);
return (element && element != *(DWORD*)(_this + 0x9C4)) ? *(int*)(element + parameter) : 0;
}


/*
	typedef DWORD * (__cdecl *CCREATURE_AQUIRESKILL) (DWORD * pCreature, DWORD skillID, DWORD skillLevel, DWORD aquireMethod);
	static CCREATURE_AQUIRESKILL SkillAquire = (CCREATURE_AQUIRESKILL)0x0044A840;

	typedef DWORD * (__cdecl *USER_SET_SKILL) (DWORD * pUser);
	static USER_SET_SKILL UserSetSkill = (USER_SET_SKILL)0x00450E30;

	typedef DWORD * (__cdecl *VALIDATE_USER) (DWORD * pUser);
	static VALIDATE_USER ValidateUser = (VALIDATE_USER)0x00451DD0;
*/


	void UseItem(DWORD * pUser, DWORD * pItem);


	typedef DWORD * (__cdecl *CCREATURE_GET_OBJECT) (DWORD objectID);
	static CCREATURE_GET_OBJECT GetCreature = (CCREATURE_GET_OBJECT)0x00439660;
	typedef PTUserData (__cdecl *CCREATURE_GET_OBJECT1) (DWORD Sid);
	static CCREATURE_GET_OBJECT1 UserFromSid = (CCREATURE_GET_OBJECT1)0x00439660;

//445320	CCreature::HaveSkill(int skillid, int level)
//crash	typedef bool (__cdecl *USER_HAVESKILL) (DWORD * pUser, int skillid, int level); 
//crash	static USER_HAVESKILL HaveSkill = (USER_HAVESKILL)0x00445320;


//4453E0,	"CSkillInfo* CCreature::GetUsableActiveSkill(int skillid);
//crash	typedef DWORD* (__cdecl *USER_HAVESKILLA) (DWORD * pUser, int skillid); 
//crash	static USER_HAVESKILLA GetUsableActiveSkill = (USER_HAVESKILLA)0x004453E0;




//446cc0	CCreature::BroadcastWaitType()
	typedef bool (__thiscall *USER_WAIT) (DWORD * pUser); 
	static USER_WAIT BroadcastWaitType = (USER_WAIT)0x00446cc0;

//494fc0	CNPC::GetMaster()
	typedef DWORD * (__thiscall *NPCGET_MASTER) (DWORD * pUser); 
	static NPCGET_MASTER GetMaster = (NPCGET_MASTER)0x00494fc0;

	typedef DWORD * (__thiscall *SUMMONGET_MASTER) (DWORD * pUser); 
	static SUMMONGET_MASTER Summon_GetMaster = (SUMMONGET_MASTER)0x0054ADB0;



	


//443360	CCreature::DeleteAllItemsInInventory(DWORD itemId, DWORD Cnt)
	typedef void (__thiscall *DELETE_ITEMS) (DWORD * pUser, DWORD itemId, DWORD Cnt); 
	static DELETE_ITEMS DeleteAllItemsInInventory = (DELETE_ITEMS)0x00446cc0;



//4440E0,	"CCreature::AddItemToInventory(int nItemClassID, int nCount, bool bIsPick);
	typedef void * (__cdecl *CCREATURE_ADDITEM1) (DWORD *pUser, int nItemClassID, int nCount, bool bIsPick);
	static CCREATURE_ADDITEM1 AddItemToInventoryByID = (CCREATURE_ADDITEM1)0x004440E0;

//441880,	"CCreature::DropItem();
//493B40,	"CNPC::DropItem();
	typedef void * (__cdecl *CNPC_DROPITEM1) (DWORD *pUser, int nObjectID, int nCount);
	static CNPC_DROPITEM1 DropItem1 = (CNPC_DROPITEM1)0x00493B40;



	typedef void * (__cdecl *CCREATURE_TELEPORT_TO_XYZ) (DWORD *pUser, int x, int y, int z);
	static CCREATURE_TELEPORT_TO_XYZ TeleportToLocation = (CCREATURE_TELEPORT_TO_XYZ)0x004476D0;


	//typedef void *(__cdecl *GET_USER_BY_NAME) (DWORD *pUser,wchar_t *wszMemberName);
	//static GET_USER_BY_NAME GetUserByName = (GET_USER_BY_NAME)0x0050CAB0;


		typedef void (*_VALIDATE_LOCATION)(DWORD * creature);
		static _VALIDATE_LOCATION _ValidateLocation = (_VALIDATE_LOCATION)0x448360; //c1


//		typedef void (*_ENTER_WORLD)(DWORD *);
//		static _ENTER_WORLD _EnterWorld = (_ENTER_WORLD)0x452350; //c1 CCreature::EnterWorld
//		void EnterWorld(DWORD *pUser) {_EnterWorld(pUser);}


/*
		void EnterWorld()
	{
		typedef void (*_ENTER_WORLD)(User *);
//		_ENTER_WORLD _EnterWorld = (_ENTER_WORLD)0x84CED0;  //c4
		_ENTER_WORLD _EnterWorld = (_ENTER_WORLD)0x452350; //c1 CCreature::EnterWorld
//4fdb30	User::EnterWorld()

		_EnterWorld(this);
	}

	void LeaveWorld()
	{
		typedef void (*_LEAVE_WORLD)(User *);
//		_LEAVE_WORLD _LeaveWorld = (_LEAVE_WORLD)0x84FE10; //c4
		_LEAVE_WORLD _LeaveWorld = (_LEAVE_WORLD)0x43c6a0; //c1 CCreature::LeaveWorld
//4fbba0	User::LeaveWorld()
		_LeaveWorld(this);
	}

	void SendUserInfo(bool bGMUserInfo)
	{
		typedef void (*_SEND_USERINFO)(CCreature *, bool);
//		_SEND_USERINFO _SendUserInfo = (_SEND_USERINFO)0x855740; //c4
		_SEND_USERINFO _SendUserInfo = (_SEND_USERINFO)0x4FE0E0; //c1 
		//4fe0e0	User::SendUserInfo()

		_SendUserInfo(this, bGMUserInfo);
	}

	void SendSkillList(bool bGMSkillList)
	{
		typedef void (*_SEND_SKILL_LIST)(CCreature *, bool);
//		_SEND_SKILL_LIST _SendSkillList = (_SEND_SKILL_LIST)0x828500; //c4
		_SEND_SKILL_LIST _SendSkillList = (_SEND_SKILL_LIST)0x4f2520; //c1
//4f2520	User::SendSkillList(DWORD Unused, DWORD gmSkillView)

		_SendSkillList(this, bGMSkillList);
	}

	void ValidateLocation()
	{
		typedef void (*_VALIDATE_LOCATION)(CCreature *);
//		_VALIDATE_LOCATION _ValidateLocation = (_VALIDATE_LOCATION)0x4F00D0; //c4
		_VALIDATE_LOCATION _ValidateLocation = (_VALIDATE_LOCATION)0x448360; //c1
//448360	CCreature::ValidateLocation()
		_ValidateLocation(this);
	}
*/

}





//L2Server User class
namespace User
{
	//psocket start
	const DWORD SOCKET_IP_PART1=0x132F;
	const DWORD SOCKET_IP_PART2=0x132E;
	const DWORD SOCKET_IP_PART3=0x132D;
	const DWORD SOCKET_IP_PART4=0x132C;

	const DWORD SOCKET_PACKETTABLE1=0x135C;
	const DWORD SOCKET_PACKETTABLE2=0x132C;

	const DWORD SOCKET_CRITICAL_SECTION=0x13D8;
	const DWORD SOCKET_ID=0x1390;
	const DWORD SOCKET_LOGIN=0x15D4;
	const DWORD HAVE_AN_ACC=0x162C;
	const DWORD ACC_ID = 0x1628; 
	const DWORD P_USER = 0x1394;
	const DWORD packetSize = 0x1368;
	//pSocket+13CC = 4 stop for combat use; 2 - logout; 1 - combat mode; 3 - restarting
	//pSocket+1624	???, we write here our protocol at C2 UserSelection, and use to tempriory disable login with cooperation with pSocket+13CC
	//psocket end



	//User parameter offsets (in bytes)

	const DWORD CHAR_ID = 20;				//0x14 //dbId
	const DWORD OBJECT_ID = 24;				//0x18
	const DWORD PLEDGE_OID=0x1AE0;
	const DWORD ACTIVE_ITEM = 0x1B94; //returns pointer to PItem


	const DWORD INFECTED_SKILLS = 2564;		//0xA04	//Unconfirmed

	const DWORD NPC_INDEX = 3936;			//0xF60
	const DWORD USER_SOCKET = 6584;			//0x19B8

//2009
	const DWORD NEW_NAME = 0x102a;	//pUser			
	const DWORD NEW_TITLE = 0xff8;	//pUser			

	const DWORD bIsCombatMode = 0x965;	//pUser	
	const DWORD bIsUnLocked = 0x964;	//pUser	
	const DWORD pUserGrade = 0x340; //user grade NON, D, C, B. A, S


	const DWORD ABNORMALS = 0x0AB0; //abnormals 

//2011
	const DWORD PTRADE = 6588; //0x19BC

//[PTRADE+0h]  //80 33 4E 00 "A3N";; off_5B9C38  trade memory address?

//[PTRADE+4h] //trade ID
//[PTRADE+8h] //InterlockedIncrement ?
//[PTRADE+Ch] //unknown?
//[PTRADE+10h] trade id?
//[PTRADE+14h] trade id?
//[PTRADE+18h] trade id?

//[PTRADE+1Ch] = trade request timer

//[PTRADE+20h] = trade request user1 OID
//[PTRADE+24h] = trade request user2 OID
//[PTRADE+28h] unknown? trade ID??????????????????

//[PTRADE+2Ch] = trade inventory1 user1???
//[PTRADE+30h] = trade inventory2 user1???

//[PTRADE+3Ch] = trade inventory1 user2???
//[PTRADE+40h] = trade inventory2 user2???

//[PTRADE+48h] = trade is MY confirmed status
//[PTRADE+49h] = trade is OTHER confirmed status
//[PTRADE+4Ah] = trade list was sent status
//[PTRADE+4Bh] = trade active status = 1???

//[PTRADE+4Ch] = trade MY buffer? {max buffer 2000h}
//[PTRADE+204Ch] = trade MY buffer?  {max buffer 2000h}
//[PTRADE+404Ch] = trade MY buffer size?
//[PTRADE+4050h] = trade OTHER buffer size?
//[PTRADE+4054h] = trade critical section?

/*
trade buffer structure: hdddhhdhhh
		writeH(type); // item type1
		writeD(temp.getObjectId());
		writeD(temp.getItemId());
		writeD(_amount);
		writeH(temp.getItem().getType2());	// item type2
		writeH(0x00);	//isBlessed

		writeD(temp.getItem().getBodyPart());	// rev 415  slot    0006-lr.ear  0008-neck  0030-lr.finger  0040-head  0080-??  0100-l.hand  0200-gloves  0400-chest  0800-pants  1000-feet  2000-??  4000-r.hand  8000-r.hand
		writeH(temp.getEnchantLevel());	// enchant level
		writeH(0x00);	// reserved, not used in server
		writeH(0x00);   // reserved not used in server


*/


	//ExUser AI parameter offset (in bytes)
	//DEPRECIATED -- probably won't need this anymore
	//const DWORD AI_EX_USER = 196;			//0xC4

/*
	const DWORD U_P_STATE_1= 0x904; 	//2308 p_state 
	const DWORD U_temper = 0x908;		//2312 temper

	const DWORD U_I_QUEST0 = 0x90c;		//2316 i_quest0
	const DWORD U_I_QUEST1 = 0x910;		//2320 i_quest1
	const DWORD U_I_QUEST2 = 0x914;		//2324 i_quest2
	const DWORD U_I_QUEST3 = 0x918;		//2328 i_quest3
	const DWORD U_I_QUEST4 = 0x91c;		//2332 i_quest4

	const DWORD U_I_AI0 = 0x920;		//2336 i_ai0
	const DWORD U_I_AI1 = 0x924;		//2340 i_ai1
	const DWORD U_I_AI2 = 0x928;		//2344 i_ai2
	const DWORD U_I_AI3 = 0x92c;		//2348 i_ai3
	const DWORD U_I_AI4 = 0x930;		//2352 i_ai4


	const DWORD U_C_QUEST0 = 0x938;		//2360 c_quest0
	const DWORD U_C_QUEST1 = 0x93c;		//2364 c_quest1
	const DWORD U_C_QUEST2 = 0x940;		//2368 c_quest2
	const DWORD U_C_QUEST3 = 0x944;		//2372 c_quest3
	const DWORD U_C_QUEST4 = 0x948;		//2376 c_quest4

	const DWORD U_C_AI0 = 0x94c;		//2380 c_ai0
	const DWORD U_C_AI1 = 0x950;		//2384 c_ai1
	const DWORD U_C_AI2 = 0x954;		//2388 c_ai2
	const DWORD U_C_AI3 = 0x958;		//2392 c_ai3
	const DWORD U_C_AI4 = 0x95c;		//2396 c_ai4

	const DWORD U_SM = 0x960;		//2400 shared memory
	const DWORD U_SM_MASTER = 0x964;	//2404
	const DWORD U_SM_BOSS = 0x968;		//2408
	const DWORD U_TOP_DESIRE_TGT = 0x96c;	//2412
	const DWORD U_TOP_SKILL_ID = 0x970;	//2416


	const DWORD U_START_X = 0x97c;		//2428 
	const DWORD U_START_Y = 0x980;		//2432 
	const DWORD U_START_Z = 0x984;		//2436 

	const DWORD U_P_STATE_2= 0x9c0; 	//2496 p_state 
	const DWORD U_SIT_ON_TOP= 0x9c4; 	//2500

*/

//shared data begin
//----------------kvoxi
//-----------------

	//User AI parameter offsets (in bytes)
	const DWORD AI_X_LOC = 8;				//0x08
	const DWORD AI_Y_LOC = 16;				//0x10
	const DWORD AI_Z_LOC = 24;				//0x18


	const DWORD AI_OBJID = 0x24;


//----------------kvoxi
//32      m_Direction                                             Int
//40	m_CreatureID,creature_id			        Int
//-----------------


	const DWORD AI_NPC_INDEX = 44;			//0x2C


//----------------kvoxi
//52	VehicleID                                               Int
//56      VehicleIndex                                            Int
//64	VehicleX                                                Double
//72	VehicleY                                                Double
//80	VehicleZ                                                Double
//88	m_bIsOnline					        Int
//92	next_creature_index				        Int
//96	prev_creature_index                                     Int
//-----------------



	const DWORD AI_IS_PLAYER = 108;			//0x6C
	const DWORD AI_IS_ALIVE = 112;			//0x70

	const DWORD AI_RACE = 148;				//0x94
	const DWORD AI_CLASS_ID = 152;			//0x98 //occupation
const DWORD AI_SEX = 156;				//0x9C smeli guess that is gender, kvoxi code confirms :)
	const DWORD AI_NAME = 160;				//0xA0  //WChar


//216 = D8
//----------------kvoxi
//216	collision_radius				        Double
//224	collision_high                                          Double
//-----------------

const DWORD	ai_nHairShape = 0xE8; //kvoxi confirm 232
const DWORD	ai_nHairColor = 0xEc; //kvoxi confirm 236
const DWORD	ai_nFaceIndex = 0xF0; //kvoxi confirm 240



const DWORD AI_EXP = 244;				//0xF4 smeli guess that is exp //kvoxi confirm
const DWORD AI_SP = 248;				//0xF8

const DWORD	Inventory = 0xFC; //corrund 252  Inventory 
const DWORD	ai_nObjIdAdena = 0xFC; //kvoxi 252  inv_tOP_item_uid                                        Int
const DWORD	ai_nObjIdUnder = 0x100;
const DWORD	ai_nObjIdLEar = 0x104;
const DWORD	ai_nObjIdREar = 0x108;
const DWORD	ai_nObjIdNeck = 0x10c;
const DWORD	ai_nObjIdLRing = 0x110;
const DWORD	ai_nObjIdRRing = 0x114;
const DWORD	ai_nObjIdHead = 0x118;
const DWORD	ai_nObjIdLHand = 0x11c;
const DWORD	ai_nObjIdRHand = 0x120;
const DWORD	ai_nObjIdGloves = 0x124;
const DWORD	ai_nObjIdChest = 0x128;
const DWORD	ai_nObjIdLegs = 0x12c;
const DWORD	ai_nObjIdFeet = 0x130;
const DWORD	ai_nObjIdBack = 0x134;
const DWORD	ai_nObjId2Hand = 0x138;
const DWORD	ai_nObjIdOnePiece = 0x13c;



	const DWORD AI_INT = 320;				//0x140
	const DWORD AI_STR = 324;				//0x144
	const DWORD AI_CON = 328;				//0x148
	const DWORD AI_MEN = 332;				//0x14C
	const DWORD AI_DEX = 336;				//0x150
	const DWORD AI_WIT = 340;				//0x154

	const DWORD AI_HP = 344;				//0x158
	const DWORD AI_MP = 352;				//0x15C




	const DWORD AI_MOVE_TYPE = 364;			//0x16C	(0 = Walk, 1 = Run)
	const DWORD AI_STAND_TYPE = 368;		//0x170	(0 = Sitting, 1 = Standing, 2 = PrivateStore)
//???
	const DWORD AI_TARGET_INDEX = 384;		//0x180	
	const DWORD AI_TARGET_ID = 388;			//0x184	Target's objectID
//???
	const DWORD AI_PVP_FLAG1 = 396;			//0x18C	 smeli guess that is PVP flag? 0 no flag, 1 flag, 2 ending flag
	const DWORD AI_PVP_FLAG_TIME = 416;			
	const DWORD AI_FREEZE_FLAG = 397;		//0x18D	 freeze flag
//???


//----------------kvoxi
//364     m_bIsRunning 						Int
//368	m_bIsStanding                                           Int
//--------------
//384	m_TargetIndex,target_index				Int
//388	m_TargetID,target_id					Int
//-----------------
//396	m_nPvPflag                                              Int	
//397	m_bIsFreezed,is_freezed					Int
//---------------
//400     m_nPvP,m_nDuels                                         Int	
//404	m_nPK                                                   Int	
//408	m_nPKPardon                                             Int	
//412	m_nKarma,karma						Int
//416	m_nPvPTimeEnd                                           Int	
//--------------------

	const DWORD AI_PVP = 400;				//0x190
	const DWORD AI_PK = 404;				//0x194
	const DWORD AI_PKPARDON = 408;				//0x198 
	const DWORD AI_KARMA = 412;				//0x19C
	const DWORD AI_PVPTIMEEND=416;			//0x1A0

//========ezme
/*
	 int nTutorialQuestId;
	 int nTutotialState;
	 int nTutotialJournal;
	 int quests[64];	//QUESTDATA quests[16];
*/
//=================



//----------------kvoxi
//420	Quest1_ID						Int	
//424     Quest1_State						Int
//428     Quest1_Journal						Int
//432	Quest2_ID						Int	
//436     Quest2_State						Int
//440     Quest2_Journal						Int
//444	Quest3_ID						Int	
//448     Quest3_State						Int
//452     Quest3_Journal						Int
//456	Quest4_ID						Int	
//460     Quest4_State						Int
//464     Quest4_Journal						Int
//468	Quest5_ID						Int	
//472     Quest5_State						Int
//476     Quest5_Journal						Int
//480	Quest6_ID						Int	
//484     Quest6_State						Int
//488     Quest6_Journal						Int
//492	Quest7_ID						Int	
//496     Quest7_State						Int
//500     Quest7_Journal						Int
//504	Quest8_ID						Int	
//508     Quest8_State						Int
//512     Quest8_Journal						Int
//516	Quest9_ID						Int	
//520     Quest9_State						Int
//524     Quest9_Journal						Int
//528	Quest10_ID						Int	
//532     Quest10_State						Int
//536     Quest10_Journal						Int
//540	Quest11_ID						Int	
//544     Quest11_State						Int
//548     Quest11_Journal						Int
//552	Quest12_ID						Int	
//556     Quest12_State						Int
//560     Quest12_Journal						Int
//564	Quest13_ID						Int	
//568     Quest13_State						Int
//572     Quest13_Journal						Int
//576	Quest14_ID						Int	
//580     Quest14_State						Int
//584     Quest14_Journal						Int
//588	Quest15_ID						Int	
//592     Quest15_State						Int
//596     Quest15_Journal						Int
//600	Quest16_ID						Int	
//604     Quest16_State						Int
//608     Quest16_Journal						Int
//612	OneTimeQuestFlag224_256					Int
//616	OneTimeQuestFlag192_224					Int
//620	OneTimeQuestFlag160_192					Int
//624	OneTimeQuestFlag128_160					Int
//628	OneTimeQuestFlag96_128					Int
//632	OneTimeQuestFlag64_96					Int
//636	OneTimeQuestFlag32_64					Int
//640	OneTimeQuestFlag1_32					Int
//644	m_dwLastRewardTime,quest_last_reward_time		Int
//-----------------



	const DWORD AI_PLEDGE_IDDEX = 664;			//0x298
	const DWORD AI_PLEDGE_ID = 668;			//0x298
	const DWORD AI_IS_PLEDGE_MASTER = 672;	//0x2A0
	const DWORD AI_MOUNT = 748;				//0x2EC	(0 = None, 1 = Strider, 2 = Wyvern)

//-----kvoxi
/*
	664	m_nPledgeId,pledge_id					Int
	668	m_nPledgeIndex  		                        Int
	672	m_bIsPledgeMaster,is_pledge_master			Int
	676     m_nAllianceDbId                                         Int
	680	m_nAllianceIndex		                        Int
	724	m_pParty						Int
	728	m_nPartyIndex                                           Int
	732	m_bIsPartyLeader                                        Int
	736	m_nResidenceId,residence_id                             Int
	748 	m_nMountType                                            Int
	752	m_nPrivateStoreType                                     Int
	764	m_bIsSSCharged                                          Int
	768	SS_multiplier						Double
	776	m_bIsSpSCharged			                        Int
	784	SpS_multiplier1						Double                 
	792	SpS_multiplier2						Double
//----------------
	804	base_attack_type					Int
	812	base_attack_range					Int
	816	base_damage_range_1					Int
	820	base_damage_range_2					Int
	824	base_damage_range_3					Int
	828	base_damage_range_4					Int
	832	base_rand_dam						Int
//base attack speed
	848	base_critical						Int
//----------
	864	m_nINT1							Int
	868	m_nSTR1							Int
	872	m_nCON1							Int
	876	m_nMEN1							Int
	880	m_nDEX1							Int
	884	m_nWIT1							Int
	888	m_nLevel,level						Int
//------------------	
	960	MaxSlot							int //smeli
	964	CurrSlot							int //smeli
	968	CurrWeight						int //smeli
	972 ???								int
	976	MaxLoad 						Double //by smeli
//-----------------
	984	org_hp							Double
	992	org_mp							Double
	1000	m_dBaseHP,max_hp					Double
	1008	m_dBaseMP,max_mp					Double
	1016	org_hp_regen						Double
	1024	org_mp_regen						Double
//----------
	1032	org_speed							Double //by smeli untested
	1040	???

	1048	ground_low						Double
	1056	ground_high						Double
	1072	org_earshot						Double
	1144	m_EquipedWeaponClassId,equiped_weapon_class_id		Int
        1148	m_AttackType,attack_type				Int
	1216	m_nPAtk							Double
	1224	m_nPDef							Double
	1232	m_nMAtk							Double
	1240	m_nMDef							Double
	1248	m_nAtkSpd						Double
	1256	critical_div_10						Double
	1096	accuracy						Double
	1104	evasion							Double

	1316	m_nBuilderLevel						Int
	1332	m_nLastBlowWeaponClassId,last_blow_weapon_class_id	Int
	1336	m_sAI,ai						WChar
	1540	acquire_sp						Int
	1544	hp_increase						Int
	1548	mp_increase						Int
	1552	aggro_range						Int
	1560	physical_hit_modify					Double
	1568	physical_avoid_modify					Double
	1576	temper							Int
	1580	safe_height						Int
	1584	max_item						Int
	1616	m_BossSMIndex,boss_id					Int
	1620	m_nClassId,npc_class_id,class_id			Int
	1624	m_nWeightPoint,weight_point				Int
	1628	m_nRespawnTime,respawn_time				Int
	1632	m_bIsNPC_in_Clan					Int
	1636	m_nNPC_clan_id						Int
	1656	m_nClanHelpRange,clan_help_range			Int
	1664	acquire_exp_rate					Double
	1672	m_nPState,p_state					Int
	1676	m_spTarget						CSharedCreatureData
	1680	m_bIsSeeEventEnabled					Int
	1684	m_spMaster,master					CSharedCreatureData
	1688	server_action_type					Int
	1692	attack_tick						Int
	1700	corpse_time						Int
	1704	m_bIsSpoiled						Int
	1716	flag							Int
	1720	m_Meal,meal						Int
//--------------------
	1724	m_maxMeal						int //by smeli
//--------------------
	1732	buff_1_id						Int
	1736	buff_1_level						Int
	1740	buff_2_id						Int
	1744	buff_2_level						Int
	1748	buff_3_id						Int
	1752	buff_3_level						Int
	1756	buff_4_id						Int
	1760	buff_4_level						Int
	1764	buff_5_id						Int
	1768	buff_5_level						Int
	1772	buff_6_id						Int
	1776	buff_6_level						Int
	1780	buff_7_id						Int
	1784	buff_7_level						Int
	1788	buff_8_id						Int
	1792	buff_8_level						Int
	1796	buff_9_id						Int
	1800	buff_9_level						Int
	1804	buff_10_id						Int
	1808	buff_10_level						Int
	1812	buff_11_id						Int
	1816	buff_11_level						Int
	1820	buff_12_id						Int
	1824	buff_12_level						Int
	1828	buff_13_id						Int
	1832	buff_13_level						Int
	1836	buff_14_id						Int
	1840	buff_14_level						Int
	1844	buff_15_id						Int
	1848	buff_15_level						Int
	1852	buff_16_id						Int
	1856	buff_16_level						Int
	1860	buff_17_id						Int
	1864	buff_17_level						Int
	1868	buff_18_id						Int
	1872	buff_18_level						Int
	1876	buff_19_id						Int
	1880	buff_19_level						Int
	1884	buff_20_id						Int
	1888	buff_20_level						Int
	1892	m_nDBValue,db_value					Int
	1896	m_nDualGara1,dualgara1					Int
	1900	m_nDualGara2,dualgara2					Int
	1904	m_nTradeSkillLevel,trade_skill_level			Int
	1908	m_nMakerParam1,param1					Int
	1912	m_nMakerParam2,param2					Int
	1916	m_nMakerParam3,param3					Int
*/
//---------------------


	const DWORD AI_LEVEL = 888;			//0x378
	const DWORD AI_MAX_HP = 1000;			//0x3E8

	const DWORD nWeaponClassId=1144; 	
	const DWORD IS_GM = 1316;   //0x524
	const DWORD nLastBlowWeaponClassId=1332; 	//0x534
	const DWORD AI_NPC_CLASS_ID = 1620;		//0x654
	const DWORD AI_WEIGHT_POINT = 1624;		//0x658



/*
2308 p_state
2312 temper
2316 i_quest0
2320 i_quest1
2324 i_quest2
2328 i_quest3
2332 i_quest4
2336 i_ai0
2340 i_ai1
2344 i_ai2
2348 i_ai3
2352 i_ai4
2360 c_quest0
2364 c_quest1
2368 c_quest2
-------------------------
2380 c_ai0
2384 c_ai1
2388 c_ai2
2392 c_ai3
2396 c_ai4
2400 sm
2404 master
2408 boss
2412 tOP_desire_target
2416 top skill level id
2428 start_x
2432 start_y
2436 start_z
2496 p_state //1672
2500 sit_on_stop
*/





	//DWORD * GetParty(DWORD * pUser);
	typedef DWORD * (__thiscall *USER_GET_PARTY) (DWORD * pUser);
	static USER_GET_PARTY GetParty = (USER_GET_PARTY)0x004417E0;
	typedef DWORD * (__thiscall *USER_GET_PLEDGE) (DWORD * pUser);
	static USER_GET_PLEDGE GetPledge = (USER_GET_PLEDGE)0x00405520;

	typedef PTPartyDataX (__thiscall *USER_GET_PARTYD) (DWORD * pUser);
	static USER_GET_PARTYD GetPartyD = (USER_GET_PARTYD)0x004417E0;

	//typedef void (__thiscall *USER_DROP_ITEM) (DWORD * pUser, DWORD *pItem, DWORD icount, FVector *pos);
	//static USER_DROP_ITEM DropItem = (USER_DROP_ITEM)0x004e8170;

	typedef void (__thiscall *USER_DIEDROP_ITEM) (DWORD * pUser);
	static USER_DIEDROP_ITEM OnDieDropItem = (USER_DIEDROP_ITEM)0x004ee2f0;

	typedef void (__thiscall *USER_DIED) (DWORD * pUser);
	static USER_DIED Die = (USER_DIED)0x004ef010;


	typedef void (__thiscall *USER_PLAYMUSIC) (DWORD * pUser, const WCHAR* pszFileName);
	static USER_PLAYMUSIC PlayMusic = (USER_PLAYMUSIC)0x004eac20;

	typedef void (__thiscall *USER_KARMA) (DWORD * pUser, DWORD iKarma);
	static USER_KARMA SetKarma = (USER_KARMA)0x004ea990;


//crash
//4EE0D0,	"bool User::IsMakeAttackerGuilty(CCreature *pAttacker);
//4EB430,	"void User::SetGuilty(bool c);
	typedef void (__thiscall *SET_GUILTY2) (DWORD * pUser, bool c);
	static SET_GUILTY2 SetUserGuilty = (SET_GUILTY2)0x004eb430;

	typedef void (__thiscall *RELATION_CHANGED) (DWORD * pUser);
	static RELATION_CHANGED SendRelationChanged = (RELATION_CHANGED)0x00500990;


	//typedef DWORD *(__thiscall *USER_GET_PLEDGED) (DWORD * pUser);
	//static USER_GET_PLEDGED GetPledgeD = (USER_GET_PLEDGED)0x00405520;

	
	//typedef PTUserData (__thiscall *FSID_GET_USER) (int Sid);
	//static FSID_GET_USER GetUserFromSid = (FSID_GET_USER)0x00439660;

	typedef void (__thiscall *USER_ADDITEM) (DWORD * pUser, int itemClass, int Count, int IsPick); 
	static USER_ADDITEM AddItemToInventory = (USER_ADDITEM)0x004440E0;
	typedef void (__thiscall *USER_DELPITEM) (DWORD * pUser, int ItemClass, int Count); 
	static USER_DELPITEM DelItemFromInventory = (USER_DELPITEM)0x004444f0;

	typedef bool (__thiscall *USER_ISTRADE) (DWORD * pUser); 
	static USER_ISTRADE CheckTrade = (USER_ISTRADE)0x004e7ff0;

	typedef bool (__thiscall *USER_ENDTRADE) (DWORD * pUser); 
	static USER_ENDTRADE TradeCancel = (USER_ENDTRADE)0x004e7e70;


//4ea3f0	User::GetPet()
//4ea4b0	User::GetSummon()
//4ea570	User::GetSummonOrPet()
	typedef DWORD *(__thiscall *USER_GETSUMMON) (DWORD * pUser); 
	static USER_GETSUMMON GetSummonOrPet = (USER_GETSUMMON)0x004ea570;
	typedef DWORD *(__thiscall *USER_GETSUMMON_A) (DWORD * pUser); 
	static USER_GETSUMMON_A GetSummon = (USER_GETSUMMON_A)0x004ea4b0;
	typedef DWORD *(__thiscall *USER_GETSUMMON_B) (DWORD * pUser); 
	static USER_GETSUMMON_B GetPet = (USER_GETSUMMON_B)0x004ea3f0;
//4eb9d0	User::DespawnSummon()
	typedef void (__thiscall *USER_GETSUMMON_C) (DWORD * pUser); 
	static USER_GETSUMMON_C DespawnSummon = (USER_GETSUMMON_C)0x004eb9d0;

	typedef void (__thiscall *USER_DELITEM) (DWORD * pUser, int itemClass, int Count); 
	static USER_DELITEM DeleteItemInInventory = (USER_DELITEM)0x004444F0;

	typedef void (__thiscall *USER_SENDITEMLIST) (DWORD * pUser, int option1, int option2, int option3); //user, 1, 1, 0 
	static USER_SENDITEMLIST SendItemList = (USER_SENDITEMLIST)0x004F1830;

	typedef void (__thiscall *USER_SEND_QUEST_LIST) (DWORD *pUser, bool GMPacket);
	static USER_SEND_QUEST_LIST SendQuestList = (USER_SEND_QUEST_LIST)0x004ef5b0;

	typedef void (__thiscall *USER_SEND_SKILL_LIST) (DWORD *pUser, DWORD unused, bool GMPacket);
	static USER_SEND_SKILL_LIST SendSkillList = (USER_SEND_SKILL_LIST)0x004f2520;





//4ec620	User::GetRelationTo(User *pAttacker)
//4ec9a0	User::IsEnemyTo()
//4ecf70	User::IsEnemyPledgeMember(User *pUser)
	typedef DWORD (__thiscall *USER_GETRELATION) (DWORD *pUser, DWORD *pTarget);
	static USER_GETRELATION GetRelationTo = (USER_GETRELATION)0x004ec620;
/*

1:  (pUser+1B84)
2:  pvpFlag
4:  karma
8:  have PARTY
10: (call puser+344....) is partyLeader
20: is in PC party
40: is in CLAN
80: is CLAN leader
100: (ebx = PLEDGE, ebx+28 pledgeshareddata) in clan

200: ???have Residence, (C4:is In siege) 
400: ???residence type=1 (C4:siege ATTACKER
800: C4 siege DEFENDER
1000: is enemy
2000: is PledgeWAR (aliance?war) enemy  (sub_4130A0 - isPLEDGEenemy(mypledge)
8000  (sub_4E6C40 is???enemy(what?) (C4:double fist
10000 (sub_4E6C40 is???enemy(what?) (C4:single fist
4000  relation=18000

20000 - have aliance (sub_42ED70 CAlliance *GetAlliance())
40000 - aliance war enemy clan leader
80000 - aliance war member if not leader

100000 (sub_4E6C10 IsAboutDismiss???(myALLY))
200000 (sub_40C8C0 IsAboutDismiss???(enemyALLY)
800 (if not 80100, 1000)
*/





	typedef DWORD (__thiscall *USER_CHANGETARGET) (DWORD *pUser, DWORD *pTarget);
	static USER_CHANGETARGET ChangeTarget = (USER_CHANGETARGET)0x004E8360;


	
	typedef void (__thiscall *USR_GATHER_RELATION) (DWORD *pUser);
	static USR_GATHER_RELATION User_gatherRelation = (USR_GATHER_RELATION)0x00500C40;



	typedef DWORD (__thiscall *USER_PLEDGEENEMY) (DWORD *pUser, DWORD *pTarget);
	static USER_PLEDGEENEMY IsEnemyPledgeMember = (USER_PLEDGEENEMY)0x004ecf70;

//500410	User::SendNicknameChanged()
	typedef void (__thiscall *USER_SENDNICKNAME) (DWORD *pUser);
	static USER_SENDNICKNAME UserSendNickNameChanged = (USER_SENDNICKNAME)0x00500410;


	DWORD * GetUser(DWORD * pSocket);
	DWORD * GetUserInventory(DWORD * pUser);
	void SendUserInfo(DWORD * pUser, bool GMUserInfo);
	void SendCharInfo(DWORD * pUser, bool NPCCharInfo);
	void UseItem(DWORD * pUser, DWORD * pItem);

	bool SO_VALID_USER(DWORD *p);


//5404a0	CMerchant::SendSellList(CUserSocket* pSocket)
	typedef void (__thiscall *MERCHANT_SELL) (DWORD *pMerchant, DWORD *pSocket);
	static MERCHANT_SELL MerchantSell = (MERCHANT_SELL)0x005404a0;

//5415a0	CMerchant::SendBuyList(CUserSocket* pSocket)
	typedef void (__thiscall *MERCHANT_BUY) (DWORD *pMerchant, DWORD *pSocket);
	static MERCHANT_BUY MerchantBuy = (MERCHANT_SELL)0x005415a0;


	typedef bool (__thiscall *_IS_IN_ZONE1) (DWORD *pUser);
	static _IS_IN_ZONE1 IsInPVPZone = (_IS_IN_ZONE1)0x0043EAE0;

	typedef bool (__thiscall *_IS_IN_ZONE2) (DWORD *pUser);
	static _IS_IN_ZONE2 IsInZone2 = (_IS_IN_ZONE2)0x0043EB70;

	typedef bool (__thiscall *_IS_IN_ZONE3) (DWORD *pUser);
	static _IS_IN_ZONE3 IsInPeaceZone = (_IS_IN_ZONE3)0x0043EC00;


	typedef void (__thiscall *_QuitPrivateStore) (DWORD *pUser);
	static _QuitPrivateStore QuitPrivateStore = (_QuitPrivateStore)0x004E9C20; //504980; //4E9C20;

	typedef void (__thiscall *_QuitPrivateStoreB) (DWORD *pUser);
	static _QuitPrivateStoreB QuitPrivateStoreBUY = (_QuitPrivateStoreB)0x004EA7E0; //505920; //4EA7E0;


}



namespace CParty {

	typedef void (__thiscall *PARTY_WITHDRAW) (DWORD * pParty, DWORD * pUser);
	static PARTY_WITHDRAW PartyWithdraw = (PARTY_WITHDRAW)0x004b4d60;

//	4b3380	CParty::SetMaster(User *pMaster)
	typedef void (__thiscall *PARTY_SETMASTER) (DWORD * pParty, DWORD * pUser);
	static PARTY_SETMASTER PartySetMaster = (PARTY_SETMASTER)0x004b3380;
//4b3c70	CParty::GetMaster()
	typedef DWORD *(__thiscall *PARTY_GETMASTER) (DWORD * pParty);
	static PARTY_GETMASTER PartyGetMaster = (PARTY_GETMASTER)0x004b3c70;
//4b4f70	CParty::Dismiss()
	typedef void (__thiscall *PARTY_DISMISS) (DWORD * pParty);
	static PARTY_DISMISS PartyDismiss = (PARTY_DISMISS)0x004b4f70;
//4b5470	CParty::OpenAllWindowPacket(User *pUser)
	typedef void (__thiscall *PARTY_OPENALL) (DWORD * pParty, DWORD * pUser);
	static PARTY_OPENALL PartyOpenAllWindowPacket = (PARTY_OPENALL)0x004b5470;

//4B55F0	CParty::DistributeAdena
	typedef void (__thiscall *PARTY_DistributeAdena) (DWORD * pParty, INT32 nAmount, int nTraceChar, INT32 nItemDBID, DWORD* pItem);
	static PARTY_DistributeAdena PartyDistributeAdena = (PARTY_DistributeAdena)0x004B55F0;

//4B57F0	CParty::RouteItem
	typedef void (__thiscall *PARTY_RouteItem) (DWORD * pParty, DWORD *pItem, DWORD *pPicker);
	static PARTY_RouteItem PartyRouteItem = (PARTY_RouteItem)0x004B57F0;



}

//52cf30	CDB::RequestLoadChar(unsigned int nAccountID, CUserSocket* pSocket)
	typedef void(__fastcall *_RLC)(DWORD * pCDB, unsigned int nAccountID, DWORD *pSocket); 
	static _RLC RequestLoadChar = (_RLC) 0x0052cf30;

//c1
//1720CB90h  //cdb?
//			//cdbsocket
//18AA81D8h //CLOG

//0x1628  account of Psocket

//c4
//1179D70h // ???
//10488E0h //cdb


// Returns a pointer to an address + a given offset
//
// Parameters:
// DWORD * pAddress - the address of the data to use
// DWORD byteOffset - how many bytes to offset the address
//
DWORD * GetAddress(DWORD * pAddress, DWORD byteOffset);



// Returns a value from an address + a given offset
//
// Parameters:
// DWORD * pData - the address of the data to use
// DWORD byteOffset - how many bytes to offset the address
//
void SetParameter(DWORD * pData, DWORD byteOffset, DWORD parameter);
DWORD TGetParameter(PTUserData pTData, DWORD byteOffset);
in_addr GetIP(DWORD * pData, DWORD byteOffset);


bool isInPeaceZone(DWORD *pUser);

// Returns a pointer to CSharedData for a CObject
//
// Parameters:
// DWORD * pObject - the CObject * to get CSharedData for
DWORD * GetSharedData(DWORD * pObject);
DWORD * GetSharedData2(DWORD * pObject); //itemdata
PItemData GetItemSharedData(DWORD * pObject); //itemdata

DWORD * GetSharedData22(DWORD * pObject); //iteminfo
TCharBaseData * GetTSharedData(DWORD * pObject);

int StrCompW(WCHAR * Str1, WCHAR * Str2);

void FunctionNameTracker(DWORD *pUser, const wchar_t *fName, int opCode);


int  MyRandom(int myMax);
void init_mm( );
int number_range( int from, int to );
int number_mm( void );
int SafeSubtract(int A, int B); 

//ncsoft
//const unsigned char *Disassemble(const unsigned char* packet, const char* format, ...);
int Assemble(char *buf, int bufLen, const char *format, ...);
int VAssemble(char* buf, int bufLen, const char* format, va_list ap);

void CLogAddAnsi(char *message, DWORD color, DWORD argument1, DWORD argument2);
void CLogAddAnsi2(char *message, DWORD color, DWORD argument1, DWORD argument2, DWORD argument3);
void CLogAddAnsi3(char *message, DWORD color, DWORD argument1, wchar_t *argument2);
void CLogAddAnsi4(char *message, DWORD color, char *argument1, wchar_t *argument2);
void CLogAddAnsi5(char *message, DWORD color, wchar_t * argument1, wchar_t *argument2, DWORD protocol);
void CLogAddUnicode(wchar_t *message, DWORD color, DWORD argument);

//functions

int prisonCheck(PTCharBaseData CSharedDat);
void HookI_ESCAPE();
bool CanBeAttacked(DWORD *pActor, DWORD *pTarget);  
void GetExNPC(DWORD *pUser);


void SEFunc();
void trans_func( unsigned int, EXCEPTION_POINTERS* );

class SE_Exception
{
private:
    unsigned int nSE;
public:
    SE_Exception() {}
    SE_Exception( unsigned int n ) : nSE( n ) {}
    ~SE_Exception() {}
    unsigned int getSeNumber() { return nSE; }
};


char *readfromFile(const char * filename);
BOOL Char2Wchar(LPWSTR pDest, char* pSrc, int nDestStrLen);
void sendHTML(DWORD *pSocket, const char * filename);
void sendHTMLstring(DWORD *pSocket, const wchar_t * myString);
void sendMyHTML(DWORD *pSocket, int myIndex);


__int8 is_user_have_skill_test(DWORD *pUser,int skillID,int skillLevel);
int user_get_skill_level(DWORD *pUser,int skillID, int max_skillLevel);
int *user_GetUsableActiveSkill(DWORD *pUser,int skillID);
void User_HaveSkillEx_1();
int user_get_skill_level_(DWORD *pUser,int skillID);
int user_get_skill_levelToggleON(DWORD *pUser,int skillID);

int Area_SetOnOff(DWORD *pUser,wchar_t * area_name, int on_off);



//exp table: dword_5CCA80
static int expTableC1[102]={ //83 original

0, // 0 level???
0, //1 level
0x44,
0x16B,
0x490,
0x0B44,
0x1796,
0x2C17,
0x4BDF,
0x7A92,
0x0BC65,  
0x11622, //11
0x18D2D,
0x22789,
0x2EBDE, 
0x3E17A,
0x5105B,
0x68130,
0x83D60,
0x0A4F0C,
0x0CC116,
0x0F9F28, //21
0x12F5B2,
0x16D1F7,
0x1B420B,
0x2054DC,
0x261A35,
0x2CA2C2,
0x340019,
0x3C44BA, 
0x458414, 
0x4FD28E, //31
0x5B4588,
0x67F361, 
0x75F37C,
0x855E46, 
0x964D36, 
0x0A8DAD8,
0x0BD22CF, 
0x0D341D7,
0x0EB55D1,
0x1057DBF, //41
0x121D9D1,
0x1408B63, 
0x161B506, 
0x1857A84, 
0x1AC00E3,
0x1D56E6E, 
0x201EAB4, 
0x2319E91, 
0x264B432, 
0x2B6A88D, //51
0x30E341A,
0x36B9C34, 
0x3CF2847, 
0x43921E1, 
0x4CF659F, 
0x56F081E, 
0x6187419,
0x6CC1744,
0x78A6255, 
0x8B87C68, //61
0x9F7F231, 
0x0B497A9E, 
0x0CADD154,
0x0E25B6C4, 
0x1036035F, 
0x1262783E, 
0x14AC2992, 
0x1714323B,
0x199BB3DB, 
0x1C43D6EB, //71
0x1FC047C3, 
0x2423C057, 
0x2981EFB9,
0x2FEF8154, 
0x37822434, 
0x42137547,
0x4E0D1F81,
0x5B88BA88,
0x6AA1038A, 
1810000000, //81 new
1820000000,
1830000000,
1840000000,
1850000000,
1860000000,
1870000000,
1880000000,
1890000000,
190000000,
1910000000, //91
1920000000,
1930000000,
1940000000,
1950000000,
1960000000,
1970000000,
1980000000,
1990000000,
0x7B71E511, //81 original,  100 new
0
};

//trade
PTrade GetActiveTrade(DWORD * pUser);
bool checkTradeValid(PTrade pTrade);
int checkTradeItems(PTrade pTrade); 
int TradeAddItem(DWORD *pUser, PTrade pTrade, DWORD addItemObjID, DWORD addItemID) ;
int checkTradeItems4Confirm(PTrade pTrade);


BYTE getVisualHelmetEnabled();
int getVisualHelmet(int helmet, int chest, int classid, int underwear);
BYTE get_L2_CHRONICLE();
WORD get_OP_TELEPORT_TO_LOCATION_EXT();
WORD get_OP_SHOWSCREENMESSAGE();
WORD get_OP_ExAdenaInvenCount();
WORD get_OP_ExPledgeCount();
DWORD *PledgeGetMemberByCHARId(DWORD *pUser, DWORD* pClan, DWORD charID);
int race_restriction_check(int race, int sex, int checkvalue );

DWORD GetObjectID(DWORD * pObject);
