#include "ODBCClass.h"
// working when project properties not UNICODE, but multibyte


/*-----------------------------------------------------------------*/
/* The Main Function */
/*-----------------------------------------------------------------*/
int main1()
{
	// Declare The Local Memory Variables
	SQLRETURN rc = SQL_SUCCESS;
	SQLCHAR DBName[] = "l2db";
	SQLCHAR SQLStmt[255] = {0};
	// Create An Instance Of The ODBC_Class Class
	ODBC_Class Example;
	// cout<<"Message: 0"<<endl;
	// Connect To The Northwind Sample Database
	if (Example.ConHandle != NULL)
	{
	//	 cout<<"Message: 1"<<endl;
		rc = SQLConnect(Example.ConHandle, DBName, SQL_NTS,
			(SQLCHAR *) "", SQL_NTS, (SQLCHAR *) "", SQL_NTS);
		// Allocate An SQL Statement Handle
		rc = SQLAllocHandle(SQL_HANDLE_STMT, Example.ConHandle,
				&Example.StmtHandle);
		if (rc == SQL_SUCCESS)
		{
	//		cout<<"Message: 2a"<<endl;
			// Define A SELECT SQL Statement
			strcpy((char *) SQLStmt, "SELECT * FROM server");
			// Prepare And Execute The SQL Statement
			rc = SQLExecDirect(Example.StmtHandle, SQLStmt, SQL_NTS);
			// Display The Results Of The SQL Query
			if (rc == SQL_SUCCESS)
			{
				Example.GetResultset();
				// At this point you would want to do something
				// with the resultset, such as display it.
				
				// cout<<"Message: success"<<endl;

			} else {
				//cout<<"Message: failure"<<endl;
			}
		} else {
	//		cout<<"Message: 2b"<<endl;
		}
		// Free The SQL Statement Handle
		if (Example.StmtHandle != NULL)
			SQLFreeHandle(SQL_HANDLE_STMT, Example.StmtHandle);
		// Disconnect From The Northwind Sample Database
		rc = SQLDisconnect(Example.ConHandle);
	}
	// Return To The Operating System
	return 0;
}
