//e_u086_snow  //snow effect


/*
 server packet [ExShowScreenMessagePacket] code 0xFE:0x39
{
	dword	[nMsgType]		// 0 - systemmsg, 1 - user defined text, 2 - npcstring
	dword	[nSysMsgId]		// with nMsgType = 0
	dword	[nWindowType]		// 2 - center
	dword	[nFontSize]		// font size 0 - normal, 1 - small
	dword	[nFontType]
	dword	[nMsgColor]
	dword	[nShadowType]
	dword	[nBackgroundType]
	dword	[nLifeTime]
	dword	[nAnimationTime]
	dword	[nNpcStringId]		// with nMsgType = 2
	string	[wsUserDefinedMsg]	// with nMsgType = 1
}

server packet [ExCleftStatePacket] code 0xFE:0x95
{
	dword case
	{
		0:	// team info
		{
			dword [CombatRemainSec]
			dword [DestroyPoint_blue]
			dword [DestroyPoint_red]
			dword [MasterObjectId_blue]
			dword [MasterObjectId_red]
			string [MasterName_blue]
			string [MasterName_red]
			dword length
			{
				dword [UserObjectId]
				dword [Towers]
				dword [Kills]
				dword [Deaths]
			}[blue_team_size]
			dword length
			{
				dword [UserObjectId]
				dword [Towers]
				dword [Kills]
				dword [Deaths]
			}[red_team_size]
		}
		1:	// tower destroyed
		{
			dword [CombatRemainSec]
			dword [DestroyPoint_blue]
			dword [DestroyPoint_red]
			dword [team]		// blue|red team, who destroy the tower
			dword [tower]		// center|side
			dword [UserObjectId]	// team-member info, who destroy the tower
			dword [Towers]
			dword [Kills]
			dword [Deaths]
		}
		2:	// team CAT(concentrated attack target) changed
		{
			dword [CombatRemainSec]
			dword [team]
			dword [UserObjectId]
			string [UserName]
		}
		3:	// combat result:
		{
			dword [team_winner]	// 0-blue, 1-red, 2-tie
			dword [team_loser]	// 0-blue, 1-red, 2-tie
		}
		4:	// team-member die
		{
			dword [CombatRemainSec]
			dword [DestroyPoint_blue]
			dword [DestroyPoint_red]
			dword [team_die]		// team with dead member
			dword [UserObjectId_die]	// dead team-member info
			dword [Towers_die]
			dword [Kills_die]
			dword [Deaths_die]
			dword [team_kill]		// team with killer
			dword [UserObjectId_kill]	// killer team-member info
			dword [Towers_kill]
			dword [Kills_kill]
			dword [Deaths_kill]
		}
	}[type]
}


 */

#ifndef _USER_COMMAND_
	#include "UserCommand.h"
	#include "ExDoor.h"
	#include "Party.h"
#endif
#include <math.h>
#include "Lines.h"
//extern BYTE L2_CHRONICLE;

//--------------------------------------------------------------------------------------------
//// Function Definitions
//--------------------------------------------------------------------------------------------

/*
nbr	id	name
1	0	a,loc\0
2	1	a,GM\0
3	2	a,Gmcancel\0
4	3	a,gmlist\0
5	4	a,sit\0
6	5	a,stand\0
7	6	a,walk\0
8	7	a,run\0
9	8	a,attack\0
10	9	a,attackforce\0
11	10	a,attackstand\0
12	11	a,trade\0
13	12	a,target\0
14	13	a,targetnext\0
15	14	a,pickup\0
16	15	a,assist\0
17	16	a,Invite\0
18	17	a,Leave\0
19	18	a,Dismiss\0
20	19	a,vendor\0
21	20	a,partymatching\0
22	21	a,socialhello\0
23	22	a,socialvictory\0
24	23	a,socialcharge\0
25	24	a,useskill\0
26	25	a,useskillforce\0
27	26	a,useskillstand\0
28	27	a,useshortcut\0
29	28	a,useshortcutforce\0
30	29	a,useshortcutstand\0
31	30	a,allyinvite\0
32	31	a,allyleave\0
33	32	a,allydismiss\0
34	33	a,allydissolve\0
35	34	a,allycrest\0
36	35	a,allyinfo\0
37	36	a,friendinvite\0
38	37	a,friendlist\0
39	38	a,frienddel\0
40	39	a,buy\0
41	40	a,allywarstart\0
42	41	a,allywarstop\0
43	42	a,allywarsurrender\0
44	43	a,blocklist\0
45	44	a,block\0
46	45	a,unblock\0
47	46	a,socialno\0
48	47	a,socialyes\0
49	48	a,socialbow\0
50	49	a,socialunaware\0
51	50	a,socialwaiting\0
52	51	a,sociallaugh\0
53	52	a,unstuck\0
54	53	a,remaintime\0
55	54	a,socialapplause\0
56	55	a,socialdance\0
57	56	a,socialsad\0
58	57	a,sitstand\0
59	58	a,walkrun\0
*/


void UserCommand(DWORD * pSocket, DWORD dwCommand) 
{
	switch( dwCommand )
	{
	case 0:
		//ShowNPCLocPacket
		ShowLocPacket(pSocket);
		break;

	case 0x34: //unstuck
		// unstuck			AA 34 00 00 00 
		//packet[0] = 0xAA;
		//packet[1] = 0x34;
		//packet[2] = 0x00;
		//packet[3] = 0x00;
		//packet[4] = 0x00;
		break;
	case 0x37:

		// unstuck cancel	37 00 00

		break;
/*
	case 39:
		// buy
		{
		DWORD *pUser1 = GetUser(pSocket);
		if (pUser1 == NULL) return;
		__asm {
			push 0
			mov	ecx, pUser1
			call USER_SENDPRIVATEBUY
		}
		}
		break;
*/
	case 77:
		ShowTimePacket(pSocket); 
		break;
	case 81:
		ShowPartyInfoPacket(pSocket);
		break;
	case 0x64: 

CSocketOLD::Send(pSocket, "cSd", aOPCODE(OP_HTML_TUTORIAL), 
L"<html><body><br>Defaul penalty for ousts is 5 days for clan, if clan ousted member(s), or member(s), if they leaved clan. Default ally oust penalties are 1 day<br>Default pledge and ally dismiss timeout is 7 days, and dismiss penalty is 10 days<br>Default clan level to start war is 3 and member count is 5 (or 15 for Scions of Destiny and above)<br>Default rechallenge penalties are 5 days<br><a action=\"link tutorial_close_0\">Close Window</a></body></html>" ,0);

		break;

//graduatelist itemlist
	case 110:
		SendItemList(GetUser(pSocket), 0, 1, 0); //>>> Packet Dump: aa 6e 00 00 00 
		break;

	}
}



void ShowTimePacket(DWORD * pSocket)
{

if (get_L2_CHRONICLE()<2) return; 

   SYSTEMTIME st;
   GetLocalTime(&st);

   if ( st.wHour < 12 )
      CSocketOLD::Send(pSocket, FORMAT_TIME, aOPCODE(OP_SYS_MSG), 927, 2, 1, st.wHour, 1, st.wMinute);
   else
      CSocketOLD::Send(pSocket, FORMAT_TIME, aOPCODE(OP_SYS_MSG), 928, 2, 1, st.wHour, 1, st.wMinute);


/*
        TEXT = new SysMsgContainer$Types("TEXT", 0);
        NUMBER = new SysMsgContainer$Types("NUMBER", 1);
        NPC_NAME = new SysMsgContainer$Types("NPC_NAME", 2);
        ITEM_NAME = new SysMsgContainer$Types("ITEM_NAME", 3);
        SKILL_NAME = new SysMsgContainer$Types("SKILL_NAME", 4);
        RESIDENCE_NAME = new SysMsgContainer$Types("RESIDENCE_NAME", 5);
        LONG = new SysMsgContainer$Types("LONG", 6);
        ZONE_NAME = new SysMsgContainer$Types("ZONE_NAME", 7);
        ITEM_NAME_WITH_AUGMENTATION = new SysMsgContainer$Types("ITEM_NAME_WITH_AUGMENTATION", 8);
        ELEMENT_NAME = new SysMsgContainer$Types("ELEMENT_NAME", 9);
        INSTANCE_NAME = new SysMsgContainer$Types("INSTANCE_NAME", 10);
        STATIC_OBJECT_NAME = new SysMsgContainer$Types("STATIC_OBJECT_NAME", 11);
        PLAYER_NAME = new SysMsgContainer$Types("PLAYER_NAME", 12);
        SYSTEM_STRING = new SysMsgContainer$Types("SYSTEM_STRING", 13);

CLASSIC SYSTEM MESSAGE
	writeC(0x62);
		writeH(_messageId);
		writeC(args.size());
		
		for (Arg e : args)
		{
			writeC(e.type);
			switch (e.type)
			{
				case TYPE_TEXT:
				case TYPE_PLAYER_NAME:
				{
					writeS((String) e.obj);
					break;
				}
				
				case TYPE_LONG_NUMBER:
				{
					writeQ(((Long) e.obj));
					break;
				}
				
				case TYPE_ITEM_NAME:
				case TYPE_CASTLE_NAME:
				case TYPE_INT_NUMBER:
				case TYPE_NPC_NAME:
				case TYPE_ELEMENT_NAME:
				case TYPE_SYSTEM_STRING:
				case TYPE_INSTANCE_NAME:
				case TYPE_DOOR_NAME:
				{
					writeD(((Number) e.obj).intValue());
					break;
				}
				
				case TYPE_SKILL_NAME:
				{
					int[] skill = (int[]) e.obj;
					writeD(skill[0]); // id
					writeH(skill[1]); // level
					break;
				}
				
				case TYPE_ZONE_NAME:
				{
					Location coord = (Location) e.obj;
					writeD(coord.getX());
					writeD(coord.getY());
					writeD(coord.getZ());
					break;
				}
				
				case TYPE_DAMAGE:
				{
					int[] attr = (int[]) e.obj;
					writeD(attr[0]); // target object id
					writeD(attr[1]); // attaker object id
					writeD(attr[2]); // damage
					break;
				}
				case TYPE_CLASS_NAME:
				{
					writeH(((Number) e.obj).intValue());
					break;
				}
			}
*/



}


void ShowLocPacket(DWORD * pSocket)
{
	int tileX = NULL, tileY = NULL, nRegion = NULL, nLocation = NULL;
	//System Message IDs for different regions



//original by ripper 2006, reworked by smeli 2009 because incorrect work
/*
	//get our x, y, z values
	DWORD * pUserData = GetSharedData( GetUser(pSocket) );

	//grab our data from the user
	double * _x = (double *)GetAddress(pUserData, AI_X_LOC);
	double * _y = (double *)GetAddress(pUserData, AI_Y_LOC);
	double * _z = (double *)GetAddress(pUserData, AI_Z_LOC);
	//copy our values over
	int x =(int) *_x;
	int y =(int) *_y;
	int z =(int) *_z;

	//determine which map tile we are in
	tileX = (( (int)x >> 15 ) + 4 ) & 0x1F;
	tileY = (( (int)y >> 15 ) + 10) & 0x1F;
	tileX =tileX+1;
*/


//rework on
	PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(GetUser(pSocket));
	int x =(int)CSharedDat2->x;
	int y =(int)CSharedDat2->y;
	int z =(int)CSharedDat2->z;

	int tile=map_tile(x, y);
	tileX=(int)(tile/100)-16; 
	tileY=tile-((int)(tile/100))*100;
	tileY=tileY-9;
//rework off

		nLocation = 913; //neutral


	//if we're in an unknown region
	if (tile<1610 || tile > 2526)
		nLocation = 913; //neutral

	//else we're in a known region
	else {
	//find the town id for that tile
		nRegion = _regions[tileY][tileX];
		nLocation = _LOC_MSG[nRegion];
	}

	if (get_L2_CHRONICLE() < LINEAGE2_CLASSIC) {
		CSocketOLD::Send(pSocket, FORMAT_LOCATION, aOPCODE(OP_SYS_MSG), nLocation, 3, 1, x, 1, y, 1, z);
	} else {
		CSocketOLD::Send(pSocket, FORMAT_LOCATION1, aOPCODE(OP_SYS_MSG), nLocation, 1, 7, x, y, z);
	}
//	CSocketOLD::Send(pSocket, FORMAT_LOCATION, aOPCODE(OP_SYS_MSG), nLocation, 3, 1, tileX, 1, tileY, 1, tile);
}


void ShowNPCLocPacket(DWORD * pSocket, PTCharBaseData CSharedDat2, BYTE showCoords)
{
	int tileX = NULL, tileY = NULL, nRegion = NULL, nLocation = NULL;
	//System Message IDs for different regions


//rework on
	int x =(int)CSharedDat2->x;
	int y =(int)CSharedDat2->y;
	int z =(int)CSharedDat2->z;

	int tile=map_tile(x, y);
	tileX=(int)(tile/100)-16; 
	tileY=tile-((int)(tile/100))*100;
	tileY=tileY-9;
//rework off

		nLocation = 913; //neutral


	//if we're in an unknown region
	if (tile<1610 || tile > 2526)
		nLocation = 913; //neutral

	//else we're in a known region
	else {
	//find the town id for that tile
		nRegion = _regions[tileY][tileX];
		nLocation = _LOC_MSG[nRegion];
	}

if (get_L2_CHRONICLE() < LINEAGE2_CLASSIC) {
	if (showCoords == 1)
		CSocketOLD::Send(pSocket, FORMAT_LOCATION, aOPCODE(OP_SYS_MSG), nLocation, 3, 1, x, 1, y, 1, z);
	else
		CSocketOLD::Send(pSocket, FORMAT_LOCATION, aOPCODE(OP_SYS_MSG), nLocation, 3, 1, 0, 1, 0, 1, 0);
} else {

		if (showCoords == 1)
		CSocketOLD::Send(pSocket, FORMAT_LOCATION1, aOPCODE(OP_SYS_MSG), nLocation, 1, 7, x, y, z);
	else
		CSocketOLD::Send(pSocket, FORMAT_LOCATION1, aOPCODE(OP_SYS_MSG), nLocation, 1, 7, 0, 0, 0);

}




//	CSocketOLD::Send(pSocket, FORMAT_LOCATION, aOPCODE(OP_SYS_MSG), nLocation, 3, 1, tileX, 1, tileY, 1, tile);
}






static const wchar_t *fnUCommand001=L"Elhaym::bool CheckIPAddr1(DWORD * pSocket)";
int CheckIPAddr1(DWORD * pSocket)
{
try { _set_se_translator( trans_func );

	in_addr UserIPaddr = GetIP(pSocket, 0x132C);

	int ipaddr[5];
	int ipcheck[5];
	ipcheck[1]=(int) UserIPaddr.S_un.S_un_b.s_b1;
	if (ipcheck[1] == 0) return 2; //anticheat
	ipcheck[2]=(int) UserIPaddr.S_un.S_un_b.s_b2;
	ipcheck[3]=(int) UserIPaddr.S_un.S_un_b.s_b3;
	ipcheck[4]=(int) UserIPaddr.S_un.S_un_b.s_b4;

	 

// Ripper (03:23:12 21/01/2009)
//char * user_ipaddr = inet_ntoa(GetIP(pSocket,0x132C));

	char string[200]="127.0.0.1";

	int ip_cycle=1;
	int ipcorrect = 0;

	 pDebug =ini_read("general", "GMIP", 0);
	if (pDebug != NULL) strcpy(string, pDebug);

		char* token = strtok(string, DELIMITERS);
		while((token != NULL) && (ipcorrect == 0))
		{   
			ipaddr[ip_cycle]= atoi(token);

			if (ip_cycle == 4) {
				if (
					((ipcheck[1] == ipaddr[1]) || (ipaddr[1] == 255)) &&
					((ipcheck[2] == ipaddr[2]) || (ipaddr[2] == 255)) &&
					((ipcheck[3] == ipaddr[3]) || (ipaddr[3] == 255)) &&
					((ipcheck[4] == ipaddr[4]) || (ipaddr[4] == 255))	) ipcorrect = 1;

				ip_cycle = 0; //reset counter
			} //ip cycle == 4

			token = strtok(NULL, DELIMITERS);
			ip_cycle++;
		} //while token

return ipcorrect;


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand001,0);
   throw;       // Pass exception to some other handler
}

}

static const wchar_t *fnUCommand002=L"Elhaym::bool CheckIPAddr2(DWORD * pSocket)";
int CheckIPAddr2(DWORD * pSocket)
{
	try { _set_se_translator( trans_func );

	in_addr UserIPaddr = GetIP(pSocket, 0x132C);

	int ipaddr[5];
	int ipcheck[5];
	ipcheck[1]=(int) UserIPaddr.S_un.S_un_b.s_b1;
	if (ipcheck[1] == 0) return 2; //anticheat
	ipcheck[2]=(int) UserIPaddr.S_un.S_un_b.s_b2;
	ipcheck[3]=(int) UserIPaddr.S_un.S_un_b.s_b3;
	ipcheck[4]=(int) UserIPaddr.S_un.S_un_b.s_b4;


// Ripper (03:23:12 21/01/2009)
//char * user_ipaddr = inet_ntoa(GetIP(pSocket,0x132C));

	char string[200]="127.0.0.1";

	int ip_cycle=1;
	int ipcorrect = 0;

int acc= GetParameter(pSocket, ACC_ID);
char buffer [17];
//int _Radix=10; //base 10 number (decimal)

	//		fileEx << ">>> IP Check ACC value= " << _itoa(acc,buffer,10) << " \n";
	//		fileEx.flush();


	 pDebug =ini_read("IP", _itoa(acc,buffer,10), 0);
	 if (pDebug == NULL)  return 1; //if not defined then player IP is correct 
		 
		
		strcpy(string, pDebug);

		char* token = strtok(string, DELIMITERS);
		while((token != NULL) && (ipcorrect == 0))
		{   
			ipaddr[ip_cycle]= atoi(token);

			if (ip_cycle == 4) {
				if (
					((ipcheck[1] == ipaddr[1]) || (ipaddr[1] == 255)) &&
					((ipcheck[2] == ipaddr[2]) || (ipaddr[2] == 255)) &&
					((ipcheck[3] == ipaddr[3]) || (ipaddr[3] == 255)) &&
					((ipcheck[4] == ipaddr[4]) || (ipaddr[4] == 255))	) ipcorrect = 1;

				ip_cycle = 0; //reset counter
			} //ip cycle == 4

			token = strtok(NULL, DELIMITERS);
			ip_cycle++;
		} //while token

return ipcorrect;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand002,0);
   throw;       // Pass exception to some other handler
}

}

static const wchar_t *fnUCommand003=L"Elhaym::void ShowEnterWorldMessageMAIN(DWORD * pSocket)";
void ShowEnterWorldMessageMAIN(DWORD * pSocket)
{
try { _set_se_translator( trans_func );

DWORD * pUser = GetUser(pSocket);
PTCharBaseData CSharedDat = NULL;

//we will let login only valid users
if (SO_VALID_USER(pUser) == true) {
	CSharedDat = (PTCharBaseData)GetSharedData(pUser);
}


//-------------------------------------------
//GM login
//-------------------------------------------

if (CSharedDat !=NULL) {




	if (_chat_ban_gm_check(pUser)>0) {
				//UPDATE user_data SET builder='10' WHERE (char_id = '5' OR char_id = '7')
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, 
				L"Can use ChatBan command: //stopsay [character_name] [stop_minutes]");
		
	}



if (CSharedDat->nBuilder >0 && CSharedDat->nBuilder <5) { //GM IP check

		int gmCheck =CheckIPAddr1(pSocket);
		if (gmCheck==1) {
				//CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"GM IP Correct. Good luck");
				ExUser * tempExUser = GetExUser( pUser );
				if (tempExUser != NULL) tempExUser ->IS_GM = CSharedDat->nBuilder;
		} else if (gmCheck==2) {
					CSocketOLD::Close(pSocket); 	//cheater GM!!!!
					return;
		} else {
				pDebug =ini_read("general", "GM_IPDisconect", 0);
				if (pDebug == NULL) pDebug="0";
				if (atoi(pDebug) == 1) {  

/*
corund - delfo
procedure Close_socket(Socket: Pointer);
const
  _Close_socket     : TCS = TCS($00539610);
asm
mov ecx,Socket;
mov dword ptr [ecx+$13CC], 2
call _Close_Socket
end;
*/


					CSocketOLD::Close(pSocket); 	//CSocketOLD::Send(pSocket, "c", fOPCODE(OP_LOGOUT);
					return;
				}
				else
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"!!!GM IP NOT Correct!!! Please, contact server administration");
		}


//	pDebug = ini_read("general", "GMHideOff", 0);
//	if (pDebug == NULL)	pDebug="0";
//	if (atoi(pDebug) == 1)
//		CSharedDat->bHide = false;


} //4 GM
}

//-------------------------------------------
//player login
//-------------------------------------------

	if (_chat_ban_global_check(pUser) >0) {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, 
				L"Global chat disabled");
	}

/*
		int playerCheck =CheckIPAddr2(pSocket);
//player IP chack can be done at 08 packet Receiving
		if ( playerCheck==1) {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Player IP Correct. Good luck");
		} else if (playerCheck ==0) {
			
				pDebug =ini_read("general", "PC_IPDisconect", 0);
				if (pDebug == NULL) pDebug="0";
				if (atoi(pDebug) == 1) {  
					CSocketOLD::Close(pSocket); 	//CSocketOLD::Send(pSocket, "c", fOPCODE(OP_LOGOUT);
					return;
				}
			
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"!!!Player IP NOT Correct!!! Please, contact server administration");

		} else {
					CSocketOLD::Close(pSocket); 	//cheater socket close
					return;
		}
*/

pDebug = ini_read("general", "LoginMSG", 0);
if (pDebug != NULL)	
{
	const std::string& str = ini_read("general", "LoginMSG", 0);
	int n=MultiByteToWideChar(CP_ACP, 0, str.c_str(), str.length(), NULL, 0);
	if(n!=0) {
		std::wstring tmp=L"";
		tmp.resize(n);
		MultiByteToWideChar(CP_ACP, 0, str.c_str(), str.length(), &tmp[0], n);
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, &tmp[0]);
			//string st1;
			//fileEx << ">>> MSG value= " << ConvertUnicodeToAnsi(tmp, st1).c_str() << " \n";
			//fileEx.flush();
	}

} else
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, LOGIN_MSG);




				if (get_L2_CHRONICLE() <7)
								return;

CSocketOLD::Send(pSocket, "ch", aOPCODE(OP_SSQ_SKY), 0);

				//ExUser * tempExUser = GetExUser(pUser); 

//cursed sword SSQ sky
/*
	//PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(GetUser(pSocket) );
	DWORD wpn= CSharedDat->nWeaponClassId;
	if (wpn == cZariche || wpn == cAkamanah) {
		//CSocketOLD::Send(pSocket, "ch", fOPCODE(OP_SSQ_SKY, 257);
		//CSocketOLD::Send(pSocket, "ch", fOPCODE(OP_SSQ_SKY, 258);
		if (tempExUser->Zariche > 0)
				tempExUser->cKarma = cNumber;
				tempExUser->Zariche= cLifetime;
				if (!CursedContainer::Instance()->UserExists((BYTE *)pUser)) 
					CursedContainer::Instance()->AddUser((BYTE *)pUser);
	}
*/

//============================================================
// CLASSIC Send ALL Beauty List COST
//============================================================

		if (get_L2_CHRONICLE()>=LINEAGE2_CLASSIC-1) {

		int TYPE_HAIR=0;
		int TYPE_FACE=1;
//hair 10001-10010 //type ==0
//face 20001-20005 //type ==1
		int TYPE_COLOR=2;

		int ismage=helmet_class1(CSharedDat->m_nClass);
		int restrcheck =0;


		DWORD hairCount=0;
		DWORD faceCount=0;


		DWORD btype=0; //menu selection


		hairCount=0;
		faceCount=0;

u8 *_beuatyshop_buffer1 = (u8 *)VirtualAlloc(NULL, _beautyshop_buffer_size2, MEM_COMMIT, PAGE_READWRITE);
BufferWriter paketas1((u8 *)_beuatyshop_buffer1);	

			for (int i=1; i<_beautyshop_hair_cnt; i++)
					{
						restrcheck = CSharedDat->m_nSex,_beuatyshop_hair[i][3];
						if (ismage == 1) restrcheck = CSharedDat->m_nSex,_beuatyshop_hair[i][4];

						if (race_restriction_check(CSharedDat->m_Race,CSharedDat->m_nSex,restrcheck) == 0) 
						{ 
							hairCount++;
							
						}
			}


		paketas1.WriteD(TYPE_HAIR);
		paketas1.WriteD(hairCount);


	for (int i=1; i<_beautyshop_hair_cnt; i++)
		{
			restrcheck = CSharedDat->m_nSex,_beuatyshop_hair[i][3];
			if (ismage == 1) restrcheck = CSharedDat->m_nSex,_beuatyshop_hair[i][4];

			if (race_restriction_check(CSharedDat->m_Race,CSharedDat->m_nSex,restrcheck) == 0) 
			{ 

							paketas1.WriteD(0); 
							paketas1.WriteD(_beuatyshop_hair[i][0]); //id
							paketas1.WriteD(10*_beuatyshop_hair[i][1]); //adena cost
							paketas1.WriteD(1000000); //reset adena
							paketas1.WriteD(_beuatyshop_hair[i][2]); //beauty shop ticket
							paketas1.WriteD(100000000); //limit


			}
		}

				for (int i=1; i<_beautyshop_face_cnt; i++)
					{
						restrcheck = CSharedDat->m_nSex,_beuatyshop_face[i][3];
						if (ismage == 1) restrcheck = CSharedDat->m_nSex,_beuatyshop_face[i][4];

						if (race_restriction_check(CSharedDat->m_Race,CSharedDat->m_nSex,restrcheck) == 0) 
						{ 
							faceCount++;
							
						}
					}

		paketas1.WriteD(TYPE_FACE);
		paketas1.WriteD(faceCount);


					for (int i=1; i<_beautyshop_face_cnt; i++)
					{
						restrcheck = CSharedDat->m_nSex,_beuatyshop_face[i][3];
						if (ismage == 1) restrcheck = CSharedDat->m_nSex,_beuatyshop_face[i][4];

						if (race_restriction_check(CSharedDat->m_Race,CSharedDat->m_nSex,restrcheck) == 0) 
						{ 
							paketas1.WriteD(0); 
							paketas1.WriteD(_beuatyshop_face[i][0]); //hairid
							paketas1.WriteD(10*_beuatyshop_face[i][1]); //adena cost
							paketas1.WriteD(1000000); //reset adena
							paketas1.WriteD(_beuatyshop_face[i][2]); //beauty shop ticket
							paketas1.WriteD(100000000); //limit

			
						
						}
					}


		paketas1.WriteD(TYPE_COLOR);
		paketas1.WriteD(0x00);
/*
		paketas1.WriteD(0x30);
		for (int i=1; i<0x31; i++)
		{
			paketas1.WriteD(_beuatyshop_color[i][5]); //hair id
			paketas1.WriteD(_beuatyshop_color[i][0]); //color id
			paketas1.WriteD(10*_beuatyshop_color[i][1]); //adena cost
			paketas1.WriteD(0); //reset adena
			paketas1.WriteD(0); //beauty shop ticket
			paketas1.WriteD(100000000); //limit
		}
*/



short opcodeEXT=0x177; //classic
if (get_L2_CHRONICLE()<LINEAGE2_CLASSIC) opcodeEXT=0x17E; //epeisodion
if (get_L2_CHRONICLE()>=(LINEAGE2_CLASSIC+2)) opcodeEXT=0x179; //helios


				CSocketOLD::Send((DWORD *)GetParameter(pUser, USER_SOCKET), "chb",
					aOPCODE(OP_EXTENDED), opcodeEXT, 
					_beautyshop_buffer_size,_beuatyshop_buffer1);
				VirtualFree(_beuatyshop_buffer1, _beautyshop_buffer_size2, MEM_DECOMMIT);

				
	}
	



} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand003,0);
   throw;       // Pass exception to some other handler
}

}

void ShowEnterWorldMessageC2(DWORD * pSocket)
{

/*
//Load character manipulations difference from C2 to C3
First file: "E:\3www_release_\LineageII_sina_server_C1\C3_L2Server.exe"
Second file: "E:\3www_release_\LineageII_sina_server_C1\L2Server483.exe"

000659A8 |       B0                | 000659A8 |       A0                |LoadCharacterPacket(CDBSocket *socket, const unsigned char *packet)
------------------------------------------------------------------------
00065EB0 |    E9 4A 27 25 00       | 00065EB0 |    E8 DA F0 FE FF       |LoadCharacterPacket(CDBSocket *socket, const unsigned char *packet)
------------------------------------------------------------------------
00065EF8 | E9 D3 26 25             | 00065EF8 | E8 73 9D 07             |LoadCharacterPacket(CDBSocket *socket, const unsigned char *packet)
------------------------------------------------------------------------
000686B0 |                   FA    | 000686B0 |                   F8    |LoadSelectedCharacterPacket(CDBSocket *socket, const u
------------------------------------------------------------------------

//C3 TIME MANIPULATION!!!!!
00068C40 |    E9 F9 F5 24 00 90    | 00068C40 |    8B 55 B4 52 6A 00    |LoadSelectedCharacterPacket(CDBSocket *socket, const u
------------------------------------------------------------------------
00068D38 |                   14 01 | 00068D38 |                   F8 00 |LoadSelectedCharacterPacket(CDBSocket *socket, const u

----------------.text:00468C17                 call    ??_CL2Time__GetTime_491060
*/

/*
	if (GetExUser0(GetUser(pSocket))->protocol < 480) {

		SYSTEMTIME st;
		GetLocalTime(&st);
		int gametime = st.wHour % 6; //one third of the day is night
		//if ( (st.wHour >=0 && st.wHour <3) || (st.wHour >=6 && st.wHour <9) || (st.wHour >=12 && st.wHour <15) || (st.wHour >=18 && st.wHour <21)  )
		if (gametime <4)
			CSocketOLD::Send(pSocket,"c", 0x1c); //sunrise
		else
			CSocketOLD::Send(pSocket,"c", 0x1d); //sunset
		
		}
*/

    ShowEnterWorldMessageMAIN(pSocket);
}


void ShowEnterWorldMessage_C3(DWORD * pSocket)
{

    ShowEnterWorldMessageMAIN(pSocket);
}


void ShowEnterWorldMessageC4(DWORD * pSocket)
{

    ShowEnterWorldMessageMAIN(pSocket);
}


void ShowEnterWorldMessageC5(DWORD * pSocket)
{

	//SendQuestList(GetUser(pSocket),false); //for C5, C6 clients
	CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 
	//9000 = time, 1 = show

    ShowEnterWorldMessageMAIN(pSocket);
}

void ShowEnterWorldMessageC6(DWORD * pSocket)
{
	
	//SendQuestList(GetUser(pSocket),false); //for C5, C6 clients
	//CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);
	CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 
	//9000 = time, 1 = show

    ShowEnterWorldMessageMAIN(pSocket);

	
	}

void ShowEnterWorldMessageKamael(DWORD * pSocket)
{
	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);

    ShowEnterWorldMessageMAIN(pSocket);

}

void ShowEnterWorldMessageCT2F(DWORD * pSocket)
{
	//CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);
	CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 
	//9000 = time, 1 = show
	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);


    ShowEnterWorldMessageMAIN(pSocket);

	
	}

void ShowEnterWorldMessageCT2P(DWORD * pSocket)
{
//	CSocketOLD::SetClientGameTime(pSocket);
//	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);
	CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 
	//9000 = time, 1 = show
	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);

    ShowEnterWorldMessageMAIN(pSocket);

	
}

void ShowEnterWorldMessageCT2Freya(DWORD * pSocket)
{
//	CSocketOLD::SetClientGameTime(pSocket);
//	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);
	//CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 
//freya:dddddddddddSSSSS
	CSocketOLD::Send(pSocket, "chdddddddddddSSSSS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1,0, 
		LOGIN_MSG,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR); 

	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);

	//9000 = time, 1 = show

    ShowEnterWorldMessageMAIN(pSocket);

	
}


void ShowEnterWorldMessageH5(DWORD * pSocket)
{
//	CSocketOLD::SetClientGameTime(pSocket);
//	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);
	//CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 

	CSocketOLD::Send(pSocket, "chdddddddddddSSSSS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1,-1, 
		LOGIN_MSG,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR); 

CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);


/*
//return "[S]FE:39 ExShowScreenMessage";

		writeH(0x39);
		writeD(_type); // 0 - system messages, 1 - your defined text, 2 - npcstring
		writeD(_sysMessageId); // system message id (_type must be 0 otherwise no effect)
		writeD(_position); // message position
		writeD(_unk1); // ?
		writeD(_size); // font size 0 - normal, 1 - small
		writeD(_unk2); // ?
		writeD(_unk3); // ?
		writeD(_effect == true ? 1 : 0); // upper effect (0 - disabled, 1 enabled) - _position must be 2 (center) otherwise no effect
		writeD(_time); // time
		writeD(_fade == true ? 1 : 0); // fade effect (0 - disabled, 1 enabled)
		writeD(_npcString); // npcString
		if (_npcString == -1)
			writeS(_text); // your text (_type must be 1, otherwise no effect)
		else
		{
			if (_parameters != null)
			{
				for (String s : _parameters)
					writeS(s);
			}
		}
*/



	//9000 = time, 1 = show

    ShowEnterWorldMessageMAIN(pSocket);

	
}


void ShowEnterWorldMessageAwakening(DWORD * pSocket)
{
//	CSocketOLD::SetClientGameTime(pSocket);
//	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);
	//CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 
//freya:dddddddddddSSSSS
	CSocketOLD::Send(pSocket, "chdddddddddddSSSSS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1,-1, 
		LOGIN_MSG,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR); 


	//CSocketOLD::Send(pSocket, "ch", 0x73, 256); //SSQ sky
	//the not SSQ sky but awakening sky, how to remove it


CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);

	//9000 = time, 1 = show

    ShowEnterWorldMessageMAIN(pSocket);

	
}

void ShowEnterWorldMessageLindvior(DWORD * pSocket)
{
//	CSocketOLD::SetClientGameTime(pSocket);
//	CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);
	//CSocketOLD::Send(pSocket, "chddddddddddS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1, LOGIN_MSG); 
//freya:dddddddddddSSSSS


	CSocketOLD::Send(pSocket, "chdddddddddddSSSSS", aOPCODE(OP_EXTENDED), aOPCODEx(get_OP_SHOWSCREENMESSAGE()), 1, -1, 2, 0, 0, 0, 0, 0, 9000,1,-1, 
		LOGIN_MSG,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR,EMPTY_WCHAR); 


	//CSocketOLD::Send(pSocket, "ch", 0x73, 256); //SSQ sky
	//the not SSQ sky but awakening sky, how to remove it


CSocketOLD::Send(pSocket, "cdd", aOPCODE(OP_TIME), CSocketOLD::GetGameTime(), 6);

	//9000 = time, 1 = show

    ShowEnterWorldMessageMAIN(pSocket);

	
}


void ShowPartyInfoPacket(DWORD * pSocket)
{
	DWORD * pUser = GetUser(pSocket);
	DWORD * pParty = GetParty(pUser);

	if (pParty != NULL)
	{
		DWORD dwLoot = GetParameter(pParty, 0x44);
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, aOPCODE(OP_SYS_MSG), 1030);

		switch (dwLoot)
		{
			case 0:   CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, aOPCODE(OP_SYS_MSG), 1031);	break;
			case 1:   CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, aOPCODE(OP_SYS_MSG), 1032);	break;
			case 2:   CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, aOPCODE(OP_SYS_MSG), 1033);	break;
			case 3:   CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, aOPCODE(OP_SYS_MSG), 1034);	break;
			case 4:   CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, aOPCODE(OP_SYS_MSG), 1035);	break;
		}
	}
}

/*
__declspec(naked) void WarehousePrivilegies()
{
	//..jmp 516907 + 1 nop
	__asm {
		mov edi,[eax][000000A0h]
		call dword ptr[edx][0000012ch] 
		cmp edi,eax
		je short valid

		//mov		eax, [ebx+0F54h] //this is NPC warehouser
		//19b8 = usersocket
		mov		eax, [esi+0F54h]
		//cmp		eax,0  // is user null
		mov		eax, [eax+065Ch] // respawn time, used as privilegies field
		cmp		eax,10
		jge		short valid

		jmp  short not_valid
valid:
		push 0516933h
		retn
not_valid:
		push 0516917h //"only clan leader enabled" message
		retn


	}
}
*/


void RequestBlock(WCHAR *wszMemberName, DWORD blocktype, DWORD *pSocket, DWORD *pUser, ExUser *tempExUser)
{

					if (tempExUser->BlockBuff == 0) {
						tempExUser->BlockBuff=1;
						CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
						614, 1 , 0, L"All not self buffs and single-heals are blocked now!");
					} else {
						tempExUser->BlockBuff=0;
						CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 
						614, 1 , 0, L"All not self buffs and single-heals are allowed now!");
					}

}







static const wchar_t *fnUCommand004=L"Elhaym::void loot_the_body(DWORD *pSocket, DWORD targetID)";
int loot_the_body(DWORD *pSocket,DWORD *pUserMe, DWORD targetID, BYTE chronicle)
{
	try { _set_se_translator( trans_func );
	
	DWORD * pUser = CCreature::GetCreature(targetID);
	if (pUser == NULL) return 0; //cant loot this

	ExUser * tempExUser = GetExUser( pUserMe );
	ExUser * tempExUserVictim = GetExUser( pUser );

	PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
	PTCharBaseData CSharedDatMe = (PTCharBaseData)GetSharedData(pUserMe);
	if (CSharedDat == NULL) return 0;
	DWORD * pUserInventory = GetUserInventory(pUser);
	if (pUserInventory == NULL) return 0; //loot body does not have inventory
	if (CSharedDat->nIsPC == 0) return 0; // is not PC
	if (CSharedDat->nIsAlive != 0 && CSharedDat->m_bIsStanding!=0) //pUser!=pUserMe && 
	{
		//RequestEvaluate(pSocket, targetID); //live person recomend
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Can't loot");
		return 0; //alive and not myself
	}
	if (CSharedDatMe->nIsAlive == 0) {
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Dead can dance, but can't loot");
		return 0; //alive and not myself
	}

DWORD * pItem=NULL;
PItemData itmdata=NULL;
PItemDat itminfo=NULL;
BYTE icount=0;
DWORD adena=CInventory::GetAdenaAmount(pUserInventory);
DWORD listID=0xAA;
u8 *pBufferNew = (u8 *)VirtualAlloc(NULL, 10000, MEM_COMMIT, PAGE_READWRITE);
BufferWriter pCSIPacket(pBufferNew);
DWORD soid[14];
//DWORD idx;
DWORD item_id;

soid[1]=CSharedDat->nObjIdREar;
soid[2]=CSharedDat->nObjIdNeck;
soid[3]=CSharedDat->nObjIdLRing;
soid[4]=CSharedDat->nObjIdRRing;
soid[5]=CSharedDat->nObjIdHead;
soid[6]=CSharedDat->nObjIdGloves;
soid[7]=CSharedDat->nObjIdOnePiece;
soid[8]=CSharedDat->nObjIdChest;
soid[9]=CSharedDat->nObjIdFeet;
soid[10]=CSharedDat->nObjId2Hand;
soid[11]=CSharedDat->nObjIdLHand;
soid[12]=CSharedDat->nObjIdRHand;
soid[13]=CSharedDat->nObjIdLegs;
soid[14]=CSharedDat->nObjIdLEar;

		//ExUser * tempExUser = GetExUser(pUser);


for (int icycle=1; icycle<14; icycle++) 
	for (int kcycle=icycle+1; kcycle<15; kcycle++) 
		if (soid[icycle] == soid[kcycle]) soid[kcycle]=0;

for (int zcycle=1; zcycle<15; zcycle++) {
	if (soid[zcycle] > 0) {
		pItem = CInventory::FindByIndex(pUserInventory, soid[zcycle]); //? 
		if (pItem != NULL) itmdata = (PItemData)GetSharedData2(pItem);
		if (itmdata != NULL) {
			itminfo = (PItemDat)GetSharedData22(pItem);
			item_id = itmdata->m_nClassId;

				if (itmdata->m_nConsumeType == 0)
				{
				icount++;


				if (chronicle==2) {

						pCSIPacket.WriteH(itmdata->m_nItemType); // item type1
						pCSIPacket.WriteD(soid[zcycle]); //object id
						pCSIPacket.WriteD(itmdata->m_nClassId); //item id
						pCSIPacket.WriteD(itmdata->m_nCount);
						pCSIPacket.WriteH(itmdata->m_nItemType); // item type2 = 0 weapon, 1.....
						pCSIPacket.WriteH(0); //custom type 1
						pCSIPacket.WriteD(itmdata->m_nSlotBitType); // bodypart (slot)
						pCSIPacket.WriteH(itmdata->m_nEnchantLevel);
						pCSIPacket.WriteH(0); //custom type 2
						pCSIPacket.WriteH(0);
						pCSIPacket.WriteD(itminfo->price); //price					

				} else {


						pCSIPacket.WriteD(itmdata->m_nClassId);
						pCSIPacket.WriteH(itmdata->m_nItemType); // item type2 = 0 weapon, 1.....
						pCSIPacket.WriteH(itmdata->m_nSlotBitType); // bodypart (slot)
						pCSIPacket.WriteD(itminfo->price); //price
						if (chronicle>=9) {
							//if (get_L2_CHRONICLE()>=9)
							pCSIPacket.WriteD(0); //Gracia Finall price addon
						}




				}

				
			}
		}
	}
}

	if (icount >0) {
//	CSocketOLD::Send(pSocket,"cccccddhb", fOPCODE(OP_WEAR, 0xC0, 0x13, 0, 0, adena, listID, icount, pCSIPacket.size, pCSIPacket.buffer);


		if (chronicle = 2) {

			CSocketOLD::Send(pSocket,"cddhb", 0xE8, adena, targetID, icount, pCSIPacket.size, pCSIPacket.buffer); //package sendable list
		} else if(chronicle <9) 
		{
			CSocketOLD::Send(pSocket,"cdddhb", aOPCODE(OP_WEAR), 0, adena, listID, icount, pCSIPacket.size, pCSIPacket.buffer);
		} else {
			CSocketOLD::Send(pSocket,"cddddhb", aOPCODE(OP_WEAR), 0, adena,0, listID, icount, pCSIPacket.size, pCSIPacket.buffer);
		}

	} else {
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"You cant loot last trousers of poor victim.");
	}

	VirtualFree(pBufferNew, 10000, MEM_DECOMMIT);

	return 1;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand004,0);
   throw;       // Pass exception to some other handler
}


	}


static const wchar_t *fnUCommand005=L"Elhaym::void request_loot(DWORD *pSocket, DWORD item_id)";
void request_loot(DWORD *pSocket,DWORD *pUser, DWORD item_id,DWORD item_oid, BYTE chronicle)
{

	if (pUser == NULL) return;


	try { _set_se_translator( trans_func );

	if (item_id > 20000) {
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Item id is over limits");
		return;

	}

if (GetParameter8(pUser,bIsCombatMode) == 1) 	
{
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"No looting while in combat.");
	return;
}

PTCharBaseData CSharedDat = (PTCharBaseData)GetSharedData(pUser);
if(CSharedDat == NULL) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Ahehe.");
	return;
}



DWORD targetID =CSharedDat->nTargetObjId;
if(targetID == 0) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Select target, looter!");
	return;
}



		DWORD *pUser2 = CCreature::GetCreature(CSharedDat->nTargetObjId);
		if(pUser2 == NULL) {
			CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Null target selected!");
			return;
		}
if(pUser2 == pUser) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Looting success!");
	return;
}
if (CheckTrade(pUser2)) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Looting unsuccess!");
	return;
}
if(GetActiveTrade(pUser2) != NULL)
{
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Looting unsuccess!!");
	return;
}



PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(pUser2);
if (CSharedDat2 == NULL)  {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Ahehe..");
	return;
}
if (CSharedDat2->nIsPC == 0) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Mobs can be looted! But only via drop and spoil");
	return; // is not PC
}
if (CSharedDat2->nIsAlive != 0) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Not dead yet");
	return;
}
if (CSharedDat->nIsAlive == 0) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Dead can dance");
	return;
}

if (CSharedDat->m_nPrivateSlots>79) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Inventory already full of loot");
	return;

}

if (CSharedDat->bHide !=0) {
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Not alowed to loot in hidden mode");
	return;

}

if (loot_restrictor((int)CSharedDat2->x, (int)CSharedDat2->y))
{
	//loot allowed in this territory
	//CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Trying to loot...");

} else {
	if (CSharedDat->nBuilder != 1) {
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Looting is restricted in this territory!");
		return; //for GM 1 level only for now
	} else {
		CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Only lvl1 builder can loot in this territory");
	}
}



DWORD * pUserInventory= GetUserInventory(pUser2);
if (pUserInventory == NULL) 
{
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"No inventory found");
	return;
}

		DWORD soid[14];
soid[1]=CSharedDat2->nObjIdREar;
soid[2]=CSharedDat2->nObjIdNeck;
soid[3]=CSharedDat2->nObjIdLRing;
soid[4]=CSharedDat2->nObjIdRRing;
soid[5]=CSharedDat2->nObjIdHead;
soid[6]=CSharedDat2->nObjIdGloves;
soid[7]=CSharedDat2->nObjIdOnePiece;
soid[8]=CSharedDat2->nObjIdChest;
soid[9]=CSharedDat2->nObjIdFeet;
soid[10]=CSharedDat2->nObjId2Hand;
soid[11]=CSharedDat2->nObjIdLHand;
soid[12]=CSharedDat2->nObjIdRHand;
soid[13]=CSharedDat2->nObjIdLegs;
soid[14]=CSharedDat2->nObjIdLEar;
		


		PItem pItem=NULL;
//		FVector *vekt;  //??? how initialize it?
//		vekt->x=(int)CSharedDat2->x + 10;
//		vekt->y=(int)CSharedDat2->y;
//		vekt->z=(int)CSharedDat2->z; 





	ExUser * tempExUser = GetExUser( pUser2 );
	if (tempExUser != NULL) {
		if (((tempExUser->LOOT_TIME + 60000) > GetTickCount() )  && (tempExUser->LOOT_TIME != 0)) {
			CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Looting time is 1 minute");
			return;
		}

	}


	//tempExUser->LootID
	DWORD checkitem=0;
	PItemData itmdata = NULL; //(PItemData)GetSharedData2(pItem);


	if (item_id != 0) {
			pItem = (PItem)CInventory::FindFirstItemByClassID(pUserInventory, item_id); 

			if (pItem == NULL) {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Item id not found");
				return;
			}

			while ( (checkitem ==0) && (pItem != NULL) ) {

				itmdata = (PItemData)GetSharedData2((DWORD*)pItem);

				for (int zcycle=1;zcycle<15;zcycle++) {
					if (soid[zcycle] == itmdata->SOID) checkitem=1;
				}
				
				if (checkitem ==0) {
					//we found the item, but not one player had equipped, try to find again
					pItem = (PItem)CInventory::FindNextItemByClassID(pUserInventory, itmdata->m_nClassId); 
				}
			
			}

			if (pItem == NULL) {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Ahehe...What you think you are looting?");
				return;
			}


	} else {
			if (item_oid == 0) {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Null item soid");
				return;
			}
			pItem = (PItem)CInventory::FindByServerID(pUserInventory, item_oid);  
			//pItem = CInventory::FindByIndex(pUserInventory, item_oid);
			//pItem = CInventory::FindByDBID(pUserInventory, item_oid);
		
			if (pItem == NULL) {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Item soid not found");
				return;
			}
			itmdata = (PItemData)GetSharedData2((DWORD *)pItem);

				for (int zcycle=1;zcycle<15;zcycle++) {
					if (soid[zcycle] == itmdata->SOID) checkitem=1;
				}

				if (checkitem ==0) {
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Ahe, what you think you are looting?");
					return;
				}

	}



		int checkChance = (BYTE)MyRandom(100);
		int chance = 100; //for testing purposes make chance 100%

			if (checkChance < chance)
			{

				if ((item_id == 2368) || (item_id == 2369) || (item_id == 2370) || (item_id == 2370) ||  
					(item_id == 10) || (item_id == 6) || (item_id == 1146) || (item_id == 1147) ||
					(item_id == 425) || (item_id == 461)) 
				{
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Newbie items cannot be looted");
					return;
				}


					DeleteItemInInventory(pUser2, item_id, 1);
					AddItemToInventory(pUser, item_id, 1, 0);
					if (tempExUser != NULL) tempExUser->LOOT_TIME = GetTickCount();
					CSocketOLD::Send((DWORD *)GetParameter(pUser2, USER_SOCKET), FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"You just jave been looted!");
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Looting done");
			} else {
				CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"Looting unsuccessfull!");
			}
		

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand005,0);
   throw;       // Pass exception to some other handler
}

}





static const wchar_t *fnUCommand006=L"Elhaym::void RequestEvaluate(DWORD * pSocket, DWORD targetID)";	
void RequestEvaluate(DWORD * pSocket, DWORD targetID)
{
try { _set_se_translator( trans_func );

	if(pSocket != NULL)
	{
		DWORD * pUser = GetUser(pSocket);
		if(pUser != NULL)
		{
			ExUser * tempExUser = GetExUser(pUser);
			DWORD * pUserData = GetSharedData(pUser);
			DWORD objectID = GetParameter(pUser, OBJECT_ID);
			DWORD * pTargetUser = CCreature::GetCreature(targetID);
			
			if(pUserData != NULL && tempExUser != NULL)
			{
				if(pTargetUser == NULL)
				{
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, 0x64, 144, 0);	//TARGET_IS_INCORRECT
				}
				else if( !GetParameter( GetSharedData(pTargetUser), AI_IS_PLAYER ) )
				{
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, 0x64, 144, 0);	//TARGET_IS_INCORRECT
				}
				else if( GetParameter(pUserData, AI_LEVEL) < 10 )
				{
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, 0x64, 898, 0);	//YOU_ARE_NOT_LEVEL_10
				}
				else if(tempExUser->EvalLeft == 0)
				{
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, 0x64, 833, 0);	//YOU_HAVE_NO_RECOMMENDS_LEFT
				}
				else if(targetID == objectID)
				{
					CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, 0x64, 829, 0);	//YOU_CANT_RECOMMEND_YOURSELF
				}
				else
				{
					DWORD * pTargetSocket = (DWORD *)GetParameter(pTargetUser, USER_SOCKET);
					ExUser * targetExUser = GetExUser(pTargetUser);

					if(targetExUser != NULL)
					{
						if(targetExUser->EvalScore == 255)
						{
							//YOU_CAN_NO_LONGER_RECEIVE_RECOMMENDATIONS
							CSocketOLD::Send(pSocket, FORMAT_SYS_MSG1, 0x64, 1188, 0);
						}
						else
						{
							WCHAR * charName = (WCHAR *)GetAddress(pUserData, AI_NAME);
							WCHAR * targetName = (WCHAR *)GetAddress( GetSharedData(pTargetUser), AI_NAME);

							tempExUser->EvalLeft--;
							//YOU_HAVE_RECOMMENDED_S1_AND_HAVE_S2_RECOMMENDS_LEFT
							CSocketOLD::Send(pSocket, FORMAT_RECOMMEND2, 0x64, 830, 2, 0, targetName, 1, tempExUser->EvalLeft);
							targetExUser->EvalScore++;
							//YOU_HAVE_BEEN_RECOMMENDED_BY_S1
							CSocketOLD::Send(pTargetSocket, FORMAT_RECOMMEND, 0x64, 831, 1, 0, charName);

							//Send new UserInfo to both players so their stats update
							SendUserInfo(pUser, 0);
							SendUserInfo(pTargetUser, 0);
							SendCharInfo(pTargetUser, 0);

							//TODO: SQL saving
							//CDBSend(0x1720CB90, "cdddddd", 0xe7, *(unsigned int*)(pUser + 0x18), *(unsigned int*)(pUser + 0x14), TSharedData->RecomLeft, *(unsigned int*)(pUserTarget + 0x18), *(unsigned int*)(pUserTarget + 0x14), TargetSharedData->RecomHave);
						}
					}
				}
			}
		}
	}

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand006,0);
   throw;       // Pass exception to some other handler
}

}


static const wchar_t *fnUCommand007=L"Elhaym::void RequestRecipeBook(DWORD *pSocket, DWORD *pUser, PTCharBaseData CSharedDat, short isdwarf, BYTE chronicle)";
void RequestRecipeBook(DWORD *pSocket, DWORD *pUser, PTCharBaseData CSharedDat, short isdwarf, BYTE chronicle)
{
	try { _set_se_translator( trans_func );

	//isdwarf
	//-1 - not used
	//4 - dwarf
	




/*
		writeC(0xdc);
		writeD(_isDwarvenCraft ? 0x00 : 0x01); //0 = Dwarven - 1 = Common
	 	writeD(_maxMp);
		writeD(_recipes.length);//number of items in recipe book
			for (int i = 0; i < _recipes.length; i++)
			{
				L2RecipeList temp = _recipes[i];
				writeD(temp.getId());
				writeD(i+1);
			}
*/

		int myrecipesindex=0;
		int myrecipes[51];
		int lastindex=1;
		int myrecipe=0;
		int myrecipeid=0;

		DWORD * pUserInventory = GetUserInventory(pUser);
		DWORD * pItem; // = CInventory::FindFirstItemByClassID(pUserInventory, 57); //adena




			for (int ickl=0; ickl<_recipeDBsize; ickl++)
			{
				myrecipe=_recipeDB[ickl][1];
//		fileEs << ">>> recipe (0x" << hex <<  myrecipe << ") \n";
//		fileEs.flush();
				if (myrecipe>0)
					pItem = CInventory::FindFirstItemByClassID(pUserInventory, myrecipe); 
				if (pItem != NULL) 
				{
					myrecipesindex++;
					myrecipeid=_recipeDB[ickl][0];
//		fileEs << ">>> recipe id (0x" << hex <<  myrecipeid << ") \n";
//		fileEs.flush();
					if (myrecipesindex<50)
						myrecipes[myrecipesindex] = myrecipeid ;
					else
						ickl = 1000;
				}
			}


if (myrecipesindex > 0) {

	u32 nbSize =1000;
	lastindex=0;

	u8 *pBufferNew = (u8 *)VirtualAlloc(NULL, nbSize, MEM_COMMIT, PAGE_READWRITE);
	BufferWriter pCSIPacket(pBufferNew);	

	 for( int i =  1; i < myrecipesindex+1 ; i++)
	 { 
		if (myrecipes[i]>0)
		{
					pCSIPacket.WriteD(myrecipes[i]); 
					lastindex++;
					pCSIPacket.WriteD(lastindex); 
		} 
	 }


	if (isdwarf == 4)
		CSocketOLD::Send(pSocket,"cdddb", aOPCODE(OP_RECIPE_BOOK), 0, (int)CSharedDat->fMaxMP, lastindex, pCSIPacket.size, pCSIPacket.buffer);
	else if(isdwarf == -1)
		CSocketOLD::Send(pSocket,"cddb", aOPCODE(OP_RECIPE_BOOK), (int)CSharedDat->fMaxMP, lastindex, pCSIPacket.size, pCSIPacket.buffer);
	else
		CSocketOLD::Send(pSocket,"cdddb", aOPCODE(OP_RECIPE_BOOK), 1, (int)CSharedDat->fMaxMP, lastindex, pCSIPacket.size, pCSIPacket.buffer);

	VirtualFree(pBufferNew, nbSize, MEM_DECOMMIT);


} else
	CSocketOLD::Send(pSocket, FORMAT_SYS_MSG_TXT, aOPCODE(OP_SYS_MSG), 614, 1 , 0, L"You have no recipes in your inventory");


} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand007,0);
   throw;       // Pass exception to some other handler
}

}



static const wchar_t *fnUCommand008=L"Elhaym::bool RequestRide(DWORD *pUser, PTCharBaseData CSharedDat)";
bool RequestRide(DWORD *pUser, PTCharBaseData CSharedDat)
{
try { _set_se_translator( trans_func );

	if (CSharedDat->nMountType !=0)
		return true;

	DWORD *pPet = GetPet(pUser);
	if (pPet !=NULL)
	{
			 PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(pPet);
			 int petID=CSharedDat2->m_nClassId;
			if (petID == PET_RIDE_WOLF || petID == PET_RIDE_LION || petID == PET_RIDE_HORSE ||
				petID == PET_RIDE_STEAM || petID == PET_RIDE_STRIDER || petID == PET_RIDE_WYVERN ||
				petID == PET_RIDE_STRIDER_WIND || petID == PET_RIDE_STRIDER_STAR) 
			{
				if (CSharedDat2->nIsAlive)
								return true;
			}

	}
return false;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand008,0);
   throw;       // Pass exception to some other handler
}

}


static const wchar_t *fnUCommand009=L"Elhaym::bool RequestMultisell(DWORD *pUser, PTCharBaseData CSharedDat, int multisellID)";
bool RequestMultisell(DWORD *pUser, PTCharBaseData CSharedDat, int multisellID)
{
	try { _set_se_translator( trans_func );

	int npcclassIDmatch=0;
	int npcmasterLVLmatch=0;
	int checkLVL=0;

//		fileEs << ">>> multisell-id1 (0x" << hex <<  multisellID << ") \n";
//		fileEs.flush();

//available for GM only
//now available for all         if (CSharedDat->nBuilder !=0) 
{
//player selected target - must be dwarf's wolf
	if (CSharedDat->nTargetObjId !=0) {
//		DWORD *pUser2=(DWORD *)UserContainer::Instance()->GetUserByObjId(CSharedDat->nTargetObjId);
		DWORD *pUser2=CCreature::GetCreature(CSharedDat->nTargetObjId);

//selected target not gone
		if (pUser2 != NULL) {
//	fileEs << ">>> multisell-id2a (0x" << hex <<  CSharedDat->nTargetObjId << ") \n";
//	fileEs.flush();
			 PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(pUser2);
			 npcclassIDmatch=CSharedDat2->m_nClassId;
//	fileEs << ">>> multisell-id2b (0x" << hex <<  npcclassIDmatch << ") \n";
//	fileEs.flush();
//selected target is wolf
			 if (npcclassIDmatch == PET_WOLF_A) {
				pUser2= CCreature::GetMaster(pUser2);
//wolf's master not gone
				if (pUser2 != NULL) {
				 PTCharBaseData CSharedDat2 = (PTCharBaseData)GetSharedData(pUser2);
//	fileEs << ">>> multisell-id2c (0x" << hex <<  CSharedDat2->m_Race << ") \n";
//	fileEs.flush();
//wolf's master is dwarf
				 if (CSharedDat2->m_Race ==4 && CSharedDat2->nIsPC) 
				 {
//	fileEs << ">>> multisell-id2d (0x" << hex <<  CSharedDat2->m_nClass << ") \n";
//	fileEs.flush();
//wolf's master is artisan or warsmith
					 if (CSharedDat2->m_nClass == 56 || CSharedDat2->m_nClass == 57) {
							if (CSharedDat2->nTargetObjId !=0) {
								DWORD *pUser3=CCreature::GetCreature(CSharedDat2->nTargetObjId);						
//dwarf selected player
								if (pUser3 != NULL && pUser == pUser3) {
									npcmasterLVLmatch =CSharedDat2->nLevel;
								} //player is correct
							} //dwarf selected player
					 } //dwarf is crafter
				 } //wolf's master is dwarf
				} //wolf master not null
			 } //wolf id correct
		} //wolf not null
	} //wolf selected
} //GM only

//		fileEs << ">>> multisell-id3 (0x" << hex <<  npcclassIDmatch << ") \n";
//		fileEs.flush();



		for( int i =  0; i < 54 ; i++)
		{ 
	
			if (_multisellDB[i][2]<10 && _multisellDB[i][0]==multisellID && npcclassIDmatch!=1000000+_multisellDB[i][1] )
			{
//		fileEs << ">>> multisell-id-4a "  << " \n";
//		fileEs.flush();
				//recipe shop check not ok
				return false;
			} else if (_multisellDB[i][2]<10 && _multisellDB[i][0]==multisellID) {
//		fileEs << ">>> multisell-id-4b "  << " \n";
//		fileEs.flush();
				//recipe shop check ok
				if(_multisellDB[i][2] ==1)
					checkLVL=5;
				else if(_multisellDB[i][2] ==2)
					checkLVL=20;
				else if(_multisellDB[i][2] ==3)
					checkLVL=28;
				else if(_multisellDB[i][2] ==4)
					checkLVL=36;
				else if(_multisellDB[i][2] ==5)
					checkLVL=43;
				else if(_multisellDB[i][2] ==6)
					checkLVL=49;
				else if(_multisellDB[i][2] ==7)
					checkLVL=55;
				else if(_multisellDB[i][2] ==8)
					checkLVL=62;
				else if(_multisellDB[i][2] ==9)
					checkLVL=70;

				if (npcmasterLVLmatch<checkLVL)
					return false;

				return true;
			} else if (_multisellDB[i][2]==10 && _multisellDB[i][0]==multisellID) {
//		fileEs << ">>> multisell-id-4c "  << " \n";
//		fileEs.flush();
				//multisell without npc
				return true;

			
			} else if (_multisellDB[i][2]>10 && _multisellDB[i][0]==multisellID && npcclassIDmatch==1000000+_multisellDB[i][1]) {
//		fileEs << ">>> multisell-id-4d "  << " \n";
//		fileEs.flush();
				//multisell with NPC npcID mach
				return true;

			
			} else if (_multisellDB[i][2]>10 && _multisellDB[i][0]==multisellID) {
//		fileEs << ">>> multisell-id-4e "  << " \n";
//		fileEs.flush();
				//multisell with NPC npcID mismach
				return false;

			}
		}			

//not handled multisell
return true;

} catch(...) {  // Handle all exceptions
   // Respond (perhaps only partially) to exception
FunctionNameTracker(NULL,fnUCommand009,0);
   throw;       // Pass exception to some other handler
}


}


double DistanceSD(PTCharBaseData SD, double x1, double y1, double z1)
{
	double x2 = SD->x;
	double y2 = SD->y;
	double z2 = SD->z;

	return sqrt(pow((x2-x1),2)+pow((y2-y1),2)+pow((z2-z1),2));
}


double Distance(DWORD * pUser,double x1, double y1, double z1)
{

					PTCharBaseData CSharedDat;
					if (pUser != NULL) 
						CSharedDat = (PTCharBaseData)GetSharedData(pUser);
					else 
						return 0;

	double x2 = CSharedDat->x;
	double y2 = CSharedDat->y;
	double z2 = CSharedDat->z;

	return sqrt(pow((x2-x1),2)+pow((y2-y1),2)+pow((z2-z1),2));
}





bool check_stackable(int itemID) {

	for (int i=0; i<_stackables_cnt;i++) {
		if (_stackables[i] == itemID) return true;
	}
return false;

}

bool check_questitems(int itemID) {

	for (int i=0; i<_questitems_cnt;i++) {
		if (_questitems[i] == itemID) return true;
	}
return false;

}



bool check_stackable_obj(DWORD *pUser, int DobjectID) 
{

			DWORD * pUserInventory = GetUserInventory(pUser);
			DWORD * pItem = CInventory::FindByServerID(pUserInventory, DobjectID); //? 
			//DWORD * pItem = CInventory::FindByIndex(pUserInventory, DobjectID); //? 
			PItemData itmdata=NULL;
			//DWORD useitemID=0;
			if (pItem != NULL) itmdata = (PItemData)GetSharedData2(pItem);
			if (itmdata != NULL) {
				if (itmdata->m_nConsumeType >1) return true;
				//useitemID = itmdata->m_nClassId;
				
			} else {
				return false;
			}
	
			
			//return check_stackable(useitemID);
			return false;

}



 DWORD _chat_ban_global_check(DWORD *pUser)
{

	   	for (int i = 0; i < _chat_ban_global_cnt; i++)
		{
				//file << "ChatBan GM check. Char ID: " << _chat_ban_gms[i] << "\n";
				//file.flush();

		  if (_chat_ban_globals[i] == 0) return 0;
		  if (_chat_ban_globals[i] == GetParameter(pUser, CHAR_ID) ) 
		  {
				return 1;
		  }
		}

return 0;

}


 DWORD _chat_ban_gm_check(DWORD *pUser)
{

	   	for (int i = 0; i < _chat_ban_gm_cnt; i++)
		{
				//file << "ChatBan GM check. Char ID: " << _chat_ban_gms[i] << "\n";
				//file.flush();

		  if (_chat_ban_gms[i] == 0) return 0;
		  if (_chat_ban_gms[i] == GetParameter(pUser, CHAR_ID) ) 
		  {
				return 1;
		  }
		}

return 0;

}


DWORD _chat_ban_global_set(DWORD charid)
{
	
	   	for (int i = 0; i < _chat_ban_global_cnt; i++)
		{
			if (_chat_ban_globals[i] == 0 ) 
			{

			//	file << "ChatBan GM set. Char ID: " << gmid << "\n";
			//	file.flush();

				_chat_ban_globals[i] = charid;
				return 1;
			}

		}

return 0;

}


DWORD _chat_ban_gm_set(DWORD charid)
{
	
	   	for (int i = 0; i < _chat_ban_gm_cnt; i++)
		{
			if (_chat_ban_gms[i] == 0 ) 
			{

			//	file << "ChatBan GM set. Char ID: " << gmid << "\n";
			//	file.flush();

				_chat_ban_gms[i] = charid;
				return 1;
			}

		}

return 0;

}


/*
AWAKENING
D0:94 - RequestFlyMove
D0:B4 - RequestFlyMoveStart (ch)

ExNotifyFlyMoveStart fe:114 (in)     
 0xd0:0xb4 (out)  
 ExFlyMove fe:e7 (in)     

ddddd ddddd

 ExFlyMoveBroadcast fe:10c (in)       knownlist

(dddddddddd)


FE:113 - ExAlterSkillRequest
writeC(0xfe); 
writeH(0113); 
//ddd 
writeD(0);//id  (     ) 
writeD(0); //  
writeD(0);//     

*/

void RequestFlyMove(DWORD * pSocket, DWORD * pUser, PTCharBaseData CSharedDat)
{

	CSocketOLD::Send(pSocket, "ch", aOPCODE(OP_EXTENDED), aOPCODEx(0x114));

}

void StartFlyMove_Awakening(DWORD * pSocket, DWORD * pUser, PTCharBaseData CSharedDat)
{

	CSocketOLD::Send(pSocket, "ch", aOPCODE(OP_EXTENDED), aOPCODEx(0xe7));

	//d-object d-x d-y d-z d-x1 d-y1 d-z1 ddd
	//L2Server::BroadcastToAllUser("chd", aOPCODE(OP_EXTENDED), aOPCODEx(0x10c), GetParameter(pUser, OBJECT_ID)); 

}