#pragma once

#define SKILL_OPERATE_TYPE_A1 0
#define SKILL_OPERATE_TYPE_A2 1
#define SKILL_OPERATE_TYPE_A3 2
#define SKILL_OPERATE_TYPE_P 3
#define SKILL_OPERATE_TYPE_T 4
#define SKILL_OPERATE_TYPE_PP 5

#define SKILL_BASIC_PROPERTY_STR 1
#define SKILL_BASIC_PROPERTY_DEX 2
#define SKILL_BASIC_PROPERTY_CON 3
#define SKILL_BASIC_PROPERTY_INT 4
#define SKILL_BASIC_PROPERTY_MEN 5
#define SKILL_BASIC_PROPERTY_WIT 6
#define SKILL_BASIC_PROPERTY_NONE 0x19

#define SKILL_ABNORMAL_TYPE_PA_UP 0
#define SKILL_ABNORMAL_TYPE_PA_UP_SPECIAL 1
#define SKILL_ABNORMAL_TYPE_PA_DOWN 2
#define SKILL_ABNORMAL_TYPE_PD_UP 3
#define SKILL_ABNORMAL_TYPE_PD_UP_SPECIAL 4
#define SKILL_ABNORMAL_TYPE_PD_DOWN 5
#define SKILL_ABNORMAL_TYPE_MA_UP 6
#define SKILL_ABNORMAL_TYPE_MD_UP 7
#define SKILL_ABNORMAL_TYPE_MD_UP_ATTR 8
#define SKILL_ABNORMAL_TYPE_AVOID_UP 9
#define SKILL_ABNORMAL_TYPE_AVOID_UP_SPECIAL 0xA
#define SKILL_ABNORMAL_TYPE_HIT_UP 0xB
#define SKILL_ABNORMAL_TYPE_HIT_DOWN 0xC
#define SKILL_ABNORMAL_TYPE_FATAL_POISON 0xD
#define SKILL_ABNORMAL_TYPE_FLY_AWAY 0xE
#define SKILL_ABNORMAL_TYPE_TURN_STONE 0xF
#define SKILL_ABNORMAL_TYPE_CASTING_TIME_DOWN 0x10
#define SKILL_ABNORMAL_TYPE_ATTACK_TIME_DOWN 0x11
#define SKILL_ABNORMAL_TYPE_SPEED_UP 0x12
#define SKILL_ABNORMAL_POSSESSION 0x13
#define SKILL_ABNORMAL_TYPE_ATTACK_TIME_UP 0x14
#define SKILL_ABNORMAL_TYPE_SPEED_DOWN 0x15
#define SKILL_ABNORMAL_TYPE_HP_REGEN_UP 0x16
#define SKILL_ABNORMAL_TYPE_MAX_MP_UP 0x17
#define SKILL_ABNORMAL_TYPE_ANTARAS_DEBUFF 0x18
#define SKILL_ABNORMAL_TYPE_CRITICAL_PROB_UP 0x19
#define SKILL_ABNORMAL_TYPE_CANCEL_PROB_DOWN 0x1A
#define SKILL_ABNORMAL_TYPE_BOW_RANGE_UP 0x1B
#define SKILL_ABNORMAL_TYPE_MAX_BREATH_UP 0x1C
#define SKILL_ABNORMAL_TYPE_DECREASE_WIEGHT_PENALTY 0x1D
#define SKILL_ABNORMAL_TYPE_POISON 0x1E
#define SKILL_ABNORMAL_TYPE_BLEEDING 0x1F
#define SKILL_ABNORMAL_TYPE_DOT_ATTR 0x20
#define SKILL_ABNORMAL_TYPE_DOT_MP 0x21
#define SKILL_ABNORMAL_TYPE_DMG_SHIELD 0x22
#define SKILL_ABNORMAL_TYPE_AB_HAWK_EYE 0x23
#define SKILL_ABNORMAL_TYPE_RESIST_SHOCK 0x24
#define SKILL_ABNORMAL_TYPE_PARALYZE 0x25
#define SKILL_ABNORMAL_TYPE_PUBLIC_SLOT 0x26
#define SKILL_ABNORMAL_TYPE_SILENCE 0x27
#define SKILL_ABNORMAL_TYPE_DERANGEMENT 0x28
#define SKILL_ABNORMAL_TYPE_STUN 0x29
#define SKILL_ABNORMAL_TYPE_RESIST_POISON 0x2A
#define SKILL_ABNORMAL_TYPE_RESIST_DERANGEMENT 0x2B
#define SKILL_ABNORMAL_TYPE_RESIST_SPIRITLESS 0x2C
#define SKILL_ABNORMAL_TYPE_MP_REGEN_UP 0x2D
#define SKILL_ABNORMAL_TYPE_MP_DOWN 0x2E
#define SKILL_ABNORMAL_TYPE_MOVING_SPELL 0x2F
#define SKILL_ABNORMAL_TYPE_MOVE_MODE 0x30
#define SKILL_ABNORMAL_TYPE_LIGHT 0x31
#define SKILL_ABNORMAL_TYPE_PUT_ON_HATELIST 0x32
#define SKILL_ABNORMAL_TYPE_WEAPON_DMG_UP 0x33
#define SKILL_ABNORMAL_TYPE_WEAPON_DURABILITY_DOWN 0x34
#define SKILL_ABNORMAL_TYPE_WEAPON_DMG_UP_DWARF 0x35
#define SKILL_ABNORMAL_TYPE_ARMOR_DURABILITY_DOWN 0x36
#define SKILL_ABNORMAL_TYPE_TURN_PASSIVE 0x37
#define SKILL_ABNORMAL_TYPE_TURN_FLEE 0x38
#define SKILL_ABNORMAL_TYPE_AGGRO_RANGE_DOWN 0x39
#define SKILL_ABNORMAL_TYPE_SIGHT_DOWN 0x3A
#define SKILL_ABNORMAL_TYPE_REMOVE_FROM_HATELIST 0x3B
#define SKILL_ABNORMAL_TYPE_HP_RECOVER 0x3C
#define SKILL_ABNORMAL_TYPE_MP_RECOVER 0x3D
#define SKILL_ABNORMAL_TYPE_MISS 0x3E
#define SKILL_ABNORMAL_TYPE_ROOT 0x3F
#define SKILL_ABNORMAL_TYPE_SPEED_UP_SPECIAL 0x40
#define SKILL_ABNORMAL_TYPE_MAJESTY 0x41
#define SKILL_ABNORMAL_TYPE_PD_UP_BOW 0x42
#define SKILL_ABNORMAL_TYPE_ATTACK_SPEED_UP_BOW 0x43
#define SKILL_ABNORMAL_TYPE_MAX_HP_UP 0x44
#define SKILL_ABNORMAL_TYPE_HOLY_ATTACK 0x45
#define SKILL_ABNORMAL_TYPE_SLEEP 0x46
#define SKILL_ABNORMAL_TYPE_BERSERKER 0x47
#define SKILL_ABNORMAL_TYPE_PINCH 0x48
#define SKILL_ABNORMAL_TYPE_LIFE_FORCE 0x49
#define SKILL_ABNORMAL_TYPE_SONG_OF_EARTH 0x4A
#define SKILL_ABNORMAL_TYPE_SONG_OF_LIFE 0x4B
#define SKILL_ABNORMAL_TYPE_SONG_OF_WATER 0x4C
#define SKILL_ABNORMAL_TYPE_SONG_OF_WARDING 0x4D
#define SKILL_ABNORMAL_TYPE_SONG_OF_WIND 0x4E
#define SKILL_ABNORMAL_TYPE_SONG_OF_HUNTER 0x4F
#define SKILL_ABNORMAL_TYPE_SONG_OF_INVOCATION 0x50
#define SKILL_ABNORMAL_TYPE_DANCE_OF_WARRIOR 0x51
#define SKILL_ABNORMAL_TYPE_DANCE_OF_INSPIRATION 0x52
#define SKILL_ABNORMAL_TYPE_DANCE_OF_MYSTIC 0x53
#define SKILL_ABNORMAL_TYPE_DANCE_OF_FIRE 0x54
#define SKILL_ABNORMAL_TYPE_DANCE_OF_FURY 0x55
#define SKILL_ABNORMAL_TYPE_DANCE_OF_CONCENTRATION 0x56
#define SKILL_ABNORMAL_TYPE_DANCE_OF_LIGHT 0x57
#define SKILL_ABNORMAL_TYPE_DETECT_WEAKNESS 0x58
#define SKILL_ABNORMAL_TYPE_THRILL_FIGHT 0x59
#define SKILL_ABNORMAL_TYPE_RESIST_BLEEDING 0x5A
#define SKILL_ABNORMAL_TYPE_CRITICAL_DMG_UP 0x5B
#define SKILL_ABNORMAL_TYPE_SHIELD_PROB_UP 0x5C
#define SKILL_ABNORMAL_TYPE_HP_REGEN_DOWN 0x5D
#define SKILL_ABNORMAL_TYPE_REUSE_DELAY_UP 0x5E
#define SKILL_ABNORMAL_TYPE_NONE 0x5F

#define SKILL_AVE_NONE 0
#define SKILL_AVE_DOT_BLEEDING 1
#define SKILL_AVE_DOT_POISON 2
#define SKILL_AVE_DOT_FIRE 4
#define SKILL_AVE_DOT_WATER 8
#define SKILL_AVE_DOT_WIND 0x10
#define SKILL_AVE_DOT_SOIL 0x20
#define SKILL_AVE_STUN 0x40
#define SKILL_AVE_SLEEP 0x80
#define SKILL_AVE_SILENCE 0x100
#define SKILL_AVE_ROOT 0x200
#define SKILL_AVE_PARALYZE 0x400
#define SKILL_AVE_FLESH_STONE 0x800
#define SKILL_AVE_DOT_MP 0x1000

//#define SKILL_NEXT_ACTION_ATTACK 0
//#define SKILL_NEXT_ACTION_STAND 1
//#define SKILL_NEXT_ACTION_SIT 2
//#define SKILL_NEXT_ACTION_FAKE_DEATH 2
//#define SKILL_NEXT_ACTION_ATTACK 4


#pragma pack(1)
class CSkillKey
{
	__int16 nID;
	__int16 nLevel;
};
#pragma pack()