#include "Globals.h"
#include "CCreature.h"
#include "ServerPackets.h"


//.text:00440620 ; int __stdcall CCreature__AddHP(double nHP)
//CCREATURE_ADDHP CCreature_AddHP = (CCREATURE_ADDHP)(0x00440620);

typedef  CCItem * (__thiscall *CCREATURE_GETEQUIPPEDWEAPON) (CCreature_* Creature);
CCREATURE_GETEQUIPPEDWEAPON CCreature_GetEquippedWeapon = (CCREATURE_GETEQUIPPEDWEAPON)(0x00442480);

typedef  bool (__thiscall *CCREATURE_USEITEM) (CCreature_* Creature, CCItem* pItem);
CCREATURE_USEITEM CCreature_UseItem = (CCREATURE_USEITEM)(0x00443630);

typedef bool (__cdecl *ISUSERWAITINGFORREPLY)(CCreature_* pUser);
ISUSERWAITINGFORREPLY _IsUserWaitingForReply = (ISUSERWAITINGFORREPLY)0x0050B430;

typedef bool (__thiscall *USER_ISINBLOCKLIST)(CCreature_ *pUser, WCHAR *szName);
USER_ISINBLOCKLIST User_IsInBlockList = (USER_ISINBLOCKLIST)0x004F41C0;

typedef CParty_* (__thiscall *USER_GETPARTY_)(CCreature_ *pUser);
USER_GETPARTY_ User_GetParty = (USER_GETPARTY_)0x004417E0;

typedef bool (__thiscall *CREATURE_ADDITEMTOINVENTORY)(CCreature_ *pCreature, int nItemClassID,int nCount,bool bIsPick);
CREATURE_ADDITEMTOINVENTORY Creature_AddItemToInventory = (CREATURE_ADDITEMTOINVENTORY)0x004440E0;

typedef void (__thiscall *CREATURE_DIE)(CCreature_ *pCreature);
CREATURE_DIE Creature_Die = (CREATURE_DIE)0x0044F840;

typedef double (__thiscall *OLD_CCREATURE_GOTDAMAGEBY)(CCreature_ *pCreature, CCreature_ *pAttacker, double dDamage, int nParam);
OLD_CCREATURE_GOTDAMAGEBY Old_CCreature_GotDamageBy = (OLD_CCREATURE_GOTDAMAGEBY)0x004501C0;
CCREATURE_GOTDAMAGEBY New_CCreature_GotDamageBy = &CCreature_::New_GotDamageBy;


typedef int (__thiscall *USER_GETMYSTATUS )(CCreature_ *pUser);
USER_GETMYSTATUS User_GetMyStatus = (USER_GETMYSTATUS)0x004EC4A0;

typedef void (__thiscall *CCREATURE_CHECKABNORMALVISUALEFFECT)(CCreature_ *pCreature);
CCREATURE_CHECKABNORMALVISUALEFFECT CCreature_CheckAbnormalVisualEffect = CCREATURE_CHECKABNORMALVISUALEFFECT(0x004486C0);

void CCreature_::CheckAbnormalVisualEffect()
{
	CCreature_CheckAbnormalVisualEffect(this);
}

int CCreature_::GetMyStatus()
{
	return User_GetMyStatus(this);
}

void __stdcall User_SendHPInfo()
{
	CCreature_ *pUser;
	__asm mov pUser,ecx

	CUserSocket *pUserSocket = pUser->pUserSocket;
	if (!pUserSocket) return;

	pUserSocket->Send("cdddddddddd",
		SP_STATUS_UPDATE,			//c
		pUser->nObjectID,			//d
		4,							//d
		STATUS_CUR_CP,				//d
		(int)pUser->GetCurrentCP(),	//d
		STATUS_MAX_CP,				//d
		(int)pUser->GetMaxCP(),		//d
		STATUS_CUR_HP,				//d
		(int)pUser->GetCurrentHP(),	//d
		STATUS_MAX_HP,				//d
		(int)pUser->GetMaxHP()		//d
		);

	CParty_ *pParty = pUser->GetParty();
	if (pParty!=NULL)
	{
		pParty->UpdateWindowPacket(pUser,1);
	}
}

void __stdcall User_SendMPInfo()
{
	CCreature_ *pUser;
	__asm mov pUser,ecx

	CUserSocket *pUserSocket = pUser->pUserSocket;
	if (!pUserSocket) return;

	pUserSocket->Send("cdddddd",
		SP_STATUS_UPDATE,				//c
		pUser->nObjectID,				//d
		2,								//d
		STATUS_CUR_MP,					//d
		(int)pUser->GetCurrentMP(),	//d
		STATUS_MAX_MP,					//d
		(int)pUser->GetMaxMP()		//d
		);

	CParty_ *pParty = pUser->GetParty();
	if (pParty!=NULL)
	{
		pParty->UpdateWindowPacket(pUser,2);
	}
}


double CCreature_::New_GotDamageBy(CCreature_ *pAttacker, double dDamage, int nParam)
{
	//CLog_AddW_hd(CLOG,0,L"User::GotDamageBy %s %s %f %i",Data->szName, pAttacker->Data->szName, dDamage, nParam);
	return Old_CCreature_GotDamageBy(this,pAttacker,dDamage,nParam);
}

void CCreature_::DieAsCreature()
{
	//CLog_AddW_hd(CLOG,0,L"CCreature::DieAsCreature DEBUG");
	Creature_Die(this);
}

bool CCreature_::AddItemToInventory(int nItemClassID,int nCount,bool bIsPick)
{
	return Creature_AddItemToInventory(this, nItemClassID, nCount, bIsPick);
}

CParty_ *CCreature_::GetParty()
{
	return User_GetParty(this);
}

double CCreature_::GetCurrentCP()
{
	//return Data->fCurrentCP;
	return 0;
}

double CCreature_::GetMaxCP()
{
	return GetMaxHP()*0.5;
}

bool CCreature_::UseItemAsCreature(CCItem *pItem)
{
	return CCreature_UseItem(this,pItem);
}

CCItem* CCreature_::GetEquippedWeapon()
{
	CCItem *Item = CCreature_GetEquippedWeapon(this);
	return Item;
}

CItemInfo* CCreature_::GetEquippedWeaponInfo()
{
	CCItem* Item = GetEquippedWeapon();
	if (Item==NULL) return NULL;
	return Item->GetInfo();
}

CCItem* CCreature_::FindFirstItemByClassID(int nItemID)
{
	if (nItemID==0) return NULL;
	return Inventory.FindFirstItemByClassID(nItemID);
}

CCItem* CCreature_::FindNextItemByClassID(CCItem* pPrevItem)
{
	if (pPrevItem==NULL) return NULL;
	if (pPrevItem->pData==NULL) return NULL;
	return Inventory.FindNextItemByClassID(pPrevItem->pData->nInventoryIndex);
}

int CCreature_::GetAdenaAmount()
{
	return Inventory.GetAdenaAmount();
}

#define ASS_ON 1
#define ASS_OFF 0

void CCreature_::RechargeAutoSS()
{
	/*
	CCItem *pShot;
	CItemInfo *pWeaponInfo;

	if (pUserSocket == NULL) return;
	if (Data->nIsPC == 0) return;

	//recharge SS
	if (bSoulShotOn == false && Data->nAutoSS != 0)
	{
		pWeaponInfo = GetEquippedWeaponInfo();
		pShot = FindFirstItemByClassID(Data->nAutoSS);

		if (pWeaponInfo==NULL || pShot==NULL)
		{
			SP_SM_TEXT(pUserSocket,SM_CANT_USE_SS);
			SP_AUTOSS(pUserSocket,Data->nAutoSS,ASS_OFF);
			Data->nAutoSS = 0;
		}
		else if (pWeaponInfo->nGrade != pShot->pInfo->nGrade)
		{
			SP_SM_TEXT(pUserSocket,SM_SS_NOT_MATCH_WEAPON);
			SP_SM_TEXT_ITEM(pUserSocket,SM_USE_S1_CANCELED,Data->nAutoSS);
			SP_AUTOSS(pUserSocket,Data->nAutoSS,ASS_OFF);
			Data->nAutoSS = 0;
		}
		else if (pWeaponInfo->nConsumeSS > pShot->pData->nCount)
		{
			SP_SM_TEXT(pUserSocket,SM_NOT_ENOUGH_SS);
			SP_AUTOSS(pUserSocket,Data->nAutoSS,ASS_OFF);
			Data->nAutoSS = 0;
		}
		else 
		{
			UseItemAsCreature(pShot);
		}
	}
	//recharge SpS
	if (bSpiritShotOn == false && Data->nAutoSpS != 0)
	{
		pWeaponInfo = GetEquippedWeaponInfo();
		pShot = FindFirstItemByClassID(Data->nAutoSpS);

		if (pWeaponInfo==NULL || pShot==NULL)
		{
			SP_SM_TEXT(pUserSocket,SM_CANT_USE_SPS);
			SP_AUTOSS(pUserSocket,Data->nAutoSpS,ASS_OFF);
			Data->nAutoSpS = 0;
		}
		else if (pWeaponInfo->nGrade != pShot->pInfo->nGrade)
		{
			SP_SM_TEXT(pUserSocket,SM_SS_NOT_MATCH_WEAPON);
			SP_SM_TEXT_ITEM(pUserSocket,SM_USE_S1_CANCELED,Data->nAutoSpS);
			SP_AUTOSS(pUserSocket,Data->nAutoSpS,ASS_OFF);
			Data->nAutoSpS = 0;
		}
		else if (pWeaponInfo->nConsumeSS > pShot->pData->nCount)
		{
			SP_SM_TEXT(pUserSocket,SM_NOT_ENOUGH_SPS);
			SP_AUTOSS(pUserSocket,Data->nAutoSpS,ASS_OFF);
			Data->nAutoSpS = 0;
		}
		else
		{
			UseItemAsCreature(pShot);
		}
	}

*/

}

bool CCreature_::IsAwaitingForReply()
{
	if (Data->nIsPC==0) return false;
	return _IsUserWaitingForReply(this);
}

bool CCreature_::IsInBlockList(WCHAR *szName)
{
	if (Data->nIsPC==0) return false;
	return User_IsInBlockList(this, szName);
}



//#include "UserSocket.h"

typedef  VOID (__thiscall *CSOCKET_SENDSYSTEMMESSAGE) (CUserSocket* Socket, WCHAR *From, WCHAR *Text);
CSOCKET_SENDSYSTEMMESSAGE CSocket_SendSystemMessage = (CSOCKET_SENDSYSTEMMESSAGE)(0x005064B0);

typedef  VOID (__thiscall *CSOCKET_SENDV) (CUserSocket* Socket, const char *format,va_list va);
CSOCKET_SENDV CSocket_SendV = (CSOCKET_SENDV)(0x004DFB70);



void CUserSocket::SendSystemMessage(WCHAR *From, WCHAR *Text)
{
	CSocket_SendSystemMessage(this, From, Text);
}


void CUserSocket::Send(const char* format, ...)
{
	va_list argptr;
	va_start(argptr, format);
	CSocket_SendV(this, format,argptr);
}