//#pragma once

//#pragma pack(push)
//#pragma pack(1)
//General includes
#ifndef _WINDOWS_
	#include <windows.h>
#endif


enum ConsumeType
	{
		consume_type_normal = 0,
		consume_type_charge = 1,
		consume_type_stackable = 2,
		consume_type_asset = 3
	};
	enum SlotType //2^value = value in CSharedItemData
	{
		SlotType_None = -1,
		Underware = 0,
		REar = 1,
		LEar = 2,
		Neck = 3,
		RFinger = 4,
		LFinger = 5,
		Head = 6,
		RHand = 7,
		LHand = 8,
		Gloves = 9,
		Chest = 10,
		Legs = 11,
		Feet = 12,
		Back = 13,
		LRHand = 14,
		OnePiece = 15,
		Hair = 16,
		Dress = 17,
		//new slots
		HairDeco = 18,
		HairAll = 19
	};

//----------------------
//buff by corrund
//---------------------

typedef struct tagTBuffData //CSkillInfo
{
   WCHAR Buff_name;
    int Buff_id;
    int Buff_level;
    int magic_level;
	int is_magic;
	int has_i_energy_attack;
	int SkillOpType; //A1=0, A2 = 1   SKILL_fOPCODE(OP_TYPE_A3 = 2,   SKILL_fOPCODE(OP_TYPE_A4 = 3, SKILL_fOPCODE(OP_TYPE_P = 4,   SKILL_fOPCODE(OP_TYPE_T = 5, SKILL_fOPCODE(OP_TYPE_PP = 6
	int mp_consume1;
	int mp_consume2;
	int hp_consume;
	int item_consume; //??
	int item_consume_count; //??
	int u[70]; //item consume list?
	int Buff_duration; //139? s_might level 2
	int u1; //0
	int u2; //0
	int cast_range;
	int effective_range;
	int u3; //0
	int u4; //0
	int u5; //0
	int u6; //0
	int u7; //0
	int u8; //0
	double skill_hit_time;
	double skill_cool_time;
	double skill_hit_cancel_time;
	int opCondition1; //0
	int opCondition2; //0
	int opCondition3; //0
	int opCondition4; //0
	double lv_bonus_rate; //0
	int activate_rate; // -1
	int basic_property; //25 - none
	int abnormal_time;
	int abnormal_lv;
	int abnormal_type; //0
	int abnormal_visual_effect; //0
	int attribute;
	int effect_point;
	int next_action; //0



} TBuffData, *PTBuffData;



typedef struct tagTBuff
{
   PTBuffData BuffData;
    int u1;
    int u2;
    int u3;

} TBuff, *PTBuff;



typedef struct tagTUserData
{
   int data[656];	//0...655

   


   //998 - firstSkill
   //99C - lastSkill

//0A88 first skill
//0A8C last skill

   //9C0 - first item skill
   //9C4 - last item skill
   
   //A04 - critical section1
 

   PTBuff FirstBuff; //656  //A3C
   PTBuff LastBuff; //660   //A40
   int d1; //A44 
   int d2; //A48 
   int d3; //A4C 
   int d4; //A50 
   int d5; //A54 
   int d6; //A58 
   int critSection2; //A5C 
   int d8; //A60 
   int d9; //A64 
   int d10; //A68 
   int d11; //A6C 
   int d12; //A70 
   int d13; //A74 
   PTBuff FirstToggleBuff_b; //A78
   PTBuff LastToggleBuff_b; //A7C
   int data2[5]; //A80  
   PTBuff FirstToggleBuff_a; //A94
   PTBuff LastToggleBuff_a; //A98





} TUserData, *PTUserData;



typedef struct tagTPartyRecord
{
	tagTPartyRecord *px1; //18
	tagTPartyRecord *px2; //18
	tagTPartyRecord *px3; //18
	int SOID; //4
	BYTE flag1; //1
	BYTE flag2; //1
	//60

} TPartyRecord, *PTPartyRecord;


typedef struct tagTPartyStack
{
	PTPartyRecord ps1;
	PTPartyRecord ps2;
	PTPartyRecord ps3; 
	

} TPartyStack, *PTPartyStack;

typedef struct tagPARTYMEMBER
{
	int	member_id;
	int	member_index;
} TPARTYMEMBER, *PPARTYMEMBER;


typedef struct tagTPartyDataX
{
	int data[15];	//0...14
	PTPartyStack Stack;
	int members_count;


} TPartyDataX, *PTPartyDataX;





//-----------------------------------------
//skills

const int _i_ds=1;
const int _i_ddd=2;
const int _i_pump=3;

const int _v_diff=1;
const int _v_per=0;


typedef struct  tagTSkillHex
{
    int _template_id; // integer;
    int _hash; // integer;
    PWCHAR _basetoken; // PWideChar;
    int _baseclass; // integer;
} TSkillHex, *PTSkillHex;



typedef struct  tagTSkillData
{
    PWCHAR name; // PWideChar;
    int id; // integer;
    int flag1; // integer;
    int flag2; // integer;
    int flag3; // integer;
} TSkillData, *PTSkillData;


typedef int (__thiscall *TFuncCalcSuccess) (void *p1, void *p2, void *p3, void *p4);
typedef int (__thiscall *TFuncInstant1) (PTUserData User, PTUserData User2, PTSkillData Skill, void *p4);
typedef int (__thiscall *TFuncInstant2) (PTUserData User, PTUserData User2, PTSkillData Skill, void *p4);
typedef int (__thiscall *TFuncTick) (PTUserData User, PTUserData User2, PTSkillData Skill, void *p4);
typedef int (__thiscall *TFuncCheckPumpCondition) (PTUserData User);
typedef int (__thiscall *TFuncPump) (PTUserData User, PTUserData User2);
typedef int (__thiscall *TFuncConsume) (PTUserData User, PTUserData User2, PTSkillData Skill);
typedef int (__thiscall *TFuncCheckResisted) (PTUserData User);


typedef struct tagTSkillClass
{
TFuncCalcSuccess    _vm_calcsuccess; // TFuncCalcSuccess;
TFuncInstant1    _vm_instant1; // TFuncInstant1;
TFuncInstant2    _vm_instant2; // TFuncInstant2;
TFuncTick    _vm_tick; // TFuncTick;
TFuncCheckPumpCondition    _vm_checkpumpcondition; // TFuncCheckPumpCondition;
TFuncPump    _vm_pump; // TFuncPump;
TFuncConsume    _vm_consume; // TFuncConsume;
TFuncCheckResisted    _vm_checkresisted; // TFuncCheckResisted;
 } TSkillClass, *PTSkillClass;



  
typedef struct tagTRegSkill
{
    int _template_id; // integer;
    PWCHAR _token; // PWideChar;
    PTSkillClass _skillclass; // PSkillClass;
} TRegSkill, *PTRegSkill;


typedef struct tagTEffectClass
{
         int *ref; //: Pointer;
         int flag1; //: integer;
         int flag2; //: integer;
         int flag3; //: integer;
         double value; //: Double;
         int pr_df; //: integer;
} TEffectClass, *PTEffectClass;


void InitSkillClass(PTSkillClass SClass);
void InitSkillHex();
void RegisterNewSkill(int _template, PWCHAR token, PTSkillClass SkillClass);
void _parser_hook();
void _class_hook();
void _class_hook_p();
void _skill_in();
void _skill_out();



//=======================================
// ITEMs
//========================================



enum ETCItemType
{
	etcitem_none=0,
	etcitem_scroll=1,
	etcitem_arrow=2,
	etcitem_potion=3,
	etcitem_recipe=5,
	etcitem_material=6,
	etcitem_pet_collar=7,
	etcitem_castle_guard=8
	/*
	,
	etcitem_dye=9,
	etcitem_seed=10,
	etcitem_seed2=11,
	etcitem_harvest=12,
	etcitem_lotto=13,
	etcitem_ticket_of_lord=15,
	etcitem_lure=16,
	etcitem_crop=17,
	etcitem_maturecrop=18,
	etcitem_scrl_enchant_wp=19,
	etcitem_scrl_enchant_am=20,
	etcitem_bless_scrl_enchant_wp=21,
	etcitem_bless_scrl_enchant_am=22
	*/
};

enum ItemDefaultAction
{
	action_none=0,
	action_skill_reduce=1,
	action_equip=2,
	action_soulshot=3,
	action_spiritshot=4,
	action_skill_maintain=5,
	action_map_open=6
	/*
	,
	action_dice=7,
	action_recipe=8,
	action_capsule=9,
	action_calc=10,
	action_seed=11,
	action_harvest=12,
	action_xmas_open=13,
	action_show_html=14,
	action_show_ssq_status=15,
	action_summon_soulshot=16,
	action_summon_spiritshot=17,
	action_fishingshot=18
	*/
};




//item INFO  max 
typedef struct tagItemDat
{
	int _unk0000[2];
//	int default_action;//08h
//	int etcitem_type;//ch
	ItemDefaultAction default_action;//08 2 for weapon/armor
	ETCItemType etcitem_type;//0x0c

	int weight;//10h ??
	int price;//14h ??

	short itemSkillId;//18h
	short itemSkillLevel;//1ah
	short critical_attack_skill_id; //1ch
	short critical_attack_skill_lvl; //1eh
	int armor_type; //20h
	int material_type; //24h
	int soulshot_count; //28h 
	int spiritshot_count; //2Ch 

	int     crystalType; //30h OK
	int     crystalCount; //34h ??

/*
     bool immediate_effect;
	              int     dw68;
	             int     dw6C;
	              int     dw70;
	              bool    is_trade; 
	                        bool    is_drop;
	                        bool    is_destruct;
	                        bool    b77;
	              bool magic_weapon;
   int physical_damage;
*/

	__int8 immediate_effect; //38h  OK
	__int8 e2; //39h ??
   	__int8 e3; //3Ah ??
   	__int8 e4; 
   	__int8 item_type; //1 weapon, tested, confirmed???
   	__int8 e6; 
   	__int8 e7; 
   	__int8 e8; 

   	__int8 e9; //40h ?? 
	__int8 e10;
	__int8 e11;
	__int8 e12; //43h ??
	__int8 e13; //44h ??
	__int8 e14; //45h ??
	__int8 e15;
	__int8 e16; //47h ??
	int u48; //48h ??


	int physical_damage; //4Ch
	int random_damage; //50h
	int weapon_type;  //attack_type 54h   OK      .text:004F4BED                 cmp     dword ptr [eax+54h], 6 //6=bow?
	int u58; //CSharedDat 488
	int critical; //5Ch
	int attack_range; //60h
	int damage_range[4]; // damage_range={0;1;2;3}
	//64
	//68
	//6C magicaldamage range
	//70

	int attackspeed; //74h 
	int reuse_delay; //78h
	int mp_consume; //7Ch
	int magicdamage; //80h
	int u84;
	int physical_defense; //88h
	int magical_defense; //8Ch
	unsigned char dual_fhit_rate; //90h
	short mp_bonus; //92h
	int u94; //94h
	double d_hit_modify; //98h used in CCreature::WeaponHitCorrection
	double d_avoid_modify; //A0h used in CCreature::AvoidCorrection (Shield penalty?)
	double uA8; //puser 3A0,3A4
	double uB0; //B0 puser 398 //B4 puser 39C
	int petItem; //B8h  OK       .text:004F45C6                 mov     ecx, [eax+0B8h]


} TItemDat, *PItemDat;




typedef struct tagTItemData
{

	/*0*/ int		w_field_0;                         // 0 Int
	/*4*/ int       w_field_4;                     //4    Int
	/*8*/ double	m_PosX;       //8                 Double
	/*16*/ double	m_PosY;      //10                  Double
	/*24*/ double	m_PosZ;       //18                 Double
	/*32*/ int	w_field_32;     //20 Int in c4: /* 0B0h : 0408D10h */    virtual void func_0B0() {}; 
	/*36*/ int	sid;			//24 Int nObjectID; // item_id; sid in ItemList packet                       
	/*40*/ int	itemIndex;                       //28 Int
	/*44*/ int	SOID;                       //2C Int server object ID = container index
	/*48*/ int	IDX;                 //30     Int
	/*52*/ int	m_nAccuracyMultiplier;		//34	Int		//kvoxi Accuracy multiplier
	/*56*/ int	w_field_56; //m_nAccuracyMultiplier;	//38	Int
	/*60*/ int	w_field_60;                       //3C Int
	/*64*/ int	w_field_64;                       //40 Int
	/*68*/ int	w_field_68;                       //44 Int
	/*72*/ int	w_field_72;                       //48 Int
	/*76*/ int	w_field_76;                       //4C Int
	/*80*/ int	w_field_80;                       //50 Int
	/*84*/ int	w_field_84;                       //54 Int  //???
	/*88*/ int	isOnGround;                       //58 Int ISLOOT used in CWorld::PickItem, Amped CItem::TimerExpired hook
	/*92*/ int	PrevIDX;                       //5C Int isOnGround???
	/*96*/ int	NextIDX;                       //60 Int   //kvoxi: nextIDX, corund - prevIDX
	/*100*/ int	w_field_100;		//64	Int
	/*104*/ int	w_field_104;      //68    Int
	/*108*/ int	itemState;      //6C    Int //values: 0(on char) 1, 2
	/*112*/ int	m_nCount;       //70    Int
	/*116*/ int	itemDBID;      //74    Int //???
	/*120*/ int	m_nClassId;     //78    Int
	/*124*/ int	m_nItemType;	//7c    Int //type2 // itemType2  0-weapon  1-shield/armor  2-ring/earring/necklace  3-questitem  4-adena  5-item
	/*128*/ int	m_nSlotBitType; //80	Int
	/*132*/ int	blessed;      //84    Int //custom type???
	/*136*/ int	m_nConsumeType;	//88	Int (0, 1)normal, (2, 3) stackable, ConsumeAsset
	/*140*/ int	damaged;      //8c    Int
	/*144*/ int	m_nEnchantLevel; //90   Int
	/*148*/ int	timerIndex;       //94   Int ???  





} TItemData, *PItemData;
//#pragma pack(pop)


typedef struct tagTItem
{

	int _unk0001; 
	int _unk0002; //4
	int _unk0003; //8
	int _unk0004; //c
	int _unk0005; //10
	int _unk0006; //14
 	int objectID;//18h
	int itemDBID;//1ch //item class id?
	int index;//20h
	int _unk002C;
	PItemData sharedData;	//28h
	PItemDat Data;		//2ch
	int _unk0040[4]; //30, 34, 38, 3c  


	int fuction_isQuestItem; //98h    .text:00507983                 call    dword ptr [edx+98h]
	int fuction_isHz; //9Ch  .text:004EE4C1                 call    dword ptr [edx+9Ch]
	int function_isDropable; //A0h	.text:005079CB                 call    dword ptr [edx+0A0h]


} TItem, *PItem;
