#include "CorrundCommon.h"

static BYTE iutItemUpdate     = 2;
static BYTE  iutItemDelete     = 3;
const WCHAR *  modulename = L"Elhaym-dll";


void InventoryLock(DWORD * pUser)
{
__asm
{
  Push 0
  Push modulename
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 004132F0h
  CALL EAX
}

}

void InventoryUnLock(DWORD * pUser)
{
__asm
{
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 0041C4A0h
  CALL EAX
}

}

int GetItemSlotIdx(PItem Item)
{
	int SlotIdx = 0;
__asm
{
  MOV EAX,Item
  MOV EAX,DWORD PTR DS:[EAX+28h]
  MOV EAX,DWORD PTR DS:[EAX+2Ch]
  MOV SlotIdx, EAX
}
return SlotIdx;
}

void ItemDelete(PItem Item)
{
__asm
{
  MOV ECX, Item
  MOV EAX, 0048B480h
  CALL EAX
}
}

PItem InventoryFirstItemByClassId(DWORD * pUser, int ClassID)
{
	PItem Item = NULL;
__asm
{
  PUSH ClassID
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 00485B20h
  CALL EAX
  MOV Item, EAX
}
return Item;
}

PItem InventoryNextItemByClassId(DWORD * pUser, int prevIndex)
{
	PItem Item = NULL;
__asm
{
  PUSH prevIndex
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 00485E00h
  CALL EAX
  MOV Item, EAX
}
return Item;
}


void SetInventoryChanged(DWORD * pUser, PItem Item, int ChangedType)
{
__asm
{
  PUSH ChangedType
  PUSH Item
  LEA ECX, [pUser+0F60h]
  MOV EAX, 004883A0h
  CALL EAX
}
}

int InventoryPop(DWORD * pUser, int index)
{
	int ipop = 0;
__asm
{
  PUSH 0
  PUSH index
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 00484C90h
  CALL EAX
  MOV ipop, EAX
}
return ipop;
}

int InventoryPush(DWORD * pUser, int index)
{
	int ipush = 0;
__asm
{
  PUSH 0
  PUSH index
  LEA ECX, [pUser+0F60h]  //inventory offset
  MOV EAX, 00443F0Ch
  CALL EAX
  MOV ipush, EAX
}
return ipush;
}



void AddItemToInventory(DWORD * pUser, int ItemClass, int Count, int IsPick)
{
	__asm
	{
  PUSH IsPick
  Push Count
  PUSH ItemClass
  MOV ECX, pUser
  MOV EAX, 004440E0h
  CALL EAX
	}
}

void DeleteItemInInventory(DWORD * pUser, int ItemClass, int Count)
{
__asm
{
	 Push Count
  PUSH ItemClass
  MOV ECX, pUser
  MOV EAX, 004444F0h
  CALL EAX
}
}


void SendItemList(DWORD * pUser)
{
__asm
{
  PUSH 0
  PUSH 1
  PUSH 1
  MOV ECX, pUser
  MOV EAX, 004F1830h
  CALL EAX
}
}

//int GetAdenaAmount(DWORD * pUser)
//{
//	return GetItemClassCount(pUser, 57);
//} 


PItemData GetActiveItem(DWORD * pUser)
{
	PItemData result = NULL;
  DWORD * ptr = (DWORD *)(pUser + 0x1B94); //active item pointer offset
  if (ptr == NULL)
	  return result;
  
  PItemData itm = (PItemData)(ptr + 0x28);
  return itm;
}


/////////////////////////////////////////////////////////////////
// NEW BY SMELI
////////////////////////////////////////////////////////////////


int InventoryAdenaAmmount(DWORD * pUser)
{
	int adena = 0;
__asm
{
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 00484f60h
  CALL EAX
  MOV adena, EAX
}
return adena;
}


int InventoryTotalCount(DWORD * pUser)
{
	int adena = 0;
__asm
{
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 00486120h
  CALL EAX
  MOV adena, EAX
}
return adena;
}


PItem InventoryGetItemBySOID(DWORD * pUser, int SOID) 
//get item by server object ID
{
	PItem Item = NULL;
__asm
{
  PUSH SOID
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 00485550h
  CALL EAX
  MOV Item, EAX
}
return Item;
}


PItem InventoryGetItemByIDX(DWORD * pUser, int IDX)
{
	PItem Item = NULL;
__asm
{
  PUSH IDX
  LEA ECX, [pUser+0F60h] //inventory offset
  MOV EAX, 00485830h
  CALL EAX
  MOV Item, EAX
}
return Item;
}


PItemData GetItemData(PItem itm)
{
	PItemData result = NULL;
  if (itm == NULL)
	  return result;
  
  PItemData itmdata = (PItemData)(itm + 0x28);
  return itmdata;
}


PItemData GetItemDataC(int Index)
{
	int * pItemz = NULL;
	* pItemz = 0x01689FB8C; //index start of items
  if (Index == -1)
	  return NULL;
  PItemData result = PItemData (pItemz + (Index * 0x98));
  return result;
}