/*



client packets 

//C1 opcodes


Client -> Server 
0x00 RequestAuthLogin 
0x02 RequestServerLogin 
0x05 RequestServerList 
0x00 SendProtocolVersion 
0x01 MoveBackwardToLocation 
0x02 Say 
0x03 EnterWorld 
0x04 Action 
0x08 RequestAuthLogin
0x09 Logout 
0x0a Attack 
0x0b CharacterCreate
0x0c CharacterDelete
0x0d CharacterSelect
0x0e NewCharacter 
0x0f ItemList 
0x10 RequestEquipItem 
0x11 RequestUnEquipItem 
0x12 RequestDropItem 
0x13 RequestDropItemFromPet 
0x14 UseItem 
0x15 TradeRequest 
0x16 AddTradeItem 
0x17 TradeDone 
0x1a RequestTeleport 
0x1b SocialAction 
0x1c ChangeMoveType // not used any more RequestActionUse instead 
0x1d ChangeWaitType // not used any more RequestActionUse instead 
0x1e RequestSellItem 
0x1f RequestBuyItem 
0x20 RequestLinkHtml 
0x21 RequestBypassToServer 
0x22 RequestBBSwrite 
0x23 RequestCreatePledge 
0x24 RequestJoinPledge 
0x25 RequestAnswerJoinPledge 
0x26 RequestWithDrawalPledge 
0x27 RequestOustPledgeMember 
0x28 RequestDismissPledge 
0x29 RequestJoinParty 
0x2a RequestAnswerJoinParty 
0x2b RequestWithDrawalParty 
0x2c RequestOustPartyMember 
0x2d RequestDismissParty 
0x2e RequestMagicSkillList 
0x2f RequestMagicSkillUse 
0x30 Appearing 
0x31 SendWareHouseDepositList 
0x32 SendWareHouseWithDrawList 
0x33 RequestShortCutReg 
0x34 RequestShortCutUse 
0x35 RequestShortCutDel 
0x37 RequestTargetCancel 
0x38 Say2 
0x3c RequestPledgeMemberList 
0x3e RequestMagicList 
0x3f RequestSkillList 
0x41 MoveWithDelta 
0x42 GetOnVehicle 
0x43 GetOffVehicle 
0x44 AnswerTradeRequest 
0x45 RequestActionUse 
0x46 RequestRestart 
0x47 RequestSiegeInfo 
0x48 ValidatePosition 
0x49 RequestSEKCustom 
0x4a StartRotating 
0x4b FinishRotating 
0x4d RequestStartPledgeWar 
0x4e RequestReplyStartPledgeWar 
0x4f RequestStopPledgeWar 
0x50 RequestReplyStopPledgeWar 
0x51 RequestSurrenderPledgeWar 
0x52 RequestReplySurrenderPledgeWar 
0x53 RequestSetPledgeCrest 
0x55 RequestGiveNickName 
0x57 RequestShowboard 
0x58 RequestEnchantItem 
0x59 RequestDestroyItem 
0x5b SendBypassBuildCmd 
0x5e RequestFriendInvite 
0x5f RequestFriendAddReply 
0x60 RequestFriendList 
0x61 RequestFriendDel 
0x62 CharacterRestore 
0x63 RequestQuestList 
0x64 RequestDestroyQuest 
0x66 RequestPledgeInfo 
0x67 RequestPledgeExtendedInfo 
0x68 RequestPledgeCrest 
0x69 RequestSurrenderPersonally 
0x6a Ride 
0x6b RequestAcquireSkillInfo 
0x6c RequestAcquireSkill 
0x6d RequestRestartPoint 
0x6e RequestGMCommand 
0x6f RequestPartyMatchConfig 
0x70 RequestPartyMatchList 
0x71 RequestPartyMatchDetail 
0x72 RequestCrystallizeItem 
0x73 RequestPrivateStoreManage 
0x74 SetPrivateStoreList 
0x75 RequestPrivateStoreManageCancel 
0x76 RequestPrivateStoreQuit 
0x77 SetPrivateStoreMsg 
0x78 RequestPrivateStoreList 
0x79 SendPrivateStoreBuyList 
0x7a ReviveReply 
0x7b RequestTutorialLinkHtml 
0x7c RequestTutorialPassCmdToServer 
0x7d RequestTutorialQuestionMark 
0x7e RequestTutorialClientEvent 
0x7f RequestPetition 
0x80 RequestPetitionCancel 
0x81 RequestGMList 
0x82 RequestJoinAlly 
0x83 RequestAnswerJoinAlly 
0x84 RequestWithdrawAlly 
0x85 RequestOustAlly 
0x86 RequestDismissAlly 
0x87 RequestSetAllyCrest 
0x88 RequestAllyCrest 
0x89 RequestChangePetName 
0x8a RequestPetUseItem 
0x8b RequestGiveItemToPet 
0x8c RequestGetItemFromPet 
0x8e RequestAllyInfo 
0x8f RequestPetGetItem 
0x90 RequestPrivateStoreBuyManage 
0x91 SetPrivateStoreList 
0x92 RequestPrivateStoreBuyManageCancel 
0x93 RequestPrivateStoreBuyQuit 
0x94 SetPrivateStoreBuyMsg 
0x95 RequestPrivateStoreBuyList 
0x96 SendPrivateStoreBuyBuyList 
0x97 SendTimeCheckPacket 
0x98 RequestStartAllianceWar 
0x99 ReplyStartAllianceWar 
0x9a RequestStopAllianceWar 
0x9b ReplyStopAllianceWar 
0x9c RequestSurrenderAllianceWar 
0x9d RequestSkillCoolTime 
0x9e RequestPackageSendableItemList 
0x9f RequestPackageSend 
0xa0 RequestBlock 
0xa1 RequestCastleSiegeInfo 
0xa2 RequestCastleSiegeAttackerList 
0xa3 RequestCastleSiegeInfo 
0xa4 RequestJoinCastleSiege 
0xa5 RequestConfirmCastleSiegeWaitingList 
0xa6 RequestSetCastleSiegeTime 
0xa7 RequestMultiSellChoose 
0xa8 NetPing 
 


Client -> Server(C3)

0xa9 RequestRemainTime
0xaa BypassUserCmd
0xab Snoop_quit
0xac RequestRecipeBookOpen
0xad RequestRecipeItemDelete
0xae RequestRecipeItemMakeInfo
0xaf RequestRecipeItemMakeSelf

0xb0 RequestRecipeShopManageList
0xb1 RequestRecipeShopMessageSet
0xb2 RequestRecipeShopListSet
0xb3 RequestRecipeShopManageQuit
0xb4 RequestRecipeShopManageCancel
0xb5 RequestRecipeShopMakeInfo
0xb6 RequestRecipeShopMakeDo
0xb7 RequestRecipeShopSellList
0xb8 RequestObserverEndPacket
0xb9 VoteSociality
0xba RequestHennaItemList
0xbb RequestHennaItemInfo
0xbc RequestHennaEquip
0xbd RequestHennaUnequipList
0xbe RequestHennaUnequipInfo
0xbf RequestHennaUnequip

0xc0 RequestPledgePower
0xc1 RequestMakeMacro
0xc2 RequestDeleteMacro
0xc3 RequestProcureCrop
0xc4 RequestBuySeed
0xc5 ConfirmDlg
0xc6 RequestPreviewItem
0xc7 RequestSSQStatus
0xc8 PetitionVote
0xca ReplyGameGuardQuery
0xcc RequestSendL2FriendSay
0xcd RequestOpenMinimap
0xce RequestSendMsnChatLog
0xcf RequestHandOverPartyMaster

[C4]
0xcf RequestReload
0xd0
01   RequestOustFromPartyRoom
02   RequestDismissPartyRoom
03   RequestWithdrawPartyRoom
04   RequestHandOverPartyMaster
05   RequestAutoSoulShot
06   RequestExEnchantSkillInfo
07   RequestExEnchantSkill
08   RequestManorList
09   RequestProcureCropList
0A   RequestSetSeed
0B   RequestSetCrop
0C   RequestWriteHeroWords
0D   RequestExAskJoinMPCC
0E   RequestExAcceptJoinMPCC
0F   RequestExOustFromMPCC
10   RequestExPledgeCrestLarge
11   RequestExSetPledgeCrestLarge
12   RequestOlympiadObserverEnd
13   RequestOlympiadMatchList 
 





kamael


0x00 Logout      
0x01 Attack cddddc     
0x03 RequestStartPledgeWar cS     
0x05 RequestStopPledgeWar cS     
0x05 RequestServerListPacket cddc     
0x07 ResponseAuthGameGuard cddddd     
0x09 RequestSetPledgeCrest cd cdb    
0x0a RequestRefreshPrivateMarketInfo show_market_all 30    
0x0b RequestGiveNickName cSS     
0x0b:0x80 RequestLogin cxddddddhcb     
0x0c NewCharacter cSdddddddddddd     
0x0d CharacterDeletePacket cd     
0x0f MoveBackwardToLocation cdddddd     
0x11 EnterWorldPacket cbddddbdcccccccccccccccccccc     
0x12 CharacterSelect cdhddd     
0x13 NewCharacterPacket      
0x16 Request cd     
0x17 RequestDraopItemPacket cdQddd     
0x17 RequestDraopItemPacket cdQddd     
0x19 UseItemPacket cdd     
0x1a TradeRequestPacket cd     
0x1b AddTradeItemPacket cddQ     
0x1c TradeDonePacket cd     
0x1f Action cdddd     
0x1f Action cddddc     
0x22 RequestLinkHtml cS     
0x23 RequestBypassToServer cS     
0x24 RequestBBSWrite cSSSSSS     
0x26 RequestJoinPledge cdd     
0x27 RequestAnswerJoinPledge cd     
0x28 RequestWithDrawalPledge      
0x29 RequestOustPledgeMember cS     
0x2b C_LOGIN cSdddddQd     
0x2e RequestAllyInfo      
0x2f RequestCrystallizeItem cdQ     
0x31 SetPrivateStoreList dQQ cddb    
0x34 SocialAction cd     
0x35 ChangeMoveType cd     
0x36 ChangeWaitType cd     
0x37 RequestSellItem ddQ cddb    
0x38 RequestMagicSkillList ddd     
0x39 RequestMagicSkillUse cddc     
0x3a SendApperingPacket      
0x3b SendWareHouseDepositList dQ cdb    
0x3c SendWareHouseWithDrawList dQ cdb    
0x3d RequestShortCutReg cddddddd     
0x3f RequestShortCutDel cd     
0x40 RequestBuyItem dQ cddb    
0x42 RequestJoinParty cSd     
0x43 RequestAnswerJoinParty cd     
0x44 RequestWithDrawalParty      
0x45 RequestOustPartyMember cS     
0x46 RequestDismissParty      
0x47 CanNotMoveAnymore (ch) ddddd    
0x48 RequestTargetCancel (ch)     
0x49 Say2 cSd cSdS    
0x4d RequestPledgeMemberList      
0x50 Request      
0x52 MoveWithDelta cddd     
0x55 Answer cd     
0x56 RequestActionUse cddc     
0x57 RequestRestart      
0x5a RequestSEKCustom cdd     
0x5b StartRotating cdd     
0x5c FinishRotating cdd     
0x5e RequestShowboard cd     
0x5f RequestEnchantItem cdd     
0x60 RequestDestroyItem cdQ     
0x60 SendDestroyItem cdQ     
0x62 RequestQuestList      
0x63 RequestDestroyQuest cd     
0x65 RequestPledgeInfo cd     
0x66 RequestPledgeExtendedInfo cS     
0x67 RequestPledgeCrest cd     
0x68 RequestHennaItemList cd     
0x68 RequestRecipeShopManageCancel      
0x6a RequestFriendInfoList      
0x6b RequestSendL2FriendSay cSS     
0x6c RequestOpenMinimap      
0x6d RequestSendMsnChatLog cSSd     
0x6e RequestReload      
0x6f RequestHennaEquip cd     
0x70 RequestHennaUnequipList cd     
0x71 RequestHennaUnequipInfo cd     
0x72 RequestHennaUnequip cd     
0x73 RequestAcquireSkillInfo cddd     
0x74 SendBypassBuildCmd cS     
0x75 MoveToLocationInVehicle cddddddd     
0x77 RequestFriendInvite cS     
0x78 RequestFriendAddReply cd     
0x7a RequestFriendDel cS     
0x7b CharacterRestorePacket cd     
0x7c RequestAcquireSkill cdddd cddd    
0x7d RequestRestartPoint cdd cd    
0x7e RequestGMCommand cSdd     
0x7f RequestPartyMatchConfig cddd     
0x80 RequestPartyMatchList cdddddS     
0x80 RequestSCCheck cdx     
0x81 RequestPartyMatchDetail cdddd     
0x83 SendPrivateStoreBuyList dQQ cddb    
0x85 RequestTutorialLinkHtml cdS     
0x86 RequestTutorialPassCmdToServer cS     
0x87 RequestTutorialQuestionMarkPressed cd     
0x88 RequestTutorialClientEvent cd     
0x89 RequestPetition cSd     
0x8a RequestPetitionCancel cS     
0x8b RequestGMList      
0x8c RequestJoinAlly cd     
0x8d RequestAnswerJoinAlly cd     
0x8e RequestWithdrawAlly      
0x8f RequestOustAlly cS     
0x90 RequestDismissAlly      
0x91 RequestSetAllyCrest cdb     
0x92 RequestAllyCrest cd     
0x93 RequestChangePetName cS     
0x94 RequestPetUseItem cd     
0x98 RequestPetGetItem cd     
0x9a SetPrivateStoreList dhhQQhhhhhhhhd cdb    
0x9f SendPrivateStoreBuyList ddhhQQd cddb    
0xa6 RequestSkillCoolTime      
0xa7 RequestPackageSendableItemList cd     
0xa8 RequestPackageSend dQ cddb    
0xa9 RequestBlock cdS cd    
0xaa RequestCastleSiegeInfo cd     
0xab RequestCastleSiegeAttackerList cd     
0xac RequestCastleSiegeInfo cd     
0xad RequestJoinCastleSiege cddd     
0xae RequestConfirmCastleSiegeWaitingList cddd     
0xaf RequestSetCastleSiegeTime cdd     
0xb0 RequestMultiSellChoose cddQhddhhhhhhhh     
0xb2 RequestRemainTime      
0xb3 BypassUserCmd cd     
0xb4 Snoop_quit cd     
0xb5 RequestRecipeBookOpen cd     
0xb6 RequestRecipeItemDelete cd     
0xb7 RequestRecipeItemMakeInfo cd     
0xb8 RequestRecipeItemMakeSelf cd     
0xba RequestRecipeShopMessageSet cS     
0xbb RequestRecipeShopListSet dQ cdb    
0xbc RequestRecipeShopManageQuit      
0xbe RequestRecipeShopMakeInfo cdd     
0xbf RequestRecipeShopMakeDo cddQ     
0xc0 RequestRecipeShopSellList cd     
0xc1 RequestObserverEndPacket      
0xc2 VoteSociality cd     
0xc4 RequestHennaItemInfo cd     
0xc5 RequestBuySeed dQ cddb    
0xc6 ConfirmDlg cddd     
0xc7 RequestPreviewItem cdddb     
0xc8 RequestSSQStatus cc     
0xc9:0x01 PetitionVote cddS     
0xcb ReplyGameGuardQuery cddddc     
0xcc RequestPledgePower cdd cddd    
0xcd RequestMakeMacro ccdcS cdSSSccb    
0xce RequestDeleteMacro cd     




GF

00 LogoutPacket 
01 Attack  cddddc
02 UnknownPacket0x02 cddc
03 RequestStartPledgeWar cS
05 RequestStopPledgeWar cS
07 ResponseAuthGameGuard cddddd
09 RequestSetPledgeCrest cdb lub cd
0B RequestGiveNickName cSS
0C NewCharacter cSdddddddddddd
0D CharacterDeletePacket cd
0F MoveBackwardToLocation cdddddd
10 Say cS
11 EnterWorldPacket cbddddbdcccccccccccccccccccc
12 CharacterSelect cdhddd
13 NewCharacterPacket 
14 ItemList 
15 RequestEquipItem cdd
16 RequestUnEquipItem cd
17 RequestDraopItemPacket cdQddd
19 UseItemPacket cdd
1A TradeRequestPacket cd
1b AddTradeItemPacket cddQ
1C TradeDonePacket cd
1F Action cddddc
22 RequestLinkHtml cS
23 RequestBypassToServer cS
24 RequestBBSWrite cSSSSSS
25 RequestCreatePledge cS
26 RequestJoinPledge cdd
27 RequestAnswerJoinPledge cd
28 RequestWithDrawalPledge 
29 RequestOustPledgeMember cS
2C RequestGetItemFromPet? cdQd
2E RequestAllyInfo  
2F RequestCrystallizeItem cdQ
30 UnknownPacket1
32 UnknownPacket2
33 RequestTeleportPacket cddddd lub cdddd
34 SocialAction cd
35 ChangeMoveType cd
36 ChangeWaitType cd
38 RequestMagicSkillList ddd
39 RequestMagicSkillUse cddc
3A SendApperingPacket 
3D RequestShortCutReg cddddd
3E RequestShortCutUse cddc
3F RequestShortCutDel cd
41 RequestDismissPledge 
42 RequestJoinParty cSd
43 RequestAnswerJoinParty cd
44 RequestWithDrawalParty 
45 RequestOustPartyMember cS
46 RequestDismissParty 
48 RequestTargetCancel ch
49 Say2 cSd lub cSdS
4D RequestPledgeMemberList 
4F RequestMagicList 
50 RequestSkillList 
52 MoveWithDelta cddd
53 GetOnVehicle cdddd
54 GetOffVehicle cdddd
55 AnswerTradeRequest cd
56 RequestActionUse cddc
57 RequestRestart 
58 RequestSiegeInfo 
59 ValidatePosition? cddddd
5a RequestSEKCustom cdd
5B StartRotating cdd
5C FinishRotating cdd
5e RequestShowboard cd
5F RequestEnchantItem cdd
60 RequestDestroyItem cdQ
62 RequestQuestList 
63 RequestDestroyQuest cd
66 RequestPledgeExtendedInfo cS
67 RequestPledgeCrest cd
6b RequestSendL2FriendSay cSS
6C RequestOpenMinimap 
6d RequestSendMsnChatLog cSSd
6e RequestReload 
6F RequestHennaEquip cd
70 RequestHennaUnequipList cd
71 RequestHennaUnequipInfo cd
72 RequestHennaUnequip cd
73 RequestAcquireSkillInfo cddd
74 SendBypassBuildCmd cS
77 RequestFriendInvite cS
78 RequestFriendAddReply cd
79 RequestFriendList 
7A RequestFriendDel cS
7B CharacterRestorePacket cd
7C RequestAcquireSkill cdddd lub cddd
7D RequestRestartPoint cd
7E RequestGMCommand cSdd
7F RequestPartyMatchConfig cddd
80 RequestPartyMatchList cdddddS
81 RequestPartyMatchDetail cdddd
82 UnknownPacket3 cd
84 ReviveReply cd
85 RequestTutorialLinkHtml cS
86 RequestTutorialPassCmdToServer cS
87 RequestTutorialQuestionMarkPressed cd
88 RequestTutorialClientEvent cd
89 RequestPetition cSd
8A RequestPetitionCancel cS
8B RequestGMList 
8C RequestJoinAlly cd
8D RequestAnswerJoinAlly cd
8E RequestWithdrawAlly  
8F RequestOustAlly cS
90 RequestDismissAlly  
91 RequestSetAllyCrest cdb
92 RequestAllyCrest cd
93 RequestChangePetName cS
94 RequestPetUseItem cd
95 RequestGiveItemToPet cdQ
96 RequestPrivateStoreQuitSell
97 SetPrivateStoreMsgSell cS
98 RequestPetGetItem cd
99 RequestPrivateStoreBuyManage?
9b UnknownPacket4
9c UnknownPacket5
9d UnknownPacket6 cS
9e UnknownPacket7 cd
A0 SendTimeCheckPacket cdd
a6 RequestSkillCoolTime 
a7 RequestPackageSendableItemList cd
A9 RequestBlock cdS lub cd
aa RequestCastleSiegeInfo cd
ab RequestCastleSiegeAttackerList cd
ac RequestCastleSiegeInfo cd
AD RequestJoinCastleSiege cddd
AE RequestConfirmCastleSiegeWaitingList cddd
af RequestSetCastleSiegeTime cdd
b1 NetPing cddd
b2 RequestRemainTime 
b3 BypassUserCmd cd
b4 SnofOPCODE(OP_quit cd
B5 RequestRecipeBookOpen cd
B6 RequestRecipeItemDelete cd
B7 RequestRecipeItemMakeInfo cd
B8 RequestRecipeItemMakeSelf cd 
B9 RequestRecipeShopManageList 
BA RequestRecipeShopMessageSet cS
BC RequestRecipeShopManageQuit 
BD RequestRecipeShopManageCancel 
BE RequestRecipeShopMakeInfo cdd
BF RequestRecipeShopMakeDo cddQ
C0 RequestRecipeShopSellList cd
c1 RequestObserverEndPacket 
c2 VoteSociality cd
c3 RequestHennaItemList cd
c4 RequestHennaItemInfo cd
c6 ConfirmDlg cddd
c8 RequestSSQStatus cc
c9 PetitionVote cddS
cb ReplyGameGuardQuery cdddd
cc RequestPledgePower cddd
CE RequestDeleteMacro  cd



D001 RequestManorList ch
D005 RequestWriteHeroWords chS
D006 RequestExAskJoinMPCC chS
D007 RequestExAcceptJoinMPCC chdd
D008 RequestExOustFromMPCC chS
D009 RequestOustFromPartyRoom chd
D00A RequestDismissPartyRoom chdd
D00B RequestWithdrawPartyRoom chdd
D00C RequestHandOverPartyMaster chS
D00D RequestAutoSoulShot chdd
d00E RequestExEnchantSkillInfo chddd
d00f RequestExEnchantSkill chdd
D010 RequestExPledgeCrestLarge  chd
D011 RequestExSetPledgeCrestLarge chdb lub chd
D012 RequestPledgeSetAcademyMaster chdSS
D013 RequestPledgePowerGradeList chch
D014 RequestPledgeMemberPowerInfo chdS
D015 RequestPledgeSetMemberPowerGrade chSd
D016 RequestPledgeMemberInfo chdS
D017 RequestPledgeWarList chdd
D018 RequestExFishRanking ch
D019 RequestPCCafeCouponUse chS
D01b RequestDuelStart chSd
D01c RequestDuelAnswerStart chddd
D01d RequestExSetTutorial chd
D01e RequestExRqItemLink chd
D021 RequestKeyMapping ch
D022 RequestSaveKeyMapping chdb
D023 RequestExRemoveItemAttribute chd
D025 RequestExitPartyMatchingWaitingRoom ch
D026 RequestConfirmTargetItem chd
D027 RequestConfirmRefinerItem chdd
D028 RequestConfirmGemStone chdddQ
D029 RequestOlympiadObserverEnd ch
D02A RequestCursedWeaponList ch
D02b RequestCursedWeaponLocation ch
D02C RequestPledgeReorganizeMember chdSdS
D02D RequestExMPCCShowPartyMembersInfo chd
D02E RequestOlympiadMatchList ch
D02f RequestAskJoinPartyRoom chS
D030 AnswerJoinPartyRoom chd
D031 RequestListPartyMatchingWaitingRoom chdddd
d032 RequestExEnchantSkill chdd
d033 RequestExEnchantSkill chdd
d034 RequestExEnchantSkill chdd
D035 RequestEnchantItemAttribute chd
D036 NieMaNazwyAleLeciPoUtworzeniuPostaci ch
D039 RequestBidItemAuction chdQ
D03a RequestInfoItemAuction chd
D03b RequestExChangeName chdSd
D03c RequestAllCastleInfo ch
D03d RequestAllFortressInfo ch
D03e RequestAllAgitInfo ch
D03f RequestFortressSiegeInfo ch
D040 RequestGetBossRecord chd
D041 RequestRefine chdddQ
D042 RequestConfirmCancelItem chd
D043 RequestConfirmCancelItem chd
D044 RequestExMagicSkillUseGround chdddddc
D045 RequestDuelSurrender ch
d046 RequestExEnchantSkillInfoDetail chddd
D048 RequestFortressMapInfo chd
D049 RequestPVPMatchRecord ch
D04a SetPrivateStoreWholeMsg chS
D04b RequestDispel chdd
D04c RequestExTryToPutEnchantTargetItem chd
D04d RequestExTryToPutEnchantSupportItem chdd
D04e RequestExCancelEnchantItem ch
D04f RequestChangeNicknameColor chdSd
D050 RequestResetNickname ch
D052 RequestWithDrawPremiumItem chQQ
D053 RequestJump ch
D054 RequestStartShowCrataeCubeRank ch
D055 RequestStopShowCrataeCubeRank ch
D056 NotifyStartMiniGame ch
D057 RequestJoinDominionWar chddd
D058 RequestDominionInfo ch
D059 RequestExCleftEnter chd
D05a RequestExBlockGameEnter chdd
D05b EndScenePlayer chd
D05c RequestExBlockGameVote chdd
D063 RequestSeedPhase ch
D065 BR_GamePoint ch
D066 BR_ProductList ch
D067 BR_ProductInfo chd
DO68 BR_BuyProduct chdd

D05100 RequestBookMarkSlotInfo chd
D05101 RequestSaveBookMarkSlot chdSdS
D05102 RequestModifyBookMarkSlot chddSdS
D05103 RequestDeleteBookMarkSlot chdd
D05104 RequestTeleportBookMark chdd
D05105 RequestChangeBookMarkSlot chddd


4A00 SuperCmdCharacterInfo ccS
4A01 SuperCmdSummonCmd ccS
4A02 SuperCmdServerStatus cc
4A03 SendL2ParamSetting ccdd

*/


/*

server EX packets

fe00	ExDummyPacket
fe01	ExRegenMaxPacket
fe02	ExEventMatchUserInfoPacket
fe03	ExColosseumFenceInfoPacket
fe04	ExEventMatchSpelledInfoPacket
fe05	ExEventMatchFirecrackerPacket
fe06	ExEventMatchTeamUnlockedPacket
fe07	ExEventMatchGMTestPacket
fe08	ExPartyRoomMemberPacket
fe09	ExClosePartyRoomPacket
fe0a	ExManagePartyRoomMemberPacket
fe0b	ExEventMatchLockResult
fe0c	ExAutoSoulShot
fe0d	ExEventMatchListPacket
fe0e	ExEventMatchObserverPacket
fe0f	ExEventMatchMessagePacket
fe10	ExEventMatchScorePacket
fe11	ExServerPrimitivePacket
fe12	ExOpenMPCCPacket
fe13	ExCloseMPCCPacket
fe14	ExShowCastleInfo
fe15	ExShowFortressInfo
fe16	ExShowAgitInfo
fe17	ExShowFortressSiegeInfo
fe18	ExPartyPetWindowAdd
fe19	ExPartyPetWindowUpdate
fe1a	ExAskJoinMPCCPacket
fe1b	ExPledgeCrestLargePacket
fe1c	ExEventMatchTeamInfoPacket
fe1d	ExEventMatchCreatePacket
fe1e	ExFishingStartPacket
fe1f	ExFishingEndPacket
fe20	ExShowQuestInfoPacket
fe21	ExShowQuestMarkPacket
fe22	ExSendManorListPacket
fe23	ExShowSeedInfoPacket
fe24	ExShowCropInfoPacket
fe25	ExShowManorDefaultInfoPacket
fe26	ExShowSeedSettingPacket
fe27	ExFishingStartCombatPacket
fe28	ExFishingHpRegenPacket
fe29	ExEnchantSkillListPacket
fe2a	ExEnchantSkillInfoPacket
fe2b	ExShowCropSettingPacket
fe2c	ExShowSellCropListPacket
fe2d	ExOlympiadMatchEndPacket
fe2e	ExMailArrivedPacket
fe2f	ExStorageMaxCountPacket
fe30	ExEventMatchManagePacket
fe31	ExMultiPartyCommandChannelInfoPacket
fe32	ExPCCafePointInfoPacket
fe33	ExSetCompassZoneCode
fe34	ExGetBossRecord
fe35	ExAskJoinPartyRoom
fe36	ExListPartyMatchingWaitingRoom
fe37	ExSetMpccRouting
fe38	ExShowAdventurerGuideBook
fe39	ExShowScreenMessage
fe3a	PledgeSkillListPacket
fe3b	PledgeSkillListAddPacket
fe3c	PledgePowerGradeList
fe3d	PledgeReceivePowerInfo
fe3e	PledgeReceiveMemberInfo
fe3f	PledgeReceiveWarList
fe40	PledgeReceiveSubPledgeCreated
fe41	ExRedSkyPacket
fe42	PledgeReceiveUpdatePower
fe43	FlySelfDestinationPacket
fe44	ShowPCCafeCouponShowUI
fe45	ExSearchOrc
fe46	ExCursedWeaponList
fe47	ExCursedWeaponLocation
fe48	ExRestartClient
fe49	ExRequestHackShield
fe4a	ExUseSharedGroupItem
fe4b	ExMPCCShowPartyMemberInfo
fe4c	ExDuelAskStart
fe4d	ExDuelReady
fe4e	ExDuelStart
fe4f	ExDuelEnd
fe50	ExDuelUpdateUserInfo
fe51	ExShowVariationMakeWindow
fe52	ExShowVariationCancelWindow
fe53	ExPutItemResultForVariationMake
fe54	ExPutIntensiveResultForVariationMake
fe55	ExPutCommissionResultForVariationMake
fe56	ExVariationResult
fe57	ExPutItemResultForVariationCancel
fe58	ExVariationCancelResult
fe59	ExDuelEnemyRelation
fe5a	ExPlayAnimation
fe5b	ExMPCCPartyInfoUpdate
fe5c	ExPlayScene
fe5d	ExSpawnEmitterPacket
fe5e	ExEnchantSkillInfoDetailPacket
fe5f	ExBasicActionList
fe60	ExAirShipInfo
fe61	ExAttributeEnchantResultPacket
fe62	ExChooseInventoryAttributeItemPacket
fe63	ExGetOnAirShipPacket
fe64	ExGetOffAirShipPacket
fe65	ExMoveToLocationAirShipPacket
fe66	ExStopMoveAirShipPacket
fe67	ExShowTracePacket
fe68	ExItemAuctionInfoPacket
fe69	ExNeedToChangeName
fe6a	ExPartyPetWindowDelete
fe6b	ExTutorialList
fe6c	ExRpItemLink
fe6d	ExMoveToLocationInAirShipPacket
fe6e	ExStopMoveInAirShipPacket
fe6f	ExValidateLocationInAirShipPacket
fe70	ExUISettingPacket
fe71	ExMoveToTargetInAirShipPacket
fe72	ExAttackInAirShipPacket
fe73	ExMagicSkillUseInAirShipPacket
fe74	ExShowBaseAttributeCancelWindow
fe75	ExBaseAttributeCancelResult
fe76	ExSubPledgetSkillAdd
fe77	ExResponseFreeServer
fe78	ExShowProcureCropDetailPacket
fe79	ExHeroListPacket
fe7a	ExOlympiadUserInfoPacket
fe7b	ExOlympiadSpelledInfoPacket
fe7c	ExOlympiadModePacket
fe7d	ExShowFortressMapInfo
fe7e	ExPVPMatchRecord
fe7f	ExPVPMatchUserDie
fe80	ExPrivateStoreWholeMsg

fe81	ExPutEnchantTargetItemResult
fe82	ExPutEnchantSupportItemResult
fe83	ExChangeNicknameNColor
fe84	ExGetBookMarkInfoPacket
fe85	ExNotifyPremiumItem
fe86	ExGetPremiumItemListPacket
fe87	ExPeriodicItemList
fe88	ExJumpToLocation
fe89	ExPVPMatchCCRecord
fe8a	ExPVPMatchCCMyRecord
fe8b	ExPVPMatchCCRetire
fe8c	ExShowTerritory
fe8d	ExNpcQuestHtmlMessage
fe8e	ExSendUIEventPacket
fe8f	ExNotifyBirthDay
fe90	ExShowDominionRegistry
fe91	ExReplyRegisterDominion
fe92	ExReplyDominionInfo
fe93	ExShowOwnthingPos
fe94	ExCleftList
fe95	ExCleftState
fe96	ExDominionChannelSet
fe97	ExBlockUpSetList
fe98	ExBlockUpSetState
fe99	ExStartScenePlayer
fe9a	ExAirShipTeleportList
fe9b	ExMpccRoomInfo
fe9c	ExListMpccWaiting
fe9d	ExDissmissMpccRoom
fe9e	ExManageMpccRoomMember
fe9f	ExMpccRoomMember
fea0	ExVitalityPointInfo
fea1	ExShowSeedMapInfo
fea2	ExMpccPartymasterList
fea3	ExDominionWarStart
fea4	ExDominionWarEnd
fea5	ExDummyPacket
fea6	ExBR_GamePointPacket
fea7	ExBR_ProductListPacket
fea8	ExBR_ProductInfoPacket
fea9	ExBR_BuyProductPacket
feaa	ExBR_PremiumStatePacket
feab	ExBrBroadcastEventState
feac	ExBrExtraUserInfo

*/


/*
server packets

0	DiePacket
1	RevivePacket
2	AttackOutofRangePacket
3	AttackinCoolTimePacket
4	AttackDeadTargetPacket
5	SpawnItemPacket
6	SellListPacket
7	BuyListPacket
8	DeleteObjectPacket
9	CharacterSelectionInfoPacket
a	LoginFailPacket
b	CharacterSelectedPacket
c	NpcInfoPacket
d	NewCharacterSuccessPacket
e	NewCharacterFailPacket
f	CharacterCreateSuccessPacket
10	CharacterCreateFailPacket
11	ItemListPacket
12	SunRisePacket
13	SunSetPacket
14	TradeStartPacket
15	TradeStartOkPacket
16	DropItemPacket
17	GetItemPacket
18	StatusUpdatePacket
19	NpcHtmlMessagePacket
1a	TradeOwnAddPacket
1b	TradeOtherAddPacket
1c	TradeDonePacket
1d	CharacterDeleteSuccessPacket
1e	CharacterDeleteFailPacket
1f	ActionFailPacket
20	SeverClosePacket
21	InventoryUpdatePacket
22	TeleportToLocationPacket
23	TargetSelectedPacket
24	TargetUnselectedPacket
25	AutoAttackStartPacket
26	AutoAttackStopPacket
27	SocialActionPacket
28	ChangeMoveTypePacket
29	ChangeWaitTypePacket
2a	ManagePledgePowerPacket
2b	CreatePledgePacket
2c	AskJoinPledgePacket
2d	JoinPledgePacket
2e	VersionCheckPacket
2f	MTLPacket
30	NSPacket
31	CIPacket
32	UIPacket
33	AttackPacket
34	WithdrawalPledgePacket
35	OustPledgeMemberPacket
36	SetOustPledgeMemberPacket
37	DismissPledgePacket
38	SetDismissPledgePacket
39	AskJoinPartyPacket
3a	JoinPartyPacket
3b	WithdrawalPartyPacket
3c	OustPartyMemberPacket
3d	SetOustPartyMemberPacket
3e	DismissPartyPacket
3f	SetDismissPartyPacket
40	MagicAndSkillList
41	WareHouseDepositListPacket
42	WareHouseWithdrawListPacket
43	WareHouseDonePacket
44	ShortCutRegisterPacket
45	ShortCutInitPacket
46	ShortCutDeletePacket
47	StopMovePacket
48	MagicSkillUse
49	MagicSkillCanceled
4a	SayPacket2
4b	EquipUpdatePacket
4c	DoorInfoPacket
4d	DoorStatusUpdatePacket
4e	PartySmallWindowAllPacket
4f	PartySmallWindowAddPacket
50	PartySmallWindowDeleteAllPacket
51	PartySmallWindowDeletePacket
52	PartySmallWindowUpdatePacket
53	TradePressOwnOkPacket
54	MagicSkillLaunchedPacket
55	FriendAddRequestResult
56	FriendAdd
57	FriendRemove
58	FriendList
59	FriendStatus
5a	PledgeShowMemberListAllPacket
5b	PledgeShowMemberListUpdatePacket
5c	PledgeShowMemberListAddPacket
5d	PledgeShowMemberListDeletePacket
5e	MagicListPacket
5f	SkillListPacket
60	VehicleInfoPacket
61	FinishRotatingPacket
62	SystemMessagePacket
63	StartPledgeWarPacket
64	ReplyStartPledgeWarPacket
65	StopPledgeWarPacket
66	ReplyStopPledgeWarPacket
67	SurrenderPledgeWarPacket
68	ReplySurrenderPledgeWarPacket
69	SetPledgeCrestPacket
6a	PledgeCrestPacket
6b	SetupGaugePacket
6c	VehicleDeparturePacket
6d	VehicleCheckLocationPacket
6e	GetOnVehiclePacket
6f	GetOffVehiclePacket
70	TradeRequestPacket
71	RestartResponsePacket
72	MoveToPawnPacket
73	SSQInfoPacket
74	GameGuardQueryPacket
75	L2FriendListPacket
76	L2FriendPacket
77	L2FriendStatusPacket
78	L2FriendSayPacket
79	ValidateLocationPacket
7a	StartRotatingPacket
7b	ShowBoardPacket
7c	ChooseInventoryItemPacket
7d	DummyPacket
7e	MoveToLocationInVehiclePacket
7f	StopMoveInVehiclePacket
80	ValidateLocationInVehiclePacket
81	TradeUpdatePacket
82	TradePressOtherOkPacket
83	FriendAddRequest
84	LogOutOkPacket
85	AbnormalStatusUpdatePacket
86	QuestListPacket
87	EnchantResultPacket
88	PledgeShowMemberListDeleteAllPacket
89	PledgeInfoPacket
8a	PledgeExtendedInfoPacket
8b	SurrenderPersonallyPacket
8c	RidePacket
8d	DummyPacket
8e	PledgeShowInfoUpdatePacket
8f	ClientActionPacket
90	AcquireSkillListPacket
91	AcquireSkillInfoPacket
92	ServerObjectInfoPacket
93	GMHidePacket
94	AcquireSkillDonePacket
95	GMViewCharacterInfoPacket
96	GMViewPledgeInfoPacket
97	GMViewSkillInfoPacket
98	GMViewMagicInfoPacket
99	GMViewQuestInfoPacket
9a	GMViewItemListPacket
9b	GMViewWarehouseWithdrawListPacket
9c	ListPartyWatingPacket
9d	PartyRoomInfoPacket
9e	PlaySoundPacket
9f	StaticObjectPacket
a0	PrivateStoreManageList
a1	PrivateStoreList
a2	PrivateStoreMsg
a3	ShowMinimapPacket
a4	ReviveRequestPacket
a5	AbnormalVisualEffectPacket
a6	TutorialShowHtmlPacket
a7	TutorialShowQuestionMarkPacket
a8	TutorialEnableClientEventPacket
a9	TutorialCloseHtmlPacket
aa	ShowRadarPacket
ab	WithdrawAlliancePacket
ac	OustAllianceMemberPledgePacket
ad	DismissAlliancePacket
ae	SetAllianceCrestPacket
af	AllianceCrestPacket
b0	ServerCloseSocketPacket
b1	PetStatusShowPacket
b2	PetInfoPacket
b3	PetItemListPacket
b4	PetInventoryUpdatePacket
b5	AllianceInfoPacket
b6	PetStatusUpdatePacket
b7	PetDeletePacket
b8	DeleteRadarPacket
b9	MyTargetSelectedPacket
ba	PartyMemberPositionPacket
bb	AskJoinAlliancePacket
bc	JoinAlliancePacket
bd	PrivateStoreBuyManageList
be	PrivateStoreBuyList
bf	PrivateStoreBuyMsg
c0	VehicleStartPacket
c1	RequestTimeCheckPacket
c2	StartAllianceWarPacket
c3	ReplyStartAllianceWarPacket
c4	StopAllianceWarPacket
c5	ReplyStopAllianceWarPacket
c6	SurrenderAllianceWarPacket
c7	SkillCoolTimePacket
c8	PackageToListPacket
c9	CastleSiegeInfoPacket
ca	CastleSiegeAttackerListPacket
cb	CastleSiegeDefenderListPacket
cc	NickNameChangedPacket
cd	PledgeStatusChangedPacket
ce	RelationChangedPacket
cf	EventTriggerPacket
d0	MultiSellListPacket
d1	SetSummonRemainTimePacket
d2	PackageSendableListPacket
d3	EarthQuakePacket
d4	FlyToLoactionPacket
d5	BlockListPacket
d6	SpecialCameraPacket
d7	NormalCameraPacket
d8	SkillRemainSecPacket
d9	NetPingPacket
da	DicePacket
db	SnoopPacket
dc	RecipeBookItemListPacket
dd	RecipeItemMakeInfoPacket
de	RecipeShopManageListPacket
df	RecipeShopSellListPacket
e0	RecipeShopItemInfoPacket
e1	RecipeShopMsgPacket
e2	ShowCalcPacket
e3	MonRaceInfoPacket
e4	HennaItemInfoPacket
e5	HennaInfoPacket
e6	HennaUnequipListPacket
e7	HennaUnequipInfoPacket
e8	MacroListPacket
e9	BuyListSeedPacket
ea	ShowTownMapPacket
eb	ObserverStartPacket
ec	ObserverEndPacket
ed	ChairSitPacket
ee	HennaEquipListPacket
ef	SellListProcurePacket
f0	GMHennaInfoPacket
f1	RadarControlPacket
f2	ClientSetTimePacket
f3	ConfirmDlgPacket
f4	PartySpelledPacket
f5	ShopPreviewListPacket
f6	ShopPreviewInfoPacket
f7	CameraModePacket
f8	ShowXMasSealPacket
f9	EtcStatusUpdatePacket
fa	ShortBuffStatusUpdatePacket
fb	SSQStatusPacket
fc	PetitionVotePacket
fd	AgitDecoInfoPacket
fe	DummyPacket

*/
/** 
26  * 
27  * the HTML parser in the client knowns these standard and non-standard tags and attributes 
28  * VOLUMN 
29  * UNKNOWN 
30  * UL 
31  * U 
32  * TT 
33  * TR 
34  * TITLE 
35  * TEXTCODE 
36  * TEXTAREA 
37  * TD 
38  * TABLE 
39  * SUP 
40  * SUB 
41  * STRIKE 
42  * SPIN 
43  * SELECT 
44  * RIGHT 
45  * PRE 
46  * P 
47  * OPTION 
48  * OL 
49  * MULTIEDIT 
50  * LI 
51  * LEFT 
52  * INPUT 
53  * IMG 
54  * I 
55  * HTML 
56  * H7 
57  * H6 
58  * H5 
59  * H4 
60  * H3 
61  * H2 
62  * H1 
63  * FONT 
64  * EXTEND 
65  * EDIT 
66  * COMMENT 
67  * COMBOBOX 
68  * CENTER 
69  * BUTTON 
70  * BR 
71  * BODY 
72  * BAR 
73  * ADDRESS 
74  * A 
75  * SEL 
76  * LIST 
77  * VAR 
78  * FORE 
79  * READONL 
80  * ROWS 
81  * VALIGN 
82  * FIXWIDTH 
83  * BORDERCOLORLI 
84  * BORDERCOLORDA 
85  * BORDERCOLOR 
86  * BORDER 
87  * BGCOLOR 
88  * BACKGROUND 
89  * ALIGN 
90  * VALU 
91  * READONLY 
92  * MULTIPLE 
93  * SELECTED 
94  * TYP 
95  * TYPE 
96  * MAXLENGTH 
97  * CHECKED 
98  * SRC 
99  * Y 
100  * X 
101  * QUERYDELAY 
102  * NOSCROLLBAR 
103  * IMGSRC 
104  * B 
105  * FG 
106  * SIZE 
107  * FACE 
108  * COLOR 
109  * DEFFON 
110  * DEFFIXEDFONT 
111  * WIDTH 
112  * VALUE 
113  * TOOLTIP 
114  * NAME 
115  * MIN 
116  * MAX 
117  * HEIGHT 
118  * DISABLED 
119  * ALIGN 
120  * MSG 
121  * LINK 
122  * HREF 
123  * ACTION 

LINDVIOR

						case 0xd0:
							int id3 = buf.getShort() & 0xffff;
							System.out.println("Packet ID(id3): "+id3);
							switch (id3)
							{
								case 0x00:
									// msg = new ?();
									break;
								case 0x01:
									msg = new RequestManorList();
									break;
								case 0x02:
									msg = new RequestProcureCropList();
									break;
								case 0x03:
									msg = new RequestSetSeed();
									break;
								case 0x04:
									msg = new RequestSetCrop();
									break;
								case 0x05:
									msg = new RequestWriteHeroWords();
									break;
								case 0x06:
									msg = new RequestExMPCCAskJoin(); // RequestExAskJoinMPCC();
									break;
								case 0x07:
									msg = new RequestExMPCCAcceptJoin(); // RequestExAcceptJoinMPCC();
									break;
								case 0x08:
									msg = new RequestExOustFromMPCC();
									break;
								case 0x09:
									msg = new RequestOustFromPartyRoom();
									break;
								case 0x0A:
									msg = new RequestDismissPartyRoom();
									break;
								case 0x0B:
									msg = new RequestWithdrawPartyRoom();
									break;
								case 0x0C:
									msg = new RequestHandOverPartyMaster();
									break;
								case 0x0D:
									msg = new RequestAutoSoulShot();
									break;
								case 0x0E:
									msg = new RequestExEnchantSkillInfo();
									break;
								case 0x0F:
									msg = new RequestExEnchantSkill();
									break;
								case 0x10:
									msg = new RequestPledgeCrestLarge();
									break;
								case 0x11:
									msg = new RequestSetPledgeCrestLarge();
									break;
								case 0x12:
									msg = new RequestPledgeSetAcademyMaster();
									break;
								case 0x13:
									msg = new RequestPledgePowerGradeList();
									break;
								case 0x14:
									msg = new RequestPledgeMemberPowerInfo();
									break;
								case 0x15:
									msg = new RequestPledgeSetMemberPowerGrade();
									break;
								case 0x16:
									msg = new RequestPledgeMemberInfo();
									break;
								case 0x17:
									msg = new RequestPledgeWarList();
									break;
								case 0x18:
									msg = new RequestExFishRanking();
									break;
								case 0x19:
									msg = new RequestPCCafeCouponUse();
									break;
								case 0x1A:
									//msg = new RequestServerLogin(); (chb) b - array ???????? ? 64 ?????
									break;
								case 0x1B:
									msg = new RequestDuelStart();
									break;
								case 0x1C:
									msg = new RequestDuelAnswerStart();
									break;
								case 0x1D:
									msg = new RequestTutorialClientEvent(); // RequestExSetTutorial(); Format: d / ??????? ???????, ????, ??? ?????? ?????? ????? (?) Drin
									break;
								case 0x1E:
									msg = new RequestExRqItemLink();
									break;
								case 0x1F:
									msg = new CannotMoveAnymoreInVehicle(); // (AirShip) (ddddd)
									break;
								case 0x20:
									msg = new RequestExMoveToLocationInAirShip();
									break;
								case 0x21:
									msg = new RequestKeyMapping();
									break;
								case 0x22:
									msg = new RequestSaveKeyMapping();
									break;
								case 0x23:
									msg = new RequestExRemoveItemAttribute();
									break;
								case 0x24:
									msg = new RequestSaveInventoryOrder();
									break;
								case 0x25:
									msg = new RequestExitPartyMatchingWaitingRoom();
									break;
								case 0x26:
									msg = new RequestConfirmTargetItem();
									break;
								case 0x27:
									msg = new RequestConfirmRefinerItem();
									break;
								case 0x28:
									msg = new RequestConfirmGemStone();
									break;
								case 0x29:
									msg = new RequestOlympiadObserverEnd();
									break;
								case 0x2A:
									msg = new RequestCursedWeaponList();
									break;
								case 0x2B:
									msg = new RequestCursedWeaponLocation();
									break;
								case 0x2C:
									msg = new RequestPledgeReorganizeMember();
									break;
								case 0x2D:
									msg = new RequestExMPCCShowPartyMembersInfo();
									break;
								case 0x2E:
									msg = new RequestExOlympiadObserverEnd(); // ?? ?????? (? ??????? ?????????? RequestOlympiadMatchList)
									break;
								case 0x2F:
									msg = new RequestAskJoinPartyRoom();
									break;
								case 0x30:
									msg = new AnswerJoinPartyRoom();
									break;
								case 0x31:
									msg = new RequestListPartyMatchingWaitingRoom();
									break;
								case 0x32:
									msg = new RequestEnchantItemAttribute();
									break;
								case 0x33:
									//msg = new RequestGotoLobby();
									break;
								case 0x35:
									msg = new RequestExMoveToLocationAirShip();
									break;
								case 0x36:
									msg = new RequestBidItemAuction();
									break;
								case 0x37:
									msg = new RequestInfoItemAuction();
									break;
								case 0x38:
									msg = new RequestExChangeName();
									break;
								case 0x39:
									msg = new RequestAllCastleInfo();
									break;
								case 0x3A:
									msg = new RequestAllFortressInfo();
									break;
								case 0x3B:
									msg = new RequestAllAgitInfo();
									break;
								case 0x3C:
									msg = new RequestFortressSiegeInfo();
									break;
								case 0x3D:
									msg = new RequestGetBossRecord();
									break;
								case 0x3E:
									msg = new RequestRefine();
									break;
								case 0x3F:
									msg = new RequestConfirmCancelItem();
									break;
								case 0x40:
									msg = new RequestRefineCancel();
									break;
								case 0x41:
									msg = new RequestExMagicSkillUseGround();
									break;
								case 0x42:
									msg = new RequestDuelSurrender();
									break;
								case 0x43:
									msg = new RequestExEnchantSkillInfoDetail();
									break;
								// 0xD0:0x44 - missed
								case 0x45:
									msg = new RequestFortressMapInfo();
									break;
								case 0x46:
									msg = new RequestPVPMatchRecord();
									break;
								case 0x47:
									msg = new SetPrivateStoreWholeMsg();
									break;
								case 0x48:
									msg = new RequestDispel();
									break;
								case 0x49:
									msg = new RequestExTryToPutEnchantTargetItem();
									break;
								case 0x4A:
									msg = new RequestExTryToPutEnchantSupportItem();
									break;
								case 0x4B:
									msg = new RequestExCancelEnchantItem();
									break;
								case 0x4C:
									msg = new RequestChangeNicknameColor();
									break;
								case 0x4D:
									msg = new RequestResetNickname();
									break;
								case 0x4E:
									int id4 = buf.getInt();
									switch (id4)
									{
										case 0x00:
											msg = new RequestBookMarkSlotInfo();
											break;
										case 0x01:
											msg = new RequestSaveBookMarkSlot();
											break;
										case 0x02:
											msg = new RequestModifyBookMarkSlot();
											break;
										case 0x03:
											msg = new RequestDeleteBookMarkSlot();
											break;
										case 0x04:
											msg = new RequestTeleportBookMark();
											break;
										case 0x05:
											msg = new RequestChangeBookMarkSlot();
											break;
										default:
											client.onUnknownPacket();
											break;
									}
									break;
								case 0x4F:
									msg = new RequestWithDrawPremiumItem();
									break;
								case 0x50:
									msg = new RequestExJump();
									break;
								case 0x51:
									msg = new RequestExStartShowCrataeCubeRank();
									break;
								case 0x52:
									msg = new RequestExStopShowCrataeCubeRank();
									break;
								case 0x53:
									msg = new NotifyStartMiniGame();
									break;
								case 0x54:
									msg = new RequestExJoinDominionWar();
									break;
								case 0x55:
									msg = new RequestExDominionInfo();
									break;
								case 0x56:
									msg = new RequestExCleftEnter();
									break;
								case 0x57:
									msg = new RequestExCubeGameChangeTeam();
									break;
								case 0x58:
									msg = new RequestExEndScenePlayer();
									break;
								case 0x59:
									msg = new RequestExCubeGameReadyAnswer(); // RequestExBlockGameVote
									break;
								case 0x5A:
									msg = new RequestExListMpccWaiting();
									break;
								case 0x5B:
									msg = new RequestExManageMpccRoom();
									break;
								case 0x5C:
									msg = new RequestExJoinMpccRoom();
									break;
								case 0x5D:
									msg = new RequestExOustFromMpccRoom();
									break;
								case 0x5E:
									msg = new RequestExDismissMpccRoom();
									break;
								case 0x5F:
									msg = new RequestExWithdrawMpccRoom();
									break;
								case 0x60:
									msg = new RequestExSeedPhase();
									break;
								case 0x61:
									msg = new RequestExMpccPartymasterList();
									break;
								case 0x62:
									msg = new RequestExPostItemList();
									break;
								case 0x63:
									msg = new RequestExSendPost();
									break;
								case 0x64:
									msg = new RequestExRequestReceivedPostList();
									break;
								case 0x65:
									msg = new RequestExDeleteReceivedPost();
									break;
								case 0x66:
									msg = new RequestExRequestReceivedPost();
									break;
								case 0x67:
									msg = new RequestExReceivePost();
									break;
								case 0x68:
									msg = new RequestExRejectPost();
									break;
								case 0x69:
									msg = new RequestExRequestSentPostList();
									break;
								case 0x6A:
									msg = new RequestExDeleteSentPost();
									break;
								case 0x6B:
									msg = new RequestExRequestSentPost();
									break;
								case 0x6C:
									msg = new RequestExCancelSentPost();
									break;
								case 0x6D:
									msg = new RequestExShowNewUserPetition();
									break;
								case 0x6E:
									msg = new RequestExShowStepTwo();
									break;
								case 0x6F:
									msg = new RequestExShowStepThree();
									break;
								case 0x70:
									// msg = new ExConnectToRaidServer(); (chddd)
									break;
								case 0x71:
									// msg = new ExReturnFromRaidServer(); (chd)
									break;
								case 0x72:
									msg = new RequestExRefundItem();
									break;
								case 0x73:
									msg = new RequestExBuySellUIClose();
									break;
								case 0x74:
									msg = new RequestExEventMatchObserverEnd();
									break;
								case 0x75:
									msg = new RequestPartyLootModification();
									break;
								case 0x76:
									msg = new AnswerPartyLootModification();
									break;
								case 0x77:
									msg = new AnswerCoupleAction();
									break;
								case 0x78:
									msg = new RequestExBR_EventRankerList();
									break;
								case 0x79:
									// msg = new RequestAskMemberShip();
									break;
								case 0x7A:
									msg = new RequestAddExpandQuestAlarm();
									break;
								case 0x7B:
									msg = new RequestVoteNew();
									break;
								case 0x7C:
									msg = new RequestGetOnShuttle();
									break;
								case 0x7D:
									msg = new RequestGetOffShuttle();
									break;
								case 0x7E:
									msg = new RequestMoveToLocationInShuttle();
									break;
								case 0x7F:
									msg = new CannotMoveAnymoreInVehicle(); // CannotMoveAnymoreInShuttle(); (chddddd)
									break;
								case 0x80:
									int id5 = buf.getInt();
									switch (id5)
									{
										case 0x01:
											//msg = new RequestExAgitInitialize chd 0x01
											break;
										case 0x02:
											//msg = new RequestExAgitDetailInfo chdcd 0x02
											break;
										case 0x03:
											//msg = new RequestExMyAgitState chd 0x03
											break;
										case 0x04:
											//msg = new RequestExRegisterAgitForBidStep1 chd 0x04
											break;
										case 0x05:
											//msg = new RequestExRegisterAgitForBidStep2 chddQd 0x05 //msg = new RequestExRegisterAgitForBidStep3 chddQd 0x05 -no error? 0x05
											break;
										case 0x07:
											//msg = new RequestExConfirmCancelRegisteringAgit chd 0x07
											break;
										case 0x08:
											//msg = new RequestExProceedCancelRegisteringAgit chd 0x08
											break;
										case 0x09:
											//msg = new RequestExConfirmCancelAgitBid chdd 0x09
											break;
										case 0x10:
											//msg = new RequestExReBid chdd 0x10
											break;
										case 0x11:
											//msg = new RequestExAgitListForLot chd 0x11
											break;
										case 0x12:
											//msg = new RequestExApplyForAgitLotStep1 chdc 0x12
											break;
										case 0x13:
											//msg = new RequestExApplyForAgitLotStep2 chdc 0x13
											break;
										case 0x14:
											//msg = new RequestExAgitListForBid chdd 0x14
											break;
										case 0x0D:
											//msg = new RequestExApplyForBidStep1 chdd 0x0D
											break;
										case 0x0E:
											//msg = new RequestExApplyForBidStep2 chddQ 0x0E
											break;
										case 0x0F:
											//msg = new RequestExApplyForBidStep3 chddQ 0x0F
											break;
										//case 0x09:
											//msg = new RequestExConfirmCancelAgitLot chdc 0x09
											//break;
										case 0x0A:
											//msg = new RequestExProceedCancelAgitLot chdc 0x0A
											break;
										//case 0x0A:
											//msg = new RequestExProceedCancelAgitBid chdd 0x0A
											//break;
									}
									break;
								case 0x81:
									msg = new RequestExAddPostFriendForPostBox();
									break;
								case 0x82:
									msg = new RequestExDeletePostFriendForPostBox();
									break;
								case 0x83:
									msg = new RequestExShowPostFriendListForPostBox();
									break;
								case 0x84:
									msg = new RequestExFriendListForPostBox(); // TODO[K] - ?? ???? ???????? 84 ? ??????, ?? ? ??????? ????? ?? ????????????!
									break;
								case 0x85:
									msg = new RequestOlympiadMatchList(); // TODO[K] - ?????? ???????? ? ?????? (?? 00 ???????). ????? ????????? ???????? ?? ??????? ?_??
									break;
								case 0x86:
									msg = new RequestExBR_GamePoint();
									break;
								case 0x87:
									msg = new RequestExBR_ProductList();
									break;
								case 0x88:
									msg = new RequestExBR_ProductInfo();
									break;
								case 0x89:
									msg = new RequestExBR_BuyProduct();
									break;
								case 0x8A:
									msg = new RequestExBR_RecentProductList();
									break;
								case 0x8B:
									msg = new RequestBR_MiniGameLoadScores();
									break;
								case 0x8C:
									msg = new RequestBR_MiniGameInsertScore();
									break;
								case 0x8D:
									msg = new RequestExBR_LectureMark();
									break;
								case 0x8E:
									msg = new RequestCrystallizeEstimate();
									break;
								case 0x8F:
									msg = new RequestCrystallizeItemCancel();
									break;
								case 0x90:
									msg = new RequestExEscapeScene();
									break;
								case 0x91:
									msg = new RequestFlyMove();
									break;
								case 0x92:
									//msg = new RequestSurrenderPledgeWarEX(); (chS)
									break;
								case 0x93:
									int id6 = buf.get();
									switch (id6)
									{
										case 0x02:
											msg = new RequestDynamicQuestProgressInfo();
											break;
										case 0x03:
											msg = new RequestDynamicQuestScoreBoard();
											break;
										case 0x04:
											msg = new RequestDynamicQuestHTML();
											break;
										default:
											client.onUnknownPacket();
											break;
									}
									break;
								case 0x94:
									msg = new RequestFriendDetailInfo();
									break;
								case 0x95:
									msg = new RequestUpdateFriendMemo();
									break;
								case 0x96:
									msg = new RequestUpdateBlockMemo();
									break;
								case 0x97:
									//msg = new RequestInzonePartyInfoHistory(); (ch) TODO[K]
									break;
								case 0x98:
									msg = new RequestCommissionRegistrableItemList();
									break;
								case 0x99:
									msg = new RequestCommissionInfo();
									break;
								case 0x9A:
									msg = new RequestCommissionRegister();
									break;
								case 0x9B:
									msg = new RequestCommissionCancel();
									break;
								case 0x9C:
									msg = new RequestCommissionDelete();
									break;
								case 0x9D:
									msg = new RequestCommissionList();
									break;
								case 0x9E:
									msg = new RequestCommissionBuyInfo();
									break;
								case 0x9F:
									msg = new RequestCommissionBuyItem();
									break;
								case 0xA0:
									msg = new RequestCommissionRegisteredItem();
									break;
								case 0xA1:
									msg = new RequestCallToChangeClass();
									break;
								case 0xA2:
									msg = new RequestChangeToAwakenedClass();
									break;
								case 0xA3:
									msg = new RequestWorldStatistics();
									break;
								case 0xA4:
									msg = new RequestUserStatistics();
									break;
								case 0xA5:
									msg = new RequestRegistPartySubstitute();
									break;
								case 0xA6:
									msg = new RequestDeletePartySubstitute();
									break;
								case 0xA7:
									msg = new RequestRegistWaitingSubstitute();
									break;
								case 0xA8:
									msg = new RequestAcceptWaitingSubstitute();
									break;
								case 0xA9:
									msg = new Request24HzSessionID();
									break;
								case 0xAE:
									msg = new RequestGoodsInventoryInfo();
									break;
								case 0xAF:
									// msg= new RequestUseGoodsInventoryItem(); (chcQ) TODO[K]
									break;
								case 0xB0:
									msg = new RequestFirstPlayStart();
									break;
								case 0xB1:
									msg = new RequestFlyMoveStart();
									break;
								case 0xB2:
									msg = new RequestHardWareInfo(); // (chSddddddSddddddddddSS) TODO[K]
									break;
								// 0xD0:0xB3 missed
								case 0xB4:
									msg = new SendChangeAttributeTargetItem();
									break;
								case 0xB5:
									msg = new RequestChangeAttributeItem();
									break;
								case 0xB6:
									msg = new RequestChangeAttributeCancel();
									break;
								case 0xB7:
									//msg = new RequestExchangeSubstitute(); (chddd) TODO[K]
									break;
								case 0xB8:
									msg = new RequestBR_PresentBuyProduct();
									break;
								case 0xB9:
									msg = new ConfirmMenteeAdd();
									break;
								case 0xBA:
									msg = new RequestMentorCancel();
									break;
								case 0xBB:
									msg = new RequestMentorList();
									break;
								case 0xBC:
									msg = new RequestMenteeAdd();
									break;
								case 0xBD:
									msg = new RequestMenteeSearch(); // RequestMenteeWaitingList
									break;
								case 0xBE:
									msg = new RequestClanAskJoinByName(); // RequestJoinPledgeByName
									break;
								case 0xBF:
									msg = new RequestInZoneWaitingTime();
									break;
								case 0xC0:
									//msg = new RequestJoinCuriousHouse(); (ch) TODO[K]
									break;
								case 0xC1:
									//msg = new RequestCancelCuriousHouse(); (ch) TODO[K]
									break;
								case 0xC2:
									//msg = new RequestLeaveCuriousHouse(); (ch) TODO[K]
									break;
								case 0xC3:
									//msg = new RequestObservingListCuriousHouse(); (ch) TODO[K]
									break;
								case 0xC4:
									//msg = new RequestObservingCuriousHouse(); (chd) TODO[K]
									break;
								case 0xC5:
									//msg = new RequestLeaveObservingCuriousHouse(); (ch) TODO[K]
									break;
								case 0xC6:
									//msg = new RequestCuriousHouseHtml(); (ch) TODO[K]
									break;
								case 0xC7:
									//msg = new RequestCuriousHouseRecord(); (ch) TODO[K]
									break;
								case 0xC8:
									//msg = new ExSysstring(); (chdS) TODO[K]
									break;
								case 0xC9:
									msg = new RequestExTryToPutShapeShiftingTargetItem();
									break;
								case 0xCA:
									msg = new RequestExTryToPutShapeShiftingExtractionItem(); // SupportItem
									break;
								case 0xCB:
									msg = new RequestExCancelShapeShiftingItem();
									break;
								case 0xCC:
									msg = new RequestShapeShiftingItem();
									break;
								case 0xCD:
									//msg = new NCGuardSendDataToServer(); // (chdb) TODO[K]
									break;
								case 0xCE:
									msg = new RequestUnionJoin(); // (chd)
									break;
								case 0xCF:
									msg = new RequestUnionChange(); // (chd)
									break;
								case 0xD0:
									msg = new RequestUnionWithdraw(); // (ch)
									break;
								case 0xD1:
									msg = new RequestUnionRequest(); // (chd)
									break;
								case 0xD2:
									msg = new RequestUnionAdjust(); // (ch)
									break;
								case 0xD3:
									msg = new RequestUnionSummon(); // (chd)
									break;
								case 0xD4:
									msg = new RequestUnionStart(); // (chd)
									break;
								case 0xD5:
									//msg = new RequestEventKalieToken(); // (ch)
									break;
								case 0xD6:
									msg = new RequestShowPledgeUnionInfo(); // (ch)
									break;
								case 0xD7:
									msg = new RequestShowBeautyList(); // (chd) TODO[K]
									break;
								case 0xD8:
									msg = new RequestRegistBeauty(); // (chddd) TODO[K]
									break;
								// 0xD0:0xD9 missed
								case 0xDA:
									msg = new RequestShowResetShopList(); // (ch) TODO[K]
									break;
								case 0xDB:
									//msg = new NetPing(); // (chd) TODO[K]
									break;
								case 0xDC:
									msg = new RequestBR_AddBasketProductInfo(); //chd
									break;
								case 0xDD:
									msg = new RequestBR_DeleteBasketProductInfo(); //chd
									break;
								case 0xDE:
									msg = new RequestBR_NewIConCashBtnWnd();
									break;
								case 0xDF:
									//msg = new RequestExEvent_Campaign_Info(); // (chcdd) TODO[K]
									break;
								case 0xE0:
									//msg = new RequestPledgeRecruitInfo(); // (chd) TODO[K]
									break;
								case 0xE1:
									//msg = new RequestPledgeRecruitBoardSearch(); // (chdddSddd) TODO[K]
									break;
								case 0xE2:
									//msg = new RequestPledgeRecruitBoardAccess(); // (chddSS) TODO[K]
									break;
								case 0xE3:
									//msg = new RequestPledgeRecruitBoardDetail(); // (chd) TODO[K]
									break;
								case 0xE4:
									//msg = new RequestPledgeWaitingApply(); // (chddS) TODO[K]
									break;
								case 0xE5:
									//msg = new RequestPledgeWaitingApplied(); // (ch) TODO[K]
									break;
								case 0xE6:
									//msg = new RequestPledgeWaitingList(); // (chd) TODO[K]
									break;
								case 0xE7:
									//msg = new RequestPledgeWaitingUser(); // (chdd) TODO[K]
									break;
								case 0xE8:
									//msg = new RequestPledgeWaitingUserAccept(); // (chddd) TODO[K]
									break;
								case 0xE9:
									//msg = new RequestPledgeDraftListSearch(); // (chdddSdd) TODO[K]
									break;
								case 0xEA:
									//msg = new RequestPledgeDraftListApply(); // (chdd) TODO[K]
									break;
								case 0xEB:
									//msg = new RequestPledgeRecruitApplyInfo(); // (ch) TODO[K]
									break;
								case 0xEC:
									//msg = new RequestPledgeJoinSys(); // (ch) TODO[K]
									break;
								case 0xED:
									//msg = new ResponsePetitionAlarm(); // (ch) TODO[K]
									break;
								case 0xEE:
									msg = new NotifyExitBeautyshop(); // (ch) TODO[K]
									break;
								case 0xEF:
									//msg = new RequestRegisterXMasWishCard(); // (chS) TODO[K]
									break;
								case 0xF0:
									//msg = new RequestExAddEnchantScrollItem(); // (chdd) TODO[K]
									break;
								case 0xF1:
									//msg = new RequestExRemoveEnchantSupportItem(); // (ch) TODO[K]
									break;
								case 0xF2:
									//msg = new RequestCardReward(); // (chd) TODO[K]
									break;



*/
